[ShaderDX] name=SharedVS version=930
#line 2
    #pragma pack_matrix ( row_major )
cbuffer params
{
    float4x4 modelToWorldTfm ;
    float4x4 worldToViewTfm ;
    float4x4 viewToClipTfm ;
    float4x4 worldToClipTfm ;
    float4x4 modelToClipTfm ;
    float debugCycles ;
}
struct Inputs
{
    float4 position : POSITION ;
}
;
struct Outputs
{
    float4 positiont : SV_Position ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    float4 pos = inputs . position ;
    pos = mul ( pos , modelToWorldTfm ) ;
    pos = mul ( pos , worldToViewTfm ) ;
    pos = mul ( pos , viewToClipTfm ) ;
    pos = mul ( pos , worldToClipTfm ) ;
    pos = mul ( pos , modelToClipTfm ) ;
    pos . x *= debugCycles ;
    outputs . positiont = pos ;
}
[ShaderDX] name=SharedPS version=930
#line 35
    #pragma pack_matrix ( row_major )
struct Inputs
{
    float4 positiont : SV_Position ;
}
;
struct Outputs
{
    float4 target0 : SV_Target0 ;
}
;
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = float4 ( 0 , 0 , 0 , 0 ) ;
}
[ShaderDX] name=ACR_VS version=930
#line 52
    #pragma pack_matrix ( row_major )
cbuffer params
{
    float4x4 worldToClipTfm ;
}
struct Inputs
{
    float3 position : POSITION ;
    float2 uv0 : TEXCOORD0 ;
    float4 color : COLOR ;
}
;
struct Outputs
{
    float4 positiont : SV_Position ;
    float2 uv0 : TEXCOORD0 ;
    float4 color : COLOR ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{

    {
        outputs . uv0 = inputs . uv0 ;
        outputs . color = inputs . color ;
        outputs . positiont = float4 ( inputs . position , 1.0 ) ;
        outputs . positiont = mul ( outputs . positiont , worldToClipTfm ) ;
    }
}
[ShaderDX] name=ACR_PS version=930
#line 83
    #pragma pack_matrix ( row_major )
cbuffer params
{
    float uBigTableCol0 ;
    float uBigTableCol1 ;
    float uBigTable_ToneCurve ;
    float uBigTable_ProfileVignette ;
    float uBigTable_ProfileDistortion ;
    float uBigTable_CurveRed ;
    float uBigTable_CurveGreen ;
    float uBigTable_CurveBlue ;
    float uBigTable_PostCropVignette ;
    float uBigTable_GrayMixer ;
    float uBigTable_UndoToneCurve ;
    float uBigTable_HSL ;
    float2 uDefaultCropSize ;
    float2 uStage3Size ;
    float2 uToDefaultCropScale ;
    float2 uToDefaultCropOffset ;
    float2 uNormalizeDistance ;
    float uRenderScale ;
    bool uHasUndoToneCurve ;
    bool uConvertToGray ;
    float uGrayMixerCoord0 ;
    float uGrayMixerCoord1 ;
    bool uHasVibranceHSL ;
    bool uHasHSL ;
    float uHSLCoord0 ;
    float uHSLCoord1 ;
    float uToneContrastSplit ;
    float uVibrance ;
    bool uHasWarp ;
    float3x3 uBackwardCropTransform ;
    bool uHasPerspective ;
    float uPerspectiveMinScale ;
    float uPerspectiveMaxScale ;
    float3x3 uPerspectiveMatrix ;
    bool uHasManualDistort ;
    float uManualDistortB ;
    bool uHasProfileWarp ;
    float2 uProfileWarpCenter ;
    float2 uProfileWarpToTable ;
    float2 uProfileWarpFromTable ;
    bool uHasLateralCA ;
    bool uHasLensVignette ;
    bool uHasLensManualVignette ;
    float uLensVignetteAmount ;
    float uLensVignetteMidpoint ;
    bool uHasLensProfileVignette ;
    float2 uVignetteProfileScale ;
    float2 uVignetteProfileOffset ;
    bool uHasPostCropVignetteHighlightPriority ;
    bool uHasPostCropVignetteColorPriority ;
    bool uHasPostCropVignettePaintOverlay ;
    float uPostCropVignetteAmount ;
    float uPostCropVignetteMidpoint ;
    float uPostCropVignetteFeather ;
    float uPostCropVignetteRoundness ;
    float uPostCropVignetteHighlightContrast ;
    float uPostCropVignetteEllipseA ;
    float uPostCropVignetteEllipseB ;
    float uPostCropVignetteEllipseC ;
    float uPostCropVignetteEllipseD ;
    float uPostCropVignetteEllipseE ;
    float3x3 uPostCropVignetteCropTransform ;
    float uPostCropVignetteCropAspectRatio ;
    bool uBlendStyleLensVignette ;
    bool uHasSplitTone ;
    float uSplitToneBalanceMapAlpha ;
    float3 uSplitToneShadowFactor ;
    float3 uSplitToneDeltaFactor ;
    bool uHasRGBCurves ;
    bool uDoTransparency ;
    bool uDoCheckerboard ;
    float uCheckerboardSize ;
    float2 uCheckerboardOrigin ;
    bool uFlattenTransparency ;
    bool uMultiplyTransparency ;
    float uMatteGrayLevel ;
    bool uOnlyPurelyTransparent ;
    float uParamExposure ;
    float3x3 uSaturationMatrix ;
}
uniform SamplerState uStage3ImageSampler ;
uniform Texture2D uStage3Image ;
uniform SamplerState uBigTableSampler ;
uniform Texture2D uBigTable ;
uniform SamplerState uLateralCAMapSampler ;
uniform Texture2D uLateralCAMap ;
struct Inputs
{
    float4 positiont : SV_Position ;
    float4 color : COLOR ;
    float2 uv0 : TEXCOORD0 ;
}
;
struct Outputs
{
    float4 target0 : SV_Target0 ;
}
;
float2 ToDefaultCrop ( float2 pt )
{
    return ( pt * uToDefaultCropScale ) + uToDefaultCropOffset ;
}
float2 FromDefaultCrop ( float2 pt )
{
    return ( pt - uToDefaultCropOffset ) / uToDefaultCropScale ;
}
float NormalizedSquaredDistanceFromCenter ( float2 pt )
{
    float2 diff = ( pt - float2 ( 0.5 , 0.5 ) ) * uNormalizeDistance ;
    return dot ( diff , diff ) ;
}
float NormalizedSquaredPinnedDistanceFromCenter ( float2 pt )
{
    return min ( NormalizedSquaredDistanceFromCenter ( pt ) , 1.0 ) ;
}
float4 BigTableLookup ( float index , float rowOffset , float coord0 , float coord1 )
{
    index = lerp ( coord0 , coord1 , index ) ;
    return uBigTable . Sample ( uBigTableSampler , float2 ( index , rowOffset ) ) ;
}
float4 BigTableLookup ( float index , float rowOffset )
{
    return BigTableLookup ( index , rowOffset , uBigTableCol0 , uBigTableCol1 ) ;
}
float sRGB_Evaluate ( float x )
{
    if ( x <= 0.0031308 ) return x * 12.92 ;
    else return 1.055 * pow ( x , 1.0 / 2.4 ) - 0.055 ;
}
float3 sRGB_Evaluate ( float3 x )
{
    return float3 ( sRGB_Evaluate ( x . r ) , sRGB_Evaluate ( x . g ) , sRGB_Evaluate ( x . b ) ) ;
}
float sRGB_EvaluateInverse ( float y )
{
    if ( y <= 0.0031308 * 12.92 ) return y * ( 1.0 / 12.92 ) ;
    else return pow ( ( y + 0.055 ) * ( 1.0 / 1.055 ) , 2.4 ) ;
}
float3 sRGB_EvaluateInverse ( float3 x )
{
    return float3 ( sRGB_EvaluateInverse ( x . r ) , sRGB_EvaluateInverse ( x . g ) , sRGB_EvaluateInverse ( x . b ) ) ;
}
float3 RGBtoHSV ( float3 src )
{
    float h , s , v ;
    v = max ( src . r , max ( src . g , src . b ) ) ;
    float gap = v - min ( src . r , min ( src . g , src . b ) ) ;
    if ( gap > 0.0 )
    {
        if ( src . r == v )
        {
            h = ( src . g - src . b ) / gap ;
            if ( h < 0.0 )
            {
                h += 6.0 ;
            }
        }
        else if ( src . g == v )
        {
            h = 2.0 + ( src . b - src . r ) / gap ;
        }
        else
        {
            h = 4.0 + ( src . r - src . g ) / gap ;
        }
        s = gap / v ;
    }
    else
    {
        h = 0.0 ;
        s = 0.0 ;
    }
    return float3 ( h , s , v ) ;
}
float3 HSVtoRGB ( float3 hsv )
{
    float r , g , b ;
    float h = hsv . x ;
    float s = hsv . y ;
    float v = hsv . z ;
    if ( s > 0.0 )
    {
        if ( h < 0.0 ) h += 6.0 ;
        if ( h >= 6.0 ) h -= 6.0 ;
        float i = floor ( h ) ;
        float f = h - i ;
        float p = v * ( 1.0 - s ) ;
        float q = v * ( 1.0 - s * f ) ;
        float t = ( v * ( 1.0 - s * ( 1.0 - f ) ) ) ;
        if ( i == 0.0 )
        {
            r = v ;
            g = t ;
            b = p ;
        }
        else if ( i == 1.0 )
        {
            r = q ;
            g = v ;
            b = p ;
        }
        else if ( i == 2.0 )
        {
            r = p ;
            g = v ;
            b = t ;
        }
        else if ( i == 3.0 )
        {
            r = p ;
            g = q ;
            b = v ;
        }
        else if ( i == 4.0 )
        {
            r = t ;
            g = p ;
            b = v ;
        }
        else
        {
            r = v ;
            g = p ;
            b = q ;
        }
    }
    else
    {
        r = v ;
        g = v ;
        b = v ;
    }
    return float3 ( r , g , b ) ;
}
float3 DoSaturation ( float3 rgb )
{
    return saturate ( uSaturationMatrix * rgb ) ;
}
float3 DoRGBtoMMH ( float3 rgb )
{
    float r = rgb . r ;
    float g = rgb . g ;
    float b = rgb . b ;
    bool mirror0 = ( b > g ) ;
    if ( mirror0 )
    {
        float temp = g ;
        g = b ;
        b = temp ;
    }
    bool mirror1 = ( b > r ) ;
    if ( mirror1 )
    {
        float temp = r ;
        r = b ;
        b = temp ;
    }
    bool mirror2 = ( g > r ) ;
    if ( mirror2 )
    {
        float temp = g ;
        g = r ;
        r = temp ;
    }
    float hue ;
    if ( r == b )
    {
        hue = 0.0 ;
    }
    else
    {
        hue = ( g - b ) / ( r - b ) ;
    }
    if ( mirror2 )
    {
        hue = 2.0 - hue ;
    }
    if ( mirror1 )
    {
        hue = 4.0 - hue ;
    }
    if ( mirror0 )
    {
        hue = 6.0 - hue ;
    }
    return float3 ( b , r , hue ) ;
}
float3 DoMMHtoRGB ( float3 mmh )
{
    float hue = mmh . z ;
    float r = mmh . y ;
    float b = mmh . x ;
    if ( hue > 6.0 )
    {
        hue -= 6.0 ;
    }
    if ( hue > 6.0 )
    {
        hue -= 6.0 ;
    }
    bool mirror0 = ( hue > 3.0 ) ;
    if ( mirror0 )
    {
        hue = 6.0 - hue ;
    }
    bool mirror1 = ( hue > 2.0 ) ;
    if ( mirror1 )
    {
        hue = 4.0 - hue ;
    }
    bool mirror2 = ( hue > 1.0 ) ;
    if ( mirror2 )
    {
        hue = 2.0 - hue ;
    }
    float g = b + ( r - b ) * hue ;
    if ( mirror2 )
    {
        float temp = g ;
        g = r ;
        r = temp ;
    }
    if ( mirror1 )
    {
        float temp = r ;
        r = b ;
        b = temp ;
    }
    if ( mirror0 )
    {
        float temp = g ;
        g = b ;
        b = temp ;
    }
    return float3 ( r , g , b ) ;
}
const float kMinSkinHue = - 60.0 ;
const float kMinCentralSkinHue = 0.0 ;
const float kMaxCentralSkinHue = 30.0 ;
const float kMaxSkinHue = 45.0 ;
const float kMinScaledSkinHue = ( kMinSkinHue + 60.0 ) / 60.0 ;
const float kMinScaledCentralSkinHue = ( kMinCentralSkinHue + 60.0 ) / 60.0 ;
const float kMaxScaledCentralSkinHue = ( kMaxCentralSkinHue + 60.0 ) / 60.0 ;
const float kMaxScaledSkinHue = ( kMaxSkinHue + 60.0 ) / 60.0 ;
const float kMinSideFalloff = 1.0 / ( kMinScaledCentralSkinHue - kMinScaledSkinHue ) ;
const float kMaxSideFalloff = 1.0 / ( kMaxScaledSkinHue - kMaxScaledCentralSkinHue ) ;
float3 DoIncreaseVibrance ( float3 minMaxHue , float vibranceShift )
{
    const float kMaxSaturationGain = 6.0 ;
    const float kMaxSkinSaturationGain = 1.75 ;
    const float kStandardFactor = 1.0 - ( 1.0 / kMaxSaturationGain ) ;
    const float kSkinFactor = 1.0 - ( 1.0 / kMaxSkinSaturationGain ) ;
    const float kSkinProtectionSlope = kSkinFactor - kStandardFactor ;
    float minValue = minMaxHue . x ;
    float maxValue = minMaxHue . y ;
    float gap = maxValue - minValue ;
    if ( gap == 0.0 )
    {
        return minMaxHue ;
    }
    float saturation = gap / maxValue ;
    float shiftFactor = vibranceShift ;
    float hue = minMaxHue . z ;
    float shiftedHue = hue + 1.0 ;
    if ( 6.0 <= shiftedHue ) shiftedHue -= 6.0 ;
    float minSide = saturate ( 1.0 - ( kMinScaledCentralSkinHue - shiftedHue ) * kMinSideFalloff ) ;
    float maxSide = saturate ( 1.0 - ( shiftedHue - kMaxScaledCentralSkinHue ) * kMaxSideFalloff ) ;
    float protection = min ( minSide , maxSide ) ;
    protection *= ( 1.0 - saturation * saturation ) ;
    shiftFactor = shiftFactor * ( shiftFactor * protection + 1.0 - protection ) ;
    float saturationFactor = kStandardFactor + kSkinProtectionSlope * protection ;
    saturationFactor *= shiftFactor ;
    saturationFactor *= 1.0 - minValue ;
    float shadowRolloff = min ( 1.0 , 16.0 * maxValue ) ;
    shadowRolloff *= 2.0 - shadowRolloff ;
    saturationFactor *= shadowRolloff ;
    float saturationMask = saturation * ( 1.0 - saturation ) ;
    saturationMask *= 2.0 - saturationMask ;
    float brightnessFactor = shiftFactor * shadowRolloff * saturationMask ;
    saturation = saturation / ( 1.0 - saturationFactor * ( 1.0 - saturation ) ) ;
    maxValue *= 1.0 + 0.25 * brightnessFactor * ( 1.0 - maxValue ) ;
    minValue = maxValue - saturation * maxValue ;
    return float3 ( minValue , maxValue , hue ) ;
}
float3 DoDecreaseVibrance ( float3 minMaxHue , float vibranceShift )
{
    float minValue = minMaxHue . x ;
    float maxValue = minMaxHue . y ;
    float gap = maxValue - minValue ;
    if ( gap == 0.0 )
    {
        return minMaxHue ;
    }
    float saturation = gap / maxValue ;
    float saturationFactor = - vibranceShift ;
    float shadowRolloff = min ( 1.0 , 16.0 * maxValue ) ;
    shadowRolloff *= 2.0 - shadowRolloff ;
    float saturationMask = saturation * ( 1.0 - saturation ) ;
    saturationMask *= 2.0 - saturationMask ;
    float brightnessFactor = - vibranceShift * shadowRolloff * saturationMask ;
    saturation *= 1.0 - saturationFactor + saturationFactor * saturation * ( 0.5 + 0.5 * saturation ) * shadowRolloff ;
    saturation *= 1.0 - 0.25 * saturationFactor ;
    maxValue *= 1.0 - brightnessFactor * ( 1.0 - maxValue ) ;
    minValue = maxValue - saturation * maxValue ;
    return float3 ( minValue , maxValue , minMaxHue . z ) ;
}
float3 DoVibrance ( float3 rgb )
{
    if ( uVibrance > 0.0 )
    {
        rgb = DoIncreaseVibrance ( rgb , uVibrance ) ;
    }
    else if ( uVibrance < 0.0 )
    {
        rgb = DoDecreaseVibrance ( rgb , uVibrance ) ;
    }
    return rgb ;
}
float ContrastBump ( float lum )
{
    float contrastBump ;
    if ( lum <= 0.5 )
    {
        float f = ( lum - 0.25 ) * 4.0 ;
        contrastBump = f * f - 1.0 ;
    }
    else
    {
        float f = ( lum - 0.75 ) * 4.0 ;
        contrastBump = 1.0 - f * f ;
    }
    contrastBump *= 0.125 ;
    return contrastBump ;
}
float DodgeBurnSlope ( float x )
{
    return pow ( 2.0 , x * 4.0 ) ;
}
float ShiftBrightnessAndContrast ( float lum , float brightnessShift , float contrastShift , float contrastSplitSlope , float invContrastSplitSlope )
{
    float dbSlope = DodgeBurnSlope ( brightnessShift ) ;
    if ( contrastShift == 0.0 )
    {
        float lum_db = dbSlope * lum ;
        lum = lum_db / ( 1.0 + lum_db - lum ) ;
    }
    else
    {
        float slope1 = dbSlope * contrastSplitSlope ;
        float slope2 = invContrastSplitSlope ;
        float lum_scaled_1 = slope1 * lum ;
        lum = lum_scaled_1 / ( 1.0 + lum_scaled_1 - lum ) ;
        float contrastSlope = pow ( 2.0 , 0.75 * contrastShift ) ;
        float contrastBump = ContrastBump ( lum ) ;
        if ( 1.0 <= contrastSlope )
        {
            lum += contrastBump * min ( 0.5 , contrastSlope - 1.0 ) ;
            contrastSlope = max ( 1.0 , contrastSlope * 0.6666666667 ) ;
        }
        else
        {
            lum += contrastBump * max ( - 0.5 , contrastSlope - 1.0 ) ;
            contrastSlope = min ( 1.0 , contrastSlope * 2.0 ) ;
        }
        if ( contrastSlope != 1.0 )
        {
            float lum_expanded = 2.0 * lum - 1.0 ;
            float lum_expanded_scaled = lum_expanded * contrastSlope ;
            float lum_expanded_scaled_b = lum_expanded_scaled / ( 1.0 + ( contrastSlope - 1.0 ) * abs ( lum_expanded ) ) ;
            lum = 0.5 + 0.5 * lum_expanded_scaled_b ;
        }
        float lum_scaled_2 = slope2 * lum ;
        lum = lum_scaled_2 / ( 1.0 + lum_scaled_2 - lum ) ;
    }
    return lum ;
}
float3 DoTuneHSLMasked32 ( float3 minMaxHue , float lMask , float cMask , float sMask )
{
    float contrastSplit = uToneContrastSplit ;
    const float kMaxSaturationGain = 6.0 ;
    const float kBaseSaturationFactor = 1.0 - ( 1.0 / kMaxSaturationGain ) ;
    const float tableScale = ( 1.0 / 6.0 ) ;
    float contrastSplitSlope = ( 1.0 - contrastSplit ) / contrastSplit ;
    float invContrastSplitSlope = contrastSplit / ( 1.0 - contrastSplit ) ;
    const float kExponentialSaturationFactor = 2.5 ;
    float minValue = minMaxHue . x ;
    float maxValue = minMaxHue . y ;
    float hue = minMaxHue . z ;
    float newHue = hue ;
    float initialGap = maxValue - minValue ;
    float maskBrightnessShift = lMask ;
    float maskContrastShift = cMask ;
    float maskSaturationShift = sMask ;
    bool doMaskBrightnessShift = maskBrightnessShift != 0.0 ;
    bool doMaskContrastShift = maskContrastShift != 0.0 ;
    bool doMaskBrightnessContrastShift = doMaskBrightnessShift || doMaskContrastShift ;
    float hslSaturationShift = 0.0 ;
    if ( initialGap != 0.0 )
    {
        float index = hue * tableScale ;
        float3 hslLookup = BigTableLookup ( index , uBigTable_HSL , uHSLCoord0 , uHSLCoord1 ) . rgb ;
        newHue = hslLookup . x ;
        hslSaturationShift = hslLookup . y ;
        float hslLuminanceShift = hslLookup . z ;
        if ( hslLuminanceShift != 0.0 )
        {
            float gap2 = initialGap * ( 2.0 - initialGap ) ;
            float gap4 = gap2 * ( 2.0 - gap2 ) ;
            float gap8 = gap4 * ( 2.0 - gap4 ) ;
            hslLuminanceShift *= gap8 ;
            minValue = minValue * ( 1.0 + hslLuminanceShift * ( 1.0 - minValue ) ) ;
            maxValue = maxValue * ( 1.0 + hslLuminanceShift * ( 1.0 - maxValue ) ) ;
            minValue = minValue * ( 1.0 + hslLuminanceShift * ( 1.0 - minValue ) ) ;
            maxValue = maxValue * ( 1.0 + hslLuminanceShift * ( 1.0 - maxValue ) ) ;
        }
    }
    if ( doMaskBrightnessContrastShift )
    {
        minValue = ShiftBrightnessAndContrast ( minValue , maskBrightnessShift , maskContrastShift , contrastSplitSlope , invContrastSplitSlope ) ;
        maxValue = ShiftBrightnessAndContrast ( maxValue , maskBrightnessShift , maskContrastShift , contrastSplitSlope , invContrastSplitSlope ) ;
    }
    if ( minValue < maxValue )
    {
        float saturationShift = hslSaturationShift + maskSaturationShift ;
        if ( saturationShift < 0.0 )
        {
            saturationShift = max ( - 1.0 , saturationShift ) ;
            float L = 0.5 * ( maxValue + minValue ) ;
            minValue += saturationShift * ( minValue - L ) ;
            maxValue += saturationShift * ( maxValue - L ) ;
        }
        else if ( 0.0 < saturationShift )
        {
            float gap = maxValue - minValue ;
            float saturation = gap / maxValue ;
            float shiftedHue = hue + 1.0 ;
            if ( 6.0 <= shiftedHue ) shiftedHue -= 6.0 ;
            float minSide = clamp ( 1.0 - ( kMinScaledCentralSkinHue - shiftedHue ) * kMinSideFalloff , 0.0 , 1.0 ) ;
            float maxSide = clamp ( 1.0 - ( shiftedHue - kMaxScaledCentralSkinHue ) * kMaxSideFalloff , 0.0 , 1.0 ) ;
            float protection = min ( minSide , maxSide ) ;
            protection *= ( 1.0 - saturation * saturation ) ;
            float availableForProtection = clamp ( maskSaturationShift , 0.0 , saturationShift ) ;
            saturationShift -= 0.5 * availableForProtection * protection ;
            saturationShift *= 1.0 - minValue ;
            float shadowRolloff = min ( 1.0 , 16.0 * maxValue ) ;
            shadowRolloff *= 2.0 - shadowRolloff ;
            saturationShift *= shadowRolloff ;
            if ( saturationShift <= 1.0 )
            {
                float saturationFactor = kBaseSaturationFactor * saturationShift ;
                saturation = saturation / ( 1.0 - saturationFactor * ( 1.0 - saturation ) ) ;
            }
            else
            {
                float saturationFactor = 6.0 * pow ( 2.0 , kExponentialSaturationFactor * ( saturationShift - 1.0 ) ) ;
                float scaledSaturation = saturationFactor * saturation ;
                saturation = scaledSaturation / ( 1.0 + scaledSaturation - saturation ) ;
            }
            minValue = maxValue - saturation * maxValue ;
        }
    }
    minMaxHue . x = minValue ;
    minMaxHue . y = maxValue ;
    minMaxHue . z = newHue ;
    return minMaxHue ;
}
float3 DoVibranceHSL ( float3 rgb )
{
    float3 mmh = DoRGBtoMMH ( rgb ) ;
    mmh = DoVibrance ( mmh ) ;
    if ( uHasHSL )
    {
        float localLuminanceMask = 0.0 ;
        float localContrastMask = 0.0 ;
        float localSatMask = 0.0 ;
        mmh = DoTuneHSLMasked32 ( mmh , localLuminanceMask , localContrastMask , localSatMask ) ;
    }
    rgb = DoMMHtoRGB ( mmh ) ;
    return rgb ;
}
float3 DoColorPath ( float3 rgb )
{
    rgb = DoSaturation ( rgb ) ;
    if ( uHasVibranceHSL )
    {
        rgb = DoVibranceHSL ( rgb ) ;
    }
    return rgb ;
}
float3 DoGrayMixer ( float3 rgb )
{
    float tableScale = ( 1.0 / 6.0 ) ;
    float r = rgb . r ;
    float g = rgb . g ;
    float b = rgb . b ;
    float minValue , maxValue , hue ;
    bool mirror0 = ( b > g ) ;
    if ( mirror0 )
    {
        float temp = g ;
        g = b ;
        b = temp ;
    }
    bool mirror1 = ( b > r ) ;
    if ( mirror1 )
    {
        float temp = r ;
        r = b ;
        b = temp ;
    }
    bool mirror2 = ( g > r ) ;
    if ( mirror2 )
    {
        float temp = g ;
        g = r ;
        r = temp ;
    }
    if ( r == b )
    {
        return float3 ( b ) ;
    }
    else
    {
        hue = ( g - b ) / ( r - b ) ;
    }
    if ( mirror2 )
    {
        hue = 2.0 - hue ;
    }
    if ( mirror1 )
    {
        hue = 4.0 - hue ;
    }
    if ( mirror0 )
    {
        hue = 6.0 - hue ;
    }
    minValue = b ;
    maxValue = r ;
    hue = hue ;
    float gap = maxValue - minValue ;
    float tableIndex = hue * tableScale ;
    tableIndex = saturate ( tableIndex ) ;
    float gray = BigTableLookup ( tableIndex , uBigTable_GrayMixer , uGrayMixerCoord0 , uGrayMixerCoord1 ) . x ;
    float result ;
    if ( gray < 0.0 )
    {
        float minT ;
        if ( 9.0 * minValue < 1.0 ) minT = ( 3.0 * minValue ) / ( 0.25 + 6.75 * minValue ) ;
        else minT = 0.25 + 0.75 * minValue ;
        float maxT ;
        if ( 9.0 * maxValue < 1.0 ) maxT = ( 3.0 * maxValue ) / ( 0.25 + 6.75 * maxValue ) ;
        else maxT = 0.25 + 0.75 * maxValue ;
        float resultT = saturate ( minT + gray * ( maxT - minT ) ) ;
        if ( 3.0 * resultT < 1.0 ) result = resultT / ( 12.0 - 27.0 * resultT ) ;
        else result = ( resultT - 0.25 ) / 0.75 ;
    }
    else
    {
        result = minValue + gray * gap ;
    }
    result = saturate ( result ) ;
    return float3 ( result ) ;
}
float3 DoGrayPath ( float3 rgb )
{
    rgb = DoGrayMixer ( rgb ) ;
    return rgb ;
}
float3 DoColorGray ( float3 rgb )
{
    if ( uConvertToGray )
    {
        rgb = DoGrayPath ( rgb ) ;
    }
    else
    {
        rgb = DoColorPath ( rgb ) ;
    }
    return rgb ;
}
float3 RGBTone ( float3 rgb , float tableIndex )
{
    float rr = BigTableLookup ( rgb . r , tableIndex ) . r ;
    float bb = BigTableLookup ( rgb . b , tableIndex ) . r ;
    float gg = bb + ( ( rr - bb ) * ( rgb . g - rgb . b ) / ( rgb . r - rgb . b ) ) ;
    return float3 ( rr , gg , bb ) ;
}
float3 DoToneCurve ( float3 rgb , float tableIndex )
{
    float r = rgb . r ;
    float g = rgb . g ;
    float b = rgb . b ;
    float3 result ;
    if ( r >= g )
    {
        if ( g > b )
        {
            result = RGBTone ( rgb , tableIndex ) . rgb ;
        }
        else if ( b > r )
        {
            result = RGBTone ( float3 ( b , r , g ) , tableIndex ) . gbr ;
        }
        else if ( b > g )
        {
            result = RGBTone ( float3 ( r , b , g ) , tableIndex ) . rbg ;
        }
        else
        {
            float gg = BigTableLookup ( g , tableIndex ) . r ;
            result = float3 ( BigTableLookup ( r , tableIndex ) . r , gg , gg ) ;
        }
    }
    else
    {
        if ( r >= b )
        {
            result = RGBTone ( float3 ( g , r , b ) , tableIndex ) . grb ;
        }
        else if ( b > g )
        {
            result = RGBTone ( float3 ( b , g , r ) , tableIndex ) . bgr ;
        }
        else
        {
            result = RGBTone ( float3 ( g , b , r ) , tableIndex ) . brg ;
        }
    }
    return result ;
}
float3 DoToneCurve ( float3 rgb )
{
    return DoToneCurve ( rgb , uBigTable_ToneCurve ) ;
}
float3 UndoToneCurve ( float3 rgb )
{
    return DoToneCurve ( rgb , uBigTable_UndoToneCurve ) ;
}
float3 DoRGBCurves ( float3 rgb )
{
    return float3 ( BigTableLookup ( rgb . r , uBigTable_CurveRed ) . x , BigTableLookup ( rgb . g , uBigTable_CurveGreen ) . x , BigTableLookup ( rgb . b , uBigTable_CurveBlue ) . x ) ;
}
float3 DivMapEvaluate ( float3 x , float alpha )
{
    float3 scaled = float3 ( alpha ) * x ;
    return scaled / ( float3 ( 1.0 ) + scaled - x ) ;
}
float3 DivMapEvaluateInverse ( float3 y , float alpha )
{
    float3 scaled = y / float3 ( alpha ) ;
    return scaled / ( float3 ( 1.0 ) + scaled - y ) ;
}
float3 DoSplitTone ( float3 rgb )
{
    float3 y = rgb ;
    y = DivMapEvaluate ( y , uSplitToneBalanceMapAlpha ) ;
    y = y * ( ( float3 ( 1.0 ) - y ) * ( uSplitToneShadowFactor + uSplitToneDeltaFactor * y ) + y * y ) ;
    return DivMapEvaluateInverse ( y , uSplitToneBalanceMapAlpha ) ;
}
float DoProfileLensVignette ( float2 pt )
{
    float2 dxdy = pt * uVignetteProfileScale + uVignetteProfileOffset ;
    float rr = dot ( dxdy , dxdy ) ;
    return BigTableLookup ( rr , uBigTable_ProfileVignette ) . x ;
}
float DoManualLensVignette ( float rr , float amount , float midpoint , float amountScale )
{
    float power = 1.0 + 4.0 * midpoint ;
    float scale = pow ( 2.0 , abs ( amount ) * amountScale ) - 1.0 ;
    float y = 1.0 + scale * pow ( rr , power ) ;
    if ( amount < 0.0 )
    {
        y = 1.0 / y ;
    }
    return y ;
}
float DoManualLensVignette ( float rr )
{
    return DoManualLensVignette ( rr , uLensVignetteAmount , uLensVignetteMidpoint , 2.0 ) ;
}
float3 DoLensVignette ( float3 image , float2 pt )
{
    float scale = 1.0 ;
    if ( uHasLensManualVignette )
    {
        float rr = NormalizedSquaredPinnedDistanceFromCenter ( pt ) ;
        scale *= DoManualLensVignette ( rr ) ;
    }
    if ( uHasLensProfileVignette )
    {
        scale *= DoProfileLensVignette ( pt ) ;
    }
    scale = max ( scale , 0.0 ) ;
    return saturate ( image * scale ) ;
}
float PowerScreen ( float x , float s )
{
    if ( x <= 0.0 )
    {
        return pow ( 1.0 + x , s ) - 1.0 ;
    }
    else
    {
        return 1.0 - pow ( 1.0 - x , s ) ;
    }
}
float DoPostCropVignette ( float x , float amount )
{
    float fMidpoint = uPostCropVignetteMidpoint ;
    float fFeather = uPostCropVignetteFeather ;
    float resultLensVignette = 0.0 ;
    if ( uBlendStyleLensVignette && ( amount < 0.0 ) )
    {
        resultLensVignette = DoManualLensVignette ( x , amount , fMidpoint , 5.0 ) ;
    }
    float feather = uPostCropVignetteFeather ;
    feather = 1.5 * feather / ( 1.0 + 0.5 * feather ) ;
    const float kMaxSlope = 8.0 ;
    float fs = 1.0 / ( feather + ( 1.0 - feather ) / kMaxSlope ) ;
    fs = fs * fs ;
    float target = sqrt ( 0.5 ) + ( 2.0 * fMidpoint - 1.0 ) * ( sqrt ( 0.5 ) - sqrt ( 0.20 ) ) * ( 0.75 + 0.25 * fMidpoint ) ;
    target = target * target ;
    float ts = ( 1.0 - target ) / target ;
    x = ts * x / ( 1.0 + ( ts - 1.0 ) * x ) ;
    x = 2.0 * x - 1.0 ;
    x = PowerScreen ( x , fs ) ;
    x = 0.5 * ( x + 1.0 ) ;
    float finalResult ;
    if ( amount < 0.0 )
    {
        float blended_sRGB = 1.0 - x ;
        float blended_linear = sRGB_EvaluateInverse ( blended_sRGB ) ;
        float scaled_sRGB = 1.0 + amount ;
        float scaled_linear = sRGB_EvaluateInverse ( scaled_sRGB ) ;
        float result = 1.0 - ( 1.0 - scaled_linear ) * ( 1.0 - blended_linear ) ;
        if ( ! uBlendStyleLensVignette )
        {
            return result ;
        }
        float lerpFactor = sRGB_EvaluateInverse ( fFeather ) ;
        finalResult = lerp ( result , resultLensVignette , lerpFactor ) ;
    }
    else
    {
        float blended_sRGB = x ;
        float blended_linear = sRGB_EvaluateInverse ( blended_sRGB ) ;
        float scaled_sRGB = amount ;
        float scaled_linear = sRGB_EvaluateInverse ( scaled_sRGB ) ;
        finalResult = 1.0 - scaled_linear * blended_linear ;
    }
    return finalResult ;
}
float RefEllipseMask32 ( float2 pt )
{
    float x = ( pt . y * uDefaultCropSize . y ) + uPostCropVignetteEllipseD ;
    float Axx = uPostCropVignetteEllipseA * x * x ;
    float Bx = uPostCropVignetteEllipseB * x ;
    float y = pt . x * uDefaultCropSize . x + uPostCropVignetteEllipseE ;
    float r2 = Axx + ( Bx + uPostCropVignetteEllipseC * y ) * y ;
    float z = BigTableLookup ( r2 , uBigTable_PostCropVignette ) . x ;
    return z ;
}
float RefRoundedRectMask32 ( float2 pt )
{
    float flatX = 0.0 ;
    float flatY = 0.0 ;
    float croppedAspectRatio = uPostCropVignetteCropAspectRatio ;
    float roundness = uPostCropVignetteRoundness ;
    if ( croppedAspectRatio >= 1.0 )
    {
        flatX = 0.45 * ( - roundness ) ;
        flatY = max ( 0.0 , 0.5 - ( ( 0.5 - flatX ) * croppedAspectRatio ) ) ;
    }
    else
    {
        flatY = 0.45 * ( - roundness ) ;
        flatX = max ( 0.0 , 0.5 - ( ( 0.5 - flatY ) / croppedAspectRatio ) ) ;
    }
    float scaleX = 0.5 / ( 0.5 - flatX ) ;
    float scaleY = 0.5 / ( 0.5 - flatY ) ;
    pt . x *= uDefaultCropSize . x ;
    pt . y *= uDefaultCropSize . y ;
    pt = ( uPostCropVignetteCropTransform * float3 ( pt . yx , 1.0 ) ) . yx ;
    float x = abs ( pt . x - 0.5 ) ;
    float y = abs ( pt . y - 0.5 ) ;
    x = max ( x - flatX , 0.0 ) * scaleX ;
    y = max ( y - flatY , 0.0 ) * scaleY ;
    float r2 = ( x * x + y * y ) * 2.0 ;
    float z = BigTableLookup ( r2 , uBigTable_PostCropVignette ) . x ;
    return z ;
}
float DoPostCropVignette ( float2 pt )
{
    if ( uPostCropVignetteRoundness >= 0.0 )
    {
        return RefEllipseMask32 ( pt ) ;
    }
    else
    {
        return RefRoundedRectMask32 ( pt ) ;
    }
}
float3 DoDarkPostCropVignette ( float3 image , float2 pt )
{
    float m = DoPostCropVignette ( pt ) ;
    float scale = m ;
    if ( uPostCropVignetteHighlightContrast > 0.0 && ! uHasPostCropVignettePaintOverlay )
    {
        float maxScale = lerp ( m , 1.0 , uPostCropVignetteHighlightContrast ) ;
        const float kHLThresh = 0.18 ;
        const float kHLScale = 1.0 / ( 1.0 - kHLThresh ) ;
        const float kHLOffset = - kHLThresh * kHLScale ;
        float3 hsv = RGBtoHSV ( image ) ;
        float v = hsv . z ;
        float t = saturate ( ( v * kHLScale ) + kHLOffset ) ;
        scale = lerp ( m , maxScale , t ) ;
        hsv . z = v * scale ;
        image = HSVtoRGB ( hsv ) ;
        return image ;
    }
    return image * scale ;
}
float3 DoWhitePostCropVignette ( float3 image , float2 pt )
{
    float m = DoPostCropVignette ( pt ) ;
    return float3 ( 1.0 ) - saturate ( ( float3 ( 1.0 ) - image ) ) * m ;
}
float3 DoPostCropVignette ( float3 image , float2 pt )
{
    pt = ToDefaultCrop ( pt ) ;
    if ( uPostCropVignetteAmount < 0.0 )
    {
        image = DoDarkPostCropVignette ( image , pt ) ;
    }
    else
    {
        image = DoWhitePostCropVignette ( image , pt ) ;
    }
    return image ;
}
float2 DoPerspective ( float2 pt )
{
    float3 xyh = uPerspectiveMatrix * float3 ( pt , 1.0 ) ;
    xyh . z = clamp ( xyh . z , uPerspectiveMinScale , uPerspectiveMaxScale ) ;
    pt = xyh . xy / xyh . z ;
    return pt ;
}
float2 DoDistort ( float2 pt , float radiusScale )
{
    const float2 center = float2 ( 0.5 , 0.5 ) ;
    return center + ( radiusScale * ( pt - center ) ) ;
}
float2 DoManualDistort ( float2 pt )
{
    float2 ptDefaultCrop = ToDefaultCrop ( pt ) ;
    float rr = NormalizedSquaredPinnedDistanceFromCenter ( ptDefaultCrop ) ;
    float scale = ( 1.0 - uManualDistortB ) + uManualDistortB * rr ;
    pt = DoDistort ( pt , scale ) ;
    return pt ;
}
float2 DoProfileDistort ( float2 pt )
{
    float2 diff = ( pt - uProfileWarpCenter ) * uProfileWarpToTable ;
    float rr = dot ( diff , diff ) ;
    float r = sqrt ( rr ) ;
    float2 ratio = BigTableLookup ( r , uBigTable_ProfileDistortion ) . xx ;
    diff = diff * ratio ;
    return uProfileWarpCenter + ( diff * uProfileWarpFromTable ) ;
}
float DoWarpMask ( float2 srcPt )
{
    const float2 kPixelOffset = float2 ( 0.5 , 0.5 ) ;
    float2 size = uDefaultCropSize * uRenderScale ;
    float2 ptPixels = ToDefaultCrop ( srcPt ) * size ;
    float2 clipTL = kPixelOffset ;
    float2 clipBR = size - kPixelOffset ;
    float alpha = ( saturate ( 1.0 - max ( clipTL . x - ptPixels . x , ptPixels . x - clipBR . x ) ) * saturate ( 1.0 - max ( clipTL . y - ptPixels . y , ptPixels . y - clipBR . y ) ) ) ;
    return alpha ;
}
float4 DoTransparency ( float4 image , float2 srcPt , float2 dstPt )
{
    image . a *= DoWarpMask ( srcPt ) ;
    if ( uOnlyPurelyTransparent && ( image . a > 0.0 ) )
    {
        image . a = 1.0 ;
    }
    if ( uFlattenTransparency )
    {
        float matteValue = uMatteGrayLevel ;
        if ( uDoCheckerboard )
        {
            float2 rounded = mod ( floor ( dstPt * uStage3Size ) - uCheckerboardOrigin , float2 ( uCheckerboardSize , uCheckerboardSize ) ) ;
            float checkerThresh = uCheckerboardSize * 0.5 - 0.5 ;
            bool test1 = ( rounded . x < checkerThresh ) ;
            bool test2 = ( rounded . y < checkerThresh ) ;
            const float kDarkCheck = 0.625 ;
            matteValue = lerp ( matteValue , kDarkCheck , test1 != test2 ) ;
        }
        image . rgb = lerp ( float3 ( matteValue ) , image . rgb , float3 ( image . a ) ) ;
        image . a = 1.0 ;
    }
    if ( uMultiplyTransparency )
    {
        image . rgb *= image . a ;
    }
    return image ;
}
void DoLateralCA ( float2 pt , out float2 ptR , out float2 ptB )
{
    pt = ToDefaultCrop ( pt ) ;
    float4 offset = uLateralCAMap . Sample ( uLateralCAMapSampler , pt ) ;
    ptR = pt + offset . xy ;
    ptB = pt + offset . zw ;
    ptR = FromDefaultCrop ( ptR ) ;
    ptB = FromDefaultCrop ( ptB ) ;
}
float4 GetStage3 ( float2 dstPt , out float2 srcPt , out float2 srcPtCrop )
{
    float2 pt = dstPt ;
    pt = ( uBackwardCropTransform * float3 ( pt . yx , 1.0 ) ) . yx ;
    srcPtCrop = pt ;
    if ( ! uHasWarp )
    {
        srcPt = pt ;
        return uStage3Image . Sample ( uStage3ImageSampler , pt ) ;
    }
    if ( uHasPerspective )
    {
        pt = DoPerspective ( pt ) ;
    }
    if ( uHasManualDistort )
    {
        pt = DoManualDistort ( pt ) ;
    }
    if ( uHasProfileWarp )
    {
        pt = DoProfileDistort ( pt ) ;
    }
    float2 ptR = pt ;
    float2 ptB = pt ;
    float4 stage3 ;
    if ( uHasLateralCA )
    {
        DoLateralCA ( pt , ptR , ptB ) ;
        float4 stage3base = uStage3Image . Sample ( uStage3ImageSampler , pt ) ;
        stage3 = float4 ( uStage3Image . Sample ( uStage3ImageSampler , ptR ) . r , stage3base . g , uStage3Image . Sample ( uStage3ImageSampler , ptB ) . b , stage3base . a ) ;
    }
    else
    {
        stage3 = uStage3Image . Sample ( uStage3ImageSampler , pt ) ;
    }
    srcPt = pt ;
    return stage3 ;
}
float4 Process2012 ( float2 dstPt )
{
    float2 srcPt ;
    float2 srcPtCrop ;
    float4 stage3 = GetStage3 ( dstPt , srcPt , srcPtCrop ) ;
    float3 result = stage3 . rgb ;
    float alpha = stage3 . a ;
    if ( uHasUndoToneCurve )
    {
        result = UndoToneCurve ( result ) ;
    }
    if ( false )
    {
        float r = 0.5667 ;
        float b = 0.7570 ;
        float scaleR = 1.0 / r ;
        float scaleB = 1.0 / b ;
        result . r *= scaleR ;
        result . b *= scaleB ;
    }
    if ( uHasLensVignette )
    {
        result = DoLensVignette ( result , srcPt ) ;
    }
    if ( uHasPostCropVignetteHighlightPriority )
    {
        result = DoPostCropVignette ( result , srcPtCrop ) ;
    }
    if ( false )
    {
        float scale = pow ( 2.0 , uParamExposure ) ;
        result *= scale ;
    }
    result = DoColorGray ( result ) ;
    if ( uHasPostCropVignetteColorPriority )
    {
        result = DoPostCropVignette ( result , srcPtCrop ) ;
    }
    result = DoToneCurve ( result ) ;
    if ( uHasRGBCurves )
    {
        result = DoRGBCurves ( result ) ;
    }
    if ( uHasSplitTone )
    {
        result = DoSplitTone ( result ) ;
    }
    if ( uHasPostCropVignettePaintOverlay )
    {
        result = DoPostCropVignette ( result , srcPtCrop ) ;
    }
    float4 final = float4 ( result , 1.0 ) ;
    if ( uDoTransparency )
    {
        final . a = alpha ;
        final = DoTransparency ( final , srcPt , dstPt ) ;
    }
    return final ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{

    {
        float2 dstPt = inputs . uv0 ;
        dstPt . y = 1.0 - dstPt . y ;
        outputs . target0 = Process2012 ( dstPt ) ;
    }
}
[Material] name=Shared vs=SharedVS ps=SharedPS
[Material] name=ACR_PV2012 vs=ACR_VS ps=ACR_PS
