[ShaderES] name=SharedVS version=200
#version 100
precision highp float;
#line 4
uniform mat4 modelToWorldTfm ;
uniform mat4 worldToViewTfm ;
uniform mat4 viewToClipTfm ;
uniform mat4 worldToClipTfm ;
uniform mat4 modelToClipTfm ;
uniform float debugCycles ;
attribute vec4 position_ ;
struct Inputs
{
    vec4 position ;
}
;
struct Outputs
{
    vec4 positiont ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    vec4 pos = inputs . position ;
    pos = ( ( pos ) * ( modelToWorldTfm ) ) ;
    pos = ( ( pos ) * ( worldToViewTfm ) ) ;
    pos = ( ( pos ) * ( viewToClipTfm ) ) ;
    pos = ( ( pos ) * ( worldToClipTfm ) ) ;
    pos = ( ( pos ) * ( modelToClipTfm ) ) ;
    pos . x *= debugCycles ;
    outputs . positiont = pos ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
}
[ShaderES] name=SharedPS version=200
#version 100
precision highp float;
#line 44
struct Inputs
{
    vec4 positiont ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = vec4 ( 0 , 0 , 0 , 0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . positiont = gl_FragCoord ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACR_VS version=200
#version 100
precision highp float;
#line 70
uniform mat4 worldToClipTfm ;
attribute vec3 position_ ;
attribute vec2 uv0_ ;
attribute vec4 color_ ;
varying vec2 uv0 ;
varying vec4 color ;
struct Inputs
{
    vec3 position ;
    vec2 uv0 ;
    vec4 color ;
}
;
struct Outputs
{
    vec4 positiont ;
    vec2 uv0 ;
    vec4 color ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{

    {
        outputs . uv0 = inputs . uv0 ;
        outputs . color = inputs . color ;
        outputs . positiont = vec4 ( inputs . position , 1.0 ) ;
        outputs . positiont = ( ( outputs . positiont ) * ( worldToClipTfm ) ) ;
    }
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    inputs . uv0 = uv0_ ;
    inputs . color = color_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
    uv0 = outputs . uv0 ;
    color = outputs . color ;
}
[ShaderES] name=ACR_PS version=200
#version 100
precision highp float;
#line 116
uniform float uBigTableCol0 ;
uniform float uBigTableCol1 ;
uniform float uBigTable_ToneCurve ;
uniform float uBigTable_ProfileVignette ;
uniform float uBigTable_ProfileDistortion ;
uniform float uBigTable_CurveRed ;
uniform float uBigTable_CurveGreen ;
uniform float uBigTable_CurveBlue ;
uniform float uBigTable_PostCropVignette ;
uniform float uBigTable_GrayMixer ;
uniform float uBigTable_UndoToneCurve ;
uniform float uBigTable_HSL ;
uniform vec2 uDefaultCropSize ;
uniform vec2 uStage3Size ;
uniform vec2 uToDefaultCropScale ;
uniform vec2 uToDefaultCropOffset ;
uniform vec2 uNormalizeDistance ;
uniform float uRenderScale ;
uniform bool uHasUndoToneCurve ;
uniform bool uConvertToGray ;
uniform float uGrayMixerCoord0 ;
uniform float uGrayMixerCoord1 ;
uniform bool uHasVibranceHSL ;
uniform bool uHasHSL ;
uniform float uHSLCoord0 ;
uniform float uHSLCoord1 ;
uniform float uToneContrastSplit ;
uniform float uVibrance ;
uniform bool uHasWarp ;
uniform mat3 uBackwardCropTransform ;
uniform bool uHasPerspective ;
uniform float uPerspectiveMinScale ;
uniform float uPerspectiveMaxScale ;
uniform mat3 uPerspectiveMatrix ;
uniform bool uHasManualDistort ;
uniform float uManualDistortB ;
uniform bool uHasProfileWarp ;
uniform vec2 uProfileWarpCenter ;
uniform vec2 uProfileWarpToTable ;
uniform vec2 uProfileWarpFromTable ;
uniform bool uHasLateralCA ;
uniform bool uHasLensVignette ;
uniform bool uHasLensManualVignette ;
uniform float uLensVignetteAmount ;
uniform float uLensVignetteMidpoint ;
uniform bool uHasLensProfileVignette ;
uniform vec2 uVignetteProfileScale ;
uniform vec2 uVignetteProfileOffset ;
uniform bool uHasPostCropVignetteHighlightPriority ;
uniform bool uHasPostCropVignetteColorPriority ;
uniform bool uHasPostCropVignettePaintOverlay ;
uniform float uPostCropVignetteAmount ;
uniform float uPostCropVignetteMidpoint ;
uniform float uPostCropVignetteFeather ;
uniform float uPostCropVignetteRoundness ;
uniform float uPostCropVignetteHighlightContrast ;
uniform float uPostCropVignetteEllipseA ;
uniform float uPostCropVignetteEllipseB ;
uniform float uPostCropVignetteEllipseC ;
uniform float uPostCropVignetteEllipseD ;
uniform float uPostCropVignetteEllipseE ;
uniform mat3 uPostCropVignetteCropTransform ;
uniform float uPostCropVignetteCropAspectRatio ;
uniform bool uBlendStyleLensVignette ;
uniform bool uHasSplitTone ;
uniform float uSplitToneBalanceMapAlpha ;
uniform vec3 uSplitToneShadowFactor ;
uniform vec3 uSplitToneDeltaFactor ;
uniform bool uHasRGBCurves ;
uniform bool uDoTransparency ;
uniform bool uDoCheckerboard ;
uniform float uCheckerboardSize ;
uniform vec2 uCheckerboardOrigin ;
uniform bool uFlattenTransparency ;
uniform bool uMultiplyTransparency ;
uniform float uMatteGrayLevel ;
uniform bool uOnlyPurelyTransparent ;
uniform float uParamExposure ;
uniform mat3 uSaturationMatrix ;
uniform sampler2D uStage3Image ;
uniform sampler2D uBigTable ;
uniform sampler2D uLateralCAMap ;
varying vec4 color ;
varying vec2 uv0 ;
struct Inputs
{
    vec4 positiont ;
    vec4 color ;
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
vec2 ToDefaultCrop ( vec2 pt )
{
    return ( pt * uToDefaultCropScale ) + uToDefaultCropOffset ;
}
vec2 FromDefaultCrop ( vec2 pt )
{
    return ( pt - uToDefaultCropOffset ) / uToDefaultCropScale ;
}
float NormalizedSquaredDistanceFromCenter ( vec2 pt )
{
    vec2 diff = ( pt - vec2 ( 0.5 , 0.5 ) ) * uNormalizeDistance ;
    return dot ( diff , diff ) ;
}
float NormalizedSquaredPinnedDistanceFromCenter ( vec2 pt )
{
    return min ( NormalizedSquaredDistanceFromCenter ( pt ) , 1.0 ) ;
}
vec4 BigTableLookup ( float index , float rowOffset , float coord0 , float coord1 )
{
    index = mix ( coord0 , coord1 , index ) ;
    return texture2D ( uBigTable , vec2 ( index , rowOffset ) ) ;
}
vec4 BigTableLookup ( float index , float rowOffset )
{
    return BigTableLookup ( index , rowOffset , uBigTableCol0 , uBigTableCol1 ) ;
}
float sRGB_Evaluate ( float x )
{
    if ( x <= 0.0031308 ) return x * 12.92 ;
    else return 1.055 * pow ( x , 1.0 / 2.4 ) - 0.055 ;
}
vec3 sRGB_Evaluate ( vec3 x )
{
    return vec3 ( sRGB_Evaluate ( x . r ) , sRGB_Evaluate ( x . g ) , sRGB_Evaluate ( x . b ) ) ;
}
float sRGB_EvaluateInverse ( float y )
{
    if ( y <= 0.0031308 * 12.92 ) return y * ( 1.0 / 12.92 ) ;
    else return pow ( ( y + 0.055 ) * ( 1.0 / 1.055 ) , 2.4 ) ;
}
vec3 sRGB_EvaluateInverse ( vec3 x )
{
    return vec3 ( sRGB_EvaluateInverse ( x . r ) , sRGB_EvaluateInverse ( x . g ) , sRGB_EvaluateInverse ( x . b ) ) ;
}
vec3 RGBtoHSV ( vec3 src )
{
    float h , s , v ;
    v = max ( src . r , max ( src . g , src . b ) ) ;
    float gap = v - min ( src . r , min ( src . g , src . b ) ) ;
    if ( gap > 0.0 )
    {
        if ( src . r == v )
        {
            h = ( src . g - src . b ) / gap ;
            if ( h < 0.0 )
            {
                h += 6.0 ;
            }
        }
        else if ( src . g == v )
        {
            h = 2.0 + ( src . b - src . r ) / gap ;
        }
        else
        {
            h = 4.0 + ( src . r - src . g ) / gap ;
        }
        s = gap / v ;
    }
    else
    {
        h = 0.0 ;
        s = 0.0 ;
    }
    return vec3 ( h , s , v ) ;
}
vec3 HSVtoRGB ( vec3 hsv )
{
    float r , g , b ;
    float h = hsv . x ;
    float s = hsv . y ;
    float v = hsv . z ;
    if ( s > 0.0 )
    {
        if ( h < 0.0 ) h += 6.0 ;
        if ( h >= 6.0 ) h -= 6.0 ;
        float i = floor ( h ) ;
        float f = h - i ;
        float p = v * ( 1.0 - s ) ;
        float q = v * ( 1.0 - s * f ) ;
        float t = ( v * ( 1.0 - s * ( 1.0 - f ) ) ) ;
        if ( i == 0.0 )
        {
            r = v ;
            g = t ;
            b = p ;
        }
        else if ( i == 1.0 )
        {
            r = q ;
            g = v ;
            b = p ;
        }
        else if ( i == 2.0 )
        {
            r = p ;
            g = v ;
            b = t ;
        }
        else if ( i == 3.0 )
        {
            r = p ;
            g = q ;
            b = v ;
        }
        else if ( i == 4.0 )
        {
            r = t ;
            g = p ;
            b = v ;
        }
        else
        {
            r = v ;
            g = p ;
            b = q ;
        }
    }
    else
    {
        r = v ;
        g = v ;
        b = v ;
    }
    return vec3 ( r , g , b ) ;
}
vec3 DoSaturation ( vec3 rgb )
{
    return clamp ( ( uSaturationMatrix * rgb ) , 0.0 , 1.0 ) ;
}
vec3 DoRGBtoMMH ( vec3 rgb )
{
    float r = rgb . r ;
    float g = rgb . g ;
    float b = rgb . b ;
    bool mirror0 = ( b > g ) ;
    if ( mirror0 )
    {
        float temp = g ;
        g = b ;
        b = temp ;
    }
    bool mirror1 = ( b > r ) ;
    if ( mirror1 )
    {
        float temp = r ;
        r = b ;
        b = temp ;
    }
    bool mirror2 = ( g > r ) ;
    if ( mirror2 )
    {
        float temp = g ;
        g = r ;
        r = temp ;
    }
    float hue ;
    if ( r == b )
    {
        hue = 0.0 ;
    }
    else
    {
        hue = ( g - b ) / ( r - b ) ;
    }
    if ( mirror2 )
    {
        hue = 2.0 - hue ;
    }
    if ( mirror1 )
    {
        hue = 4.0 - hue ;
    }
    if ( mirror0 )
    {
        hue = 6.0 - hue ;
    }
    return vec3 ( b , r , hue ) ;
}
vec3 DoMMHtoRGB ( vec3 mmh )
{
    float hue = mmh . z ;
    float r = mmh . y ;
    float b = mmh . x ;
    if ( hue > 6.0 )
    {
        hue -= 6.0 ;
    }
    if ( hue > 6.0 )
    {
        hue -= 6.0 ;
    }
    bool mirror0 = ( hue > 3.0 ) ;
    if ( mirror0 )
    {
        hue = 6.0 - hue ;
    }
    bool mirror1 = ( hue > 2.0 ) ;
    if ( mirror1 )
    {
        hue = 4.0 - hue ;
    }
    bool mirror2 = ( hue > 1.0 ) ;
    if ( mirror2 )
    {
        hue = 2.0 - hue ;
    }
    float g = b + ( r - b ) * hue ;
    if ( mirror2 )
    {
        float temp = g ;
        g = r ;
        r = temp ;
    }
    if ( mirror1 )
    {
        float temp = r ;
        r = b ;
        b = temp ;
    }
    if ( mirror0 )
    {
        float temp = g ;
        g = b ;
        b = temp ;
    }
    return vec3 ( r , g , b ) ;
}
const float kMinSkinHue = - 60.0 ;
const float kMinCentralSkinHue = 0.0 ;
const float kMaxCentralSkinHue = 30.0 ;
const float kMaxSkinHue = 45.0 ;
const float kMinScaledSkinHue = ( kMinSkinHue + 60.0 ) / 60.0 ;
const float kMinScaledCentralSkinHue = ( kMinCentralSkinHue + 60.0 ) / 60.0 ;
const float kMaxScaledCentralSkinHue = ( kMaxCentralSkinHue + 60.0 ) / 60.0 ;
const float kMaxScaledSkinHue = ( kMaxSkinHue + 60.0 ) / 60.0 ;
const float kMinSideFalloff = 1.0 / ( kMinScaledCentralSkinHue - kMinScaledSkinHue ) ;
const float kMaxSideFalloff = 1.0 / ( kMaxScaledSkinHue - kMaxScaledCentralSkinHue ) ;
vec3 DoIncreaseVibrance ( vec3 minMaxHue , float vibranceShift )
{
    const float kMaxSaturationGain = 6.0 ;
    const float kMaxSkinSaturationGain = 1.75 ;
    const float kStandardFactor = 1.0 - ( 1.0 / kMaxSaturationGain ) ;
    const float kSkinFactor = 1.0 - ( 1.0 / kMaxSkinSaturationGain ) ;
    const float kSkinProtectionSlope = kSkinFactor - kStandardFactor ;
    float minValue = minMaxHue . x ;
    float maxValue = minMaxHue . y ;
    float gap = maxValue - minValue ;
    if ( gap == 0.0 )
    {
        return minMaxHue ;
    }
    float saturation = gap / maxValue ;
    float shiftFactor = vibranceShift ;
    float hue = minMaxHue . z ;
    float shiftedHue = hue + 1.0 ;
    if ( 6.0 <= shiftedHue ) shiftedHue -= 6.0 ;
    float minSide = clamp ( ( 1.0 - ( kMinScaledCentralSkinHue - shiftedHue ) * kMinSideFalloff ) , 0.0 , 1.0 ) ;
    float maxSide = clamp ( ( 1.0 - ( shiftedHue - kMaxScaledCentralSkinHue ) * kMaxSideFalloff ) , 0.0 , 1.0 ) ;
    float protection = min ( minSide , maxSide ) ;
    protection *= ( 1.0 - saturation * saturation ) ;
    shiftFactor = shiftFactor * ( shiftFactor * protection + 1.0 - protection ) ;
    float saturationFactor = kStandardFactor + kSkinProtectionSlope * protection ;
    saturationFactor *= shiftFactor ;
    saturationFactor *= 1.0 - minValue ;
    float shadowRolloff = min ( 1.0 , 16.0 * maxValue ) ;
    shadowRolloff *= 2.0 - shadowRolloff ;
    saturationFactor *= shadowRolloff ;
    float saturationMask = saturation * ( 1.0 - saturation ) ;
    saturationMask *= 2.0 - saturationMask ;
    float brightnessFactor = shiftFactor * shadowRolloff * saturationMask ;
    saturation = saturation / ( 1.0 - saturationFactor * ( 1.0 - saturation ) ) ;
    maxValue *= 1.0 + 0.25 * brightnessFactor * ( 1.0 - maxValue ) ;
    minValue = maxValue - saturation * maxValue ;
    return vec3 ( minValue , maxValue , hue ) ;
}
vec3 DoDecreaseVibrance ( vec3 minMaxHue , float vibranceShift )
{
    float minValue = minMaxHue . x ;
    float maxValue = minMaxHue . y ;
    float gap = maxValue - minValue ;
    if ( gap == 0.0 )
    {
        return minMaxHue ;
    }
    float saturation = gap / maxValue ;
    float saturationFactor = - vibranceShift ;
    float shadowRolloff = min ( 1.0 , 16.0 * maxValue ) ;
    shadowRolloff *= 2.0 - shadowRolloff ;
    float saturationMask = saturation * ( 1.0 - saturation ) ;
    saturationMask *= 2.0 - saturationMask ;
    float brightnessFactor = - vibranceShift * shadowRolloff * saturationMask ;
    saturation *= 1.0 - saturationFactor + saturationFactor * saturation * ( 0.5 + 0.5 * saturation ) * shadowRolloff ;
    saturation *= 1.0 - 0.25 * saturationFactor ;
    maxValue *= 1.0 - brightnessFactor * ( 1.0 - maxValue ) ;
    minValue = maxValue - saturation * maxValue ;
    return vec3 ( minValue , maxValue , minMaxHue . z ) ;
}
vec3 DoVibrance ( vec3 rgb )
{
    if ( uVibrance > 0.0 )
    {
        rgb = DoIncreaseVibrance ( rgb , uVibrance ) ;
    }
    else if ( uVibrance < 0.0 )
    {
        rgb = DoDecreaseVibrance ( rgb , uVibrance ) ;
    }
    return rgb ;
}
float ContrastBump ( float lum )
{
    float contrastBump ;
    if ( lum <= 0.5 )
    {
        float f = ( lum - 0.25 ) * 4.0 ;
        contrastBump = f * f - 1.0 ;
    }
    else
    {
        float f = ( lum - 0.75 ) * 4.0 ;
        contrastBump = 1.0 - f * f ;
    }
    contrastBump *= 0.125 ;
    return contrastBump ;
}
float DodgeBurnSlope ( float x )
{
    return pow ( 2.0 , x * 4.0 ) ;
}
float ShiftBrightnessAndContrast ( float lum , float brightnessShift , float contrastShift , float contrastSplitSlope , float invContrastSplitSlope )
{
    float dbSlope = DodgeBurnSlope ( brightnessShift ) ;
    if ( contrastShift == 0.0 )
    {
        float lum_db = dbSlope * lum ;
        lum = lum_db / ( 1.0 + lum_db - lum ) ;
    }
    else
    {
        float slope1 = dbSlope * contrastSplitSlope ;
        float slope2 = invContrastSplitSlope ;
        float lum_scaled_1 = slope1 * lum ;
        lum = lum_scaled_1 / ( 1.0 + lum_scaled_1 - lum ) ;
        float contrastSlope = pow ( 2.0 , 0.75 * contrastShift ) ;
        float contrastBump = ContrastBump ( lum ) ;
        if ( 1.0 <= contrastSlope )
        {
            lum += contrastBump * min ( 0.5 , contrastSlope - 1.0 ) ;
            contrastSlope = max ( 1.0 , contrastSlope * 0.6666666667 ) ;
        }
        else
        {
            lum += contrastBump * max ( - 0.5 , contrastSlope - 1.0 ) ;
            contrastSlope = min ( 1.0 , contrastSlope * 2.0 ) ;
        }
        if ( contrastSlope != 1.0 )
        {
            float lum_expanded = 2.0 * lum - 1.0 ;
            float lum_expanded_scaled = lum_expanded * contrastSlope ;
            float lum_expanded_scaled_b = lum_expanded_scaled / ( 1.0 + ( contrastSlope - 1.0 ) * abs ( lum_expanded ) ) ;
            lum = 0.5 + 0.5 * lum_expanded_scaled_b ;
        }
        float lum_scaled_2 = slope2 * lum ;
        lum = lum_scaled_2 / ( 1.0 + lum_scaled_2 - lum ) ;
    }
    return lum ;
}
vec3 DoTuneHSLMasked32 ( vec3 minMaxHue , float lMask , float cMask , float sMask )
{
    float contrastSplit = uToneContrastSplit ;
    const float kMaxSaturationGain = 6.0 ;
    const float kBaseSaturationFactor = 1.0 - ( 1.0 / kMaxSaturationGain ) ;
    const float tableScale = ( 1.0 / 6.0 ) ;
    float contrastSplitSlope = ( 1.0 - contrastSplit ) / contrastSplit ;
    float invContrastSplitSlope = contrastSplit / ( 1.0 - contrastSplit ) ;
    const float kExponentialSaturationFactor = 2.5 ;
    float minValue = minMaxHue . x ;
    float maxValue = minMaxHue . y ;
    float hue = minMaxHue . z ;
    float newHue = hue ;
    float initialGap = maxValue - minValue ;
    float maskBrightnessShift = lMask ;
    float maskContrastShift = cMask ;
    float maskSaturationShift = sMask ;
    bool doMaskBrightnessShift = maskBrightnessShift != 0.0 ;
    bool doMaskContrastShift = maskContrastShift != 0.0 ;
    bool doMaskBrightnessContrastShift = doMaskBrightnessShift || doMaskContrastShift ;
    float hslSaturationShift = 0.0 ;
    if ( initialGap != 0.0 )
    {
        float index = hue * tableScale ;
        vec3 hslLookup = BigTableLookup ( index , uBigTable_HSL , uHSLCoord0 , uHSLCoord1 ) . rgb ;
        newHue = hslLookup . x ;
        hslSaturationShift = hslLookup . y ;
        float hslLuminanceShift = hslLookup . z ;
        if ( hslLuminanceShift != 0.0 )
        {
            float gap2 = initialGap * ( 2.0 - initialGap ) ;
            float gap4 = gap2 * ( 2.0 - gap2 ) ;
            float gap8 = gap4 * ( 2.0 - gap4 ) ;
            hslLuminanceShift *= gap8 ;
            minValue = minValue * ( 1.0 + hslLuminanceShift * ( 1.0 - minValue ) ) ;
            maxValue = maxValue * ( 1.0 + hslLuminanceShift * ( 1.0 - maxValue ) ) ;
            minValue = minValue * ( 1.0 + hslLuminanceShift * ( 1.0 - minValue ) ) ;
            maxValue = maxValue * ( 1.0 + hslLuminanceShift * ( 1.0 - maxValue ) ) ;
        }
    }
    if ( doMaskBrightnessContrastShift )
    {
        minValue = ShiftBrightnessAndContrast ( minValue , maskBrightnessShift , maskContrastShift , contrastSplitSlope , invContrastSplitSlope ) ;
        maxValue = ShiftBrightnessAndContrast ( maxValue , maskBrightnessShift , maskContrastShift , contrastSplitSlope , invContrastSplitSlope ) ;
    }
    if ( minValue < maxValue )
    {
        float saturationShift = hslSaturationShift + maskSaturationShift ;
        if ( saturationShift < 0.0 )
        {
            saturationShift = max ( - 1.0 , saturationShift ) ;
            float L = 0.5 * ( maxValue + minValue ) ;
            minValue += saturationShift * ( minValue - L ) ;
            maxValue += saturationShift * ( maxValue - L ) ;
        }
        else if ( 0.0 < saturationShift )
        {
            float gap = maxValue - minValue ;
            float saturation = gap / maxValue ;
            float shiftedHue = hue + 1.0 ;
            if ( 6.0 <= shiftedHue ) shiftedHue -= 6.0 ;
            float minSide = clamp ( 1.0 - ( kMinScaledCentralSkinHue - shiftedHue ) * kMinSideFalloff , 0.0 , 1.0 ) ;
            float maxSide = clamp ( 1.0 - ( shiftedHue - kMaxScaledCentralSkinHue ) * kMaxSideFalloff , 0.0 , 1.0 ) ;
            float protection = min ( minSide , maxSide ) ;
            protection *= ( 1.0 - saturation * saturation ) ;
            float availableForProtection = clamp ( maskSaturationShift , 0.0 , saturationShift ) ;
            saturationShift -= 0.5 * availableForProtection * protection ;
            saturationShift *= 1.0 - minValue ;
            float shadowRolloff = min ( 1.0 , 16.0 * maxValue ) ;
            shadowRolloff *= 2.0 - shadowRolloff ;
            saturationShift *= shadowRolloff ;
            if ( saturationShift <= 1.0 )
            {
                float saturationFactor = kBaseSaturationFactor * saturationShift ;
                saturation = saturation / ( 1.0 - saturationFactor * ( 1.0 - saturation ) ) ;
            }
            else
            {
                float saturationFactor = 6.0 * pow ( 2.0 , kExponentialSaturationFactor * ( saturationShift - 1.0 ) ) ;
                float scaledSaturation = saturationFactor * saturation ;
                saturation = scaledSaturation / ( 1.0 + scaledSaturation - saturation ) ;
            }
            minValue = maxValue - saturation * maxValue ;
        }
    }
    minMaxHue . x = minValue ;
    minMaxHue . y = maxValue ;
    minMaxHue . z = newHue ;
    return minMaxHue ;
}
vec3 DoVibranceHSL ( vec3 rgb )
{
    vec3 mmh = DoRGBtoMMH ( rgb ) ;
    mmh = DoVibrance ( mmh ) ;
    if ( uHasHSL )
    {
        float localLuminanceMask = 0.0 ;
        float localContrastMask = 0.0 ;
        float localSatMask = 0.0 ;
        mmh = DoTuneHSLMasked32 ( mmh , localLuminanceMask , localContrastMask , localSatMask ) ;
    }
    rgb = DoMMHtoRGB ( mmh ) ;
    return rgb ;
}
vec3 DoColorPath ( vec3 rgb )
{
    rgb = DoSaturation ( rgb ) ;
    if ( uHasVibranceHSL )
    {
        rgb = DoVibranceHSL ( rgb ) ;
    }
    return rgb ;
}
vec3 DoGrayMixer ( vec3 rgb )
{
    float tableScale = ( 1.0 / 6.0 ) ;
    float r = rgb . r ;
    float g = rgb . g ;
    float b = rgb . b ;
    float minValue , maxValue , hue ;
    bool mirror0 = ( b > g ) ;
    if ( mirror0 )
    {
        float temp = g ;
        g = b ;
        b = temp ;
    }
    bool mirror1 = ( b > r ) ;
    if ( mirror1 )
    {
        float temp = r ;
        r = b ;
        b = temp ;
    }
    bool mirror2 = ( g > r ) ;
    if ( mirror2 )
    {
        float temp = g ;
        g = r ;
        r = temp ;
    }
    if ( r == b )
    {
        return vec3 ( b ) ;
    }
    else
    {
        hue = ( g - b ) / ( r - b ) ;
    }
    if ( mirror2 )
    {
        hue = 2.0 - hue ;
    }
    if ( mirror1 )
    {
        hue = 4.0 - hue ;
    }
    if ( mirror0 )
    {
        hue = 6.0 - hue ;
    }
    minValue = b ;
    maxValue = r ;
    hue = hue ;
    float gap = maxValue - minValue ;
    float tableIndex = hue * tableScale ;
    tableIndex = clamp ( ( tableIndex ) , 0.0 , 1.0 ) ;
    float gray = BigTableLookup ( tableIndex , uBigTable_GrayMixer , uGrayMixerCoord0 , uGrayMixerCoord1 ) . x ;
    float result ;
    if ( gray < 0.0 )
    {
        float minT ;
        if ( 9.0 * minValue < 1.0 ) minT = ( 3.0 * minValue ) / ( 0.25 + 6.75 * minValue ) ;
        else minT = 0.25 + 0.75 * minValue ;
        float maxT ;
        if ( 9.0 * maxValue < 1.0 ) maxT = ( 3.0 * maxValue ) / ( 0.25 + 6.75 * maxValue ) ;
        else maxT = 0.25 + 0.75 * maxValue ;
        float resultT = clamp ( ( minT + gray * ( maxT - minT ) ) , 0.0 , 1.0 ) ;
        if ( 3.0 * resultT < 1.0 ) result = resultT / ( 12.0 - 27.0 * resultT ) ;
        else result = ( resultT - 0.25 ) / 0.75 ;
    }
    else
    {
        result = minValue + gray * gap ;
    }
    result = clamp ( ( result ) , 0.0 , 1.0 ) ;
    return vec3 ( result ) ;
}
vec3 DoGrayPath ( vec3 rgb )
{
    rgb = DoGrayMixer ( rgb ) ;
    return rgb ;
}
vec3 DoColorGray ( vec3 rgb )
{
    if ( uConvertToGray )
    {
        rgb = DoGrayPath ( rgb ) ;
    }
    else
    {
        rgb = DoColorPath ( rgb ) ;
    }
    return rgb ;
}
vec3 RGBTone ( vec3 rgb , float tableIndex )
{
    float rr = BigTableLookup ( rgb . r , tableIndex ) . r ;
    float bb = BigTableLookup ( rgb . b , tableIndex ) . r ;
    float gg = bb + ( ( rr - bb ) * ( rgb . g - rgb . b ) / ( rgb . r - rgb . b ) ) ;
    return vec3 ( rr , gg , bb ) ;
}
vec3 DoToneCurve ( vec3 rgb , float tableIndex )
{
    float r = rgb . r ;
    float g = rgb . g ;
    float b = rgb . b ;
    vec3 result ;
    if ( r >= g )
    {
        if ( g > b )
        {
            result = RGBTone ( rgb , tableIndex ) . rgb ;
        }
        else if ( b > r )
        {
            result = RGBTone ( vec3 ( b , r , g ) , tableIndex ) . gbr ;
        }
        else if ( b > g )
        {
            result = RGBTone ( vec3 ( r , b , g ) , tableIndex ) . rbg ;
        }
        else
        {
            float gg = BigTableLookup ( g , tableIndex ) . r ;
            result = vec3 ( BigTableLookup ( r , tableIndex ) . r , gg , gg ) ;
        }
    }
    else
    {
        if ( r >= b )
        {
            result = RGBTone ( vec3 ( g , r , b ) , tableIndex ) . grb ;
        }
        else if ( b > g )
        {
            result = RGBTone ( vec3 ( b , g , r ) , tableIndex ) . bgr ;
        }
        else
        {
            result = RGBTone ( vec3 ( g , b , r ) , tableIndex ) . brg ;
        }
    }
    return result ;
}
vec3 DoToneCurve ( vec3 rgb )
{
    return DoToneCurve ( rgb , uBigTable_ToneCurve ) ;
}
vec3 UndoToneCurve ( vec3 rgb )
{
    return DoToneCurve ( rgb , uBigTable_UndoToneCurve ) ;
}
vec3 DoRGBCurves ( vec3 rgb )
{
    return vec3 ( BigTableLookup ( rgb . r , uBigTable_CurveRed ) . x , BigTableLookup ( rgb . g , uBigTable_CurveGreen ) . x , BigTableLookup ( rgb . b , uBigTable_CurveBlue ) . x ) ;
}
vec3 DivMapEvaluate ( vec3 x , float alpha )
{
    vec3 scaled = vec3 ( alpha ) * x ;
    return scaled / ( vec3 ( 1.0 ) + scaled - x ) ;
}
vec3 DivMapEvaluateInverse ( vec3 y , float alpha )
{
    vec3 scaled = y / vec3 ( alpha ) ;
    return scaled / ( vec3 ( 1.0 ) + scaled - y ) ;
}
vec3 DoSplitTone ( vec3 rgb )
{
    vec3 y = rgb ;
    y = DivMapEvaluate ( y , uSplitToneBalanceMapAlpha ) ;
    y = y * ( ( vec3 ( 1.0 ) - y ) * ( uSplitToneShadowFactor + uSplitToneDeltaFactor * y ) + y * y ) ;
    return DivMapEvaluateInverse ( y , uSplitToneBalanceMapAlpha ) ;
}
float DoProfileLensVignette ( vec2 pt )
{
    vec2 dxdy = pt * uVignetteProfileScale + uVignetteProfileOffset ;
    float rr = dot ( dxdy , dxdy ) ;
    return BigTableLookup ( rr , uBigTable_ProfileVignette ) . x ;
}
float DoManualLensVignette ( float rr , float amount , float midpoint , float amountScale )
{
    float power = 1.0 + 4.0 * midpoint ;
    float scale = pow ( 2.0 , abs ( amount ) * amountScale ) - 1.0 ;
    float y = 1.0 + scale * pow ( rr , power ) ;
    if ( amount < 0.0 )
    {
        y = 1.0 / y ;
    }
    return y ;
}
float DoManualLensVignette ( float rr )
{
    return DoManualLensVignette ( rr , uLensVignetteAmount , uLensVignetteMidpoint , 2.0 ) ;
}
vec3 DoLensVignette ( vec3 image , vec2 pt )
{
    float scale = 1.0 ;
    if ( uHasLensManualVignette )
    {
        float rr = NormalizedSquaredPinnedDistanceFromCenter ( pt ) ;
        scale *= DoManualLensVignette ( rr ) ;
    }
    if ( uHasLensProfileVignette )
    {
        scale *= DoProfileLensVignette ( pt ) ;
    }
    scale = max ( scale , 0.0 ) ;
    return clamp ( ( image * scale ) , 0.0 , 1.0 ) ;
}
float PowerScreen ( float x , float s )
{
    if ( x <= 0.0 )
    {
        return pow ( 1.0 + x , s ) - 1.0 ;
    }
    else
    {
        return 1.0 - pow ( 1.0 - x , s ) ;
    }
}
float DoPostCropVignette ( float x , float amount )
{
    float fMidpoint = uPostCropVignetteMidpoint ;
    float fFeather = uPostCropVignetteFeather ;
    float resultLensVignette = 0.0 ;
    if ( uBlendStyleLensVignette && ( amount < 0.0 ) )
    {
        resultLensVignette = DoManualLensVignette ( x , amount , fMidpoint , 5.0 ) ;
    }
    float feather = uPostCropVignetteFeather ;
    feather = 1.5 * feather / ( 1.0 + 0.5 * feather ) ;
    const float kMaxSlope = 8.0 ;
    float fs = 1.0 / ( feather + ( 1.0 - feather ) / kMaxSlope ) ;
    fs = fs * fs ;
    float target = sqrt ( 0.5 ) + ( 2.0 * fMidpoint - 1.0 ) * ( sqrt ( 0.5 ) - sqrt ( 0.20 ) ) * ( 0.75 + 0.25 * fMidpoint ) ;
    target = target * target ;
    float ts = ( 1.0 - target ) / target ;
    x = ts * x / ( 1.0 + ( ts - 1.0 ) * x ) ;
    x = 2.0 * x - 1.0 ;
    x = PowerScreen ( x , fs ) ;
    x = 0.5 * ( x + 1.0 ) ;
    float finalResult ;
    if ( amount < 0.0 )
    {
        float blended_sRGB = 1.0 - x ;
        float blended_linear = sRGB_EvaluateInverse ( blended_sRGB ) ;
        float scaled_sRGB = 1.0 + amount ;
        float scaled_linear = sRGB_EvaluateInverse ( scaled_sRGB ) ;
        float result = 1.0 - ( 1.0 - scaled_linear ) * ( 1.0 - blended_linear ) ;
        if ( ! uBlendStyleLensVignette )
        {
            return result ;
        }
        float lerpFactor = sRGB_EvaluateInverse ( fFeather ) ;
        finalResult = mix ( result , resultLensVignette , lerpFactor ) ;
    }
    else
    {
        float blended_sRGB = x ;
        float blended_linear = sRGB_EvaluateInverse ( blended_sRGB ) ;
        float scaled_sRGB = amount ;
        float scaled_linear = sRGB_EvaluateInverse ( scaled_sRGB ) ;
        finalResult = 1.0 - scaled_linear * blended_linear ;
    }
    return finalResult ;
}
float RefEllipseMask32 ( vec2 pt )
{
    float x = ( pt . y * uDefaultCropSize . y ) + uPostCropVignetteEllipseD ;
    float Axx = uPostCropVignetteEllipseA * x * x ;
    float Bx = uPostCropVignetteEllipseB * x ;
    float y = pt . x * uDefaultCropSize . x + uPostCropVignetteEllipseE ;
    float r2 = Axx + ( Bx + uPostCropVignetteEllipseC * y ) * y ;
    float z = BigTableLookup ( r2 , uBigTable_PostCropVignette ) . x ;
    return z ;
}
float RefRoundedRectMask32 ( vec2 pt )
{
    float flatX = 0.0 ;
    float flatY = 0.0 ;
    float croppedAspectRatio = uPostCropVignetteCropAspectRatio ;
    float roundness = uPostCropVignetteRoundness ;
    if ( croppedAspectRatio >= 1.0 )
    {
        flatX = 0.45 * ( - roundness ) ;
        flatY = max ( 0.0 , 0.5 - ( ( 0.5 - flatX ) * croppedAspectRatio ) ) ;
    }
    else
    {
        flatY = 0.45 * ( - roundness ) ;
        flatX = max ( 0.0 , 0.5 - ( ( 0.5 - flatY ) / croppedAspectRatio ) ) ;
    }
    float scaleX = 0.5 / ( 0.5 - flatX ) ;
    float scaleY = 0.5 / ( 0.5 - flatY ) ;
    pt . x *= uDefaultCropSize . x ;
    pt . y *= uDefaultCropSize . y ;
    pt = ( uPostCropVignetteCropTransform * vec3 ( pt . yx , 1.0 ) ) . yx ;
    float x = abs ( pt . x - 0.5 ) ;
    float y = abs ( pt . y - 0.5 ) ;
    x = max ( x - flatX , 0.0 ) * scaleX ;
    y = max ( y - flatY , 0.0 ) * scaleY ;
    float r2 = ( x * x + y * y ) * 2.0 ;
    float z = BigTableLookup ( r2 , uBigTable_PostCropVignette ) . x ;
    return z ;
}
float DoPostCropVignette ( vec2 pt )
{
    if ( uPostCropVignetteRoundness >= 0.0 )
    {
        return RefEllipseMask32 ( pt ) ;
    }
    else
    {
        return RefRoundedRectMask32 ( pt ) ;
    }
}
vec3 DoDarkPostCropVignette ( vec3 image , vec2 pt )
{
    float m = DoPostCropVignette ( pt ) ;
    float scale = m ;
    if ( uPostCropVignetteHighlightContrast > 0.0 && ! uHasPostCropVignettePaintOverlay )
    {
        float maxScale = mix ( m , 1.0 , uPostCropVignetteHighlightContrast ) ;
        const float kHLThresh = 0.18 ;
        const float kHLScale = 1.0 / ( 1.0 - kHLThresh ) ;
        const float kHLOffset = - kHLThresh * kHLScale ;
        vec3 hsv = RGBtoHSV ( image ) ;
        float v = hsv . z ;
        float t = clamp ( ( ( v * kHLScale ) + kHLOffset ) , 0.0 , 1.0 ) ;
        scale = mix ( m , maxScale , t ) ;
        hsv . z = v * scale ;
        image = HSVtoRGB ( hsv ) ;
        return image ;
    }
    return image * scale ;
}
vec3 DoWhitePostCropVignette ( vec3 image , vec2 pt )
{
    float m = DoPostCropVignette ( pt ) ;
    return vec3 ( 1.0 ) - clamp ( ( ( vec3 ( 1.0 ) - image ) ) , 0.0 , 1.0 ) * m ;
}
vec3 DoPostCropVignette ( vec3 image , vec2 pt )
{
    pt = ToDefaultCrop ( pt ) ;
    if ( uPostCropVignetteAmount < 0.0 )
    {
        image = DoDarkPostCropVignette ( image , pt ) ;
    }
    else
    {
        image = DoWhitePostCropVignette ( image , pt ) ;
    }
    return image ;
}
vec2 DoPerspective ( vec2 pt )
{
    vec3 xyh = uPerspectiveMatrix * vec3 ( pt , 1.0 ) ;
    xyh . z = clamp ( xyh . z , uPerspectiveMinScale , uPerspectiveMaxScale ) ;
    pt = xyh . xy / xyh . z ;
    return pt ;
}
vec2 DoDistort ( vec2 pt , float radiusScale )
{
    const vec2 center = vec2 ( 0.5 , 0.5 ) ;
    return center + ( radiusScale * ( pt - center ) ) ;
}
vec2 DoManualDistort ( vec2 pt )
{
    vec2 ptDefaultCrop = ToDefaultCrop ( pt ) ;
    float rr = NormalizedSquaredPinnedDistanceFromCenter ( ptDefaultCrop ) ;
    float scale = ( 1.0 - uManualDistortB ) + uManualDistortB * rr ;
    pt = DoDistort ( pt , scale ) ;
    return pt ;
}
vec2 DoProfileDistort ( vec2 pt )
{
    vec2 diff = ( pt - uProfileWarpCenter ) * uProfileWarpToTable ;
    float rr = dot ( diff , diff ) ;
    float r = sqrt ( rr ) ;
    vec2 ratio = BigTableLookup ( r , uBigTable_ProfileDistortion ) . xx ;
    diff = diff * ratio ;
    return uProfileWarpCenter + ( diff * uProfileWarpFromTable ) ;
}
float DoWarpMask ( vec2 srcPt )
{
    const vec2 kPixelOffset = vec2 ( 0.5 , 0.5 ) ;
    vec2 size = uDefaultCropSize * uRenderScale ;
    vec2 ptPixels = ToDefaultCrop ( srcPt ) * size ;
    vec2 clipTL = kPixelOffset ;
    vec2 clipBR = size - kPixelOffset ;
    float alpha = ( clamp ( ( 1.0 - max ( clipTL . x - ptPixels . x , ptPixels . x - clipBR . x ) ) , 0.0 , 1.0 ) * clamp ( ( 1.0 - max ( clipTL . y - ptPixels . y , ptPixels . y - clipBR . y ) ) , 0.0 , 1.0 ) ) ;
    return alpha ;
}
vec4 DoTransparency ( vec4 image , vec2 srcPt , vec2 dstPt )
{
    image . a *= DoWarpMask ( srcPt ) ;
    if ( uOnlyPurelyTransparent && ( image . a > 0.0 ) )
    {
        image . a = 1.0 ;
    }
    if ( uFlattenTransparency )
    {
        float matteValue = uMatteGrayLevel ;
        if ( uDoCheckerboard )
        {
            vec2 rounded = mod ( floor ( dstPt * uStage3Size ) - uCheckerboardOrigin , vec2 ( uCheckerboardSize , uCheckerboardSize ) ) ;
            float checkerThresh = uCheckerboardSize * 0.5 - 0.5 ;
            bool test1 = ( rounded . x < checkerThresh ) ;
            bool test2 = ( rounded . y < checkerThresh ) ;
            const float kDarkCheck = 0.625 ;
            matteValue = mix ( matteValue , kDarkCheck , test1 != test2 ) ;
        }
        image . rgb = mix ( vec3 ( matteValue ) , image . rgb , vec3 ( image . a ) ) ;
        image . a = 1.0 ;
    }
    if ( uMultiplyTransparency )
    {
        image . rgb *= image . a ;
    }
    return image ;
}
void DoLateralCA ( vec2 pt , out vec2 ptR , out vec2 ptB )
{
    pt = ToDefaultCrop ( pt ) ;
    vec4 offset = texture2D ( uLateralCAMap , pt ) ;
    ptR = pt + offset . xy ;
    ptB = pt + offset . zw ;
    ptR = FromDefaultCrop ( ptR ) ;
    ptB = FromDefaultCrop ( ptB ) ;
}
vec4 GetStage3 ( vec2 dstPt , out vec2 srcPt , out vec2 srcPtCrop )
{
    vec2 pt = dstPt ;
    pt = ( uBackwardCropTransform * vec3 ( pt . yx , 1.0 ) ) . yx ;
    srcPtCrop = pt ;
    if ( ! uHasWarp )
    {
        srcPt = pt ;
        return texture2D ( uStage3Image , pt ) ;
    }
    if ( uHasPerspective )
    {
        pt = DoPerspective ( pt ) ;
    }
    if ( uHasManualDistort )
    {
        pt = DoManualDistort ( pt ) ;
    }
    if ( uHasProfileWarp )
    {
        pt = DoProfileDistort ( pt ) ;
    }
    vec2 ptR = pt ;
    vec2 ptB = pt ;
    vec4 stage3 ;
    if ( uHasLateralCA )
    {
        DoLateralCA ( pt , ptR , ptB ) ;
        vec4 stage3base = texture2D ( uStage3Image , pt ) ;
        stage3 = vec4 ( texture2D ( uStage3Image , ptR ) . r , stage3base . g , texture2D ( uStage3Image , ptB ) . b , stage3base . a ) ;
    }
    else
    {
        stage3 = texture2D ( uStage3Image , pt ) ;
    }
    srcPt = pt ;
    return stage3 ;
}
vec4 Process2012 ( vec2 dstPt )
{
    vec2 srcPt ;
    vec2 srcPtCrop ;
    vec4 stage3 = GetStage3 ( dstPt , srcPt , srcPtCrop ) ;
    vec3 result = stage3 . rgb ;
    float alpha = stage3 . a ;
    if ( uHasUndoToneCurve )
    {
        result = UndoToneCurve ( result ) ;
    }
    if ( false )
    {
        float r = 0.5667 ;
        float b = 0.7570 ;
        float scaleR = 1.0 / r ;
        float scaleB = 1.0 / b ;
        result . r *= scaleR ;
        result . b *= scaleB ;
    }
    if ( uHasLensVignette )
    {
        result = DoLensVignette ( result , srcPt ) ;
    }
    if ( uHasPostCropVignetteHighlightPriority )
    {
        result = DoPostCropVignette ( result , srcPtCrop ) ;
    }
    if ( false )
    {
        float scale = pow ( 2.0 , uParamExposure ) ;
        result *= scale ;
    }
    result = DoColorGray ( result ) ;
    if ( uHasPostCropVignetteColorPriority )
    {
        result = DoPostCropVignette ( result , srcPtCrop ) ;
    }
    result = DoToneCurve ( result ) ;
    if ( uHasRGBCurves )
    {
        result = DoRGBCurves ( result ) ;
    }
    if ( uHasSplitTone )
    {
        result = DoSplitTone ( result ) ;
    }
    if ( uHasPostCropVignettePaintOverlay )
    {
        result = DoPostCropVignette ( result , srcPtCrop ) ;
    }
    vec4 final = vec4 ( result , 1.0 ) ;
    if ( uDoTransparency )
    {
        final . a = alpha ;
        final = DoTransparency ( final , srcPt , dstPt ) ;
    }
    return final ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{

    {
        vec2 dstPt = inputs . uv0 ;
        dstPt . y = 1.0 - dstPt . y ;
        outputs . target0 = Process2012 ( dstPt ) ;
    }
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . positiont = gl_FragCoord ;
    inputs . color = color ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[Material] name=Shared vs=SharedVS ps=SharedPS
[Material] name=ACR_PV2012 vs=ACR_VS ps=ACR_PS
