[ShaderES] name=SharedVS version=200
#version 100
precision highp float;
#line 4
uniform mat4 modelToWorldTfm ;
uniform mat4 worldToViewTfm ;
uniform mat4 viewToClipTfm ;
uniform mat4 worldToClipTfm ;
uniform mat4 modelToClipTfm ;
uniform float debugCycles ;
attribute vec4 position_ ;
struct Inputs
{
    vec4 position ;
}
;
struct Outputs
{
    vec4 positiont ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    vec4 pos = inputs . position ;
    pos = ( ( pos ) * ( modelToWorldTfm ) ) ;
    pos = ( ( pos ) * ( worldToViewTfm ) ) ;
    pos = ( ( pos ) * ( viewToClipTfm ) ) ;
    pos = ( ( pos ) * ( worldToClipTfm ) ) ;
    pos = ( ( pos ) * ( modelToClipTfm ) ) ;
    pos . x *= debugCycles ;
    outputs . positiont = pos ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
}
[ShaderES] name=SharedPS version=200
#version 100
precision highp float;
#line 44
struct Inputs
{
    vec4 positiont ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = vec4 ( 0 , 0 , 0 , 0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . positiont = gl_FragCoord ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=TestShaderVS version=200
#version 100
precision highp float;
#line 70
uniform vec2 foregroundInverseSize ;
uniform vec2 videoInverseSize ;
attribute vec4 position_ ;
attribute vec2 uv0_ ;
attribute vec2 uv1_ ;
varying vec2 uv0 ;
varying vec2 uv1 ;
struct Inputs
{
    vec4 position ;
    vec2 uv0 ;
    vec2 uv1 ;
}
;
struct Outputs
{
    vec4 positiont ;
    vec2 uv0 ;
    vec2 uv1 ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    outputs . uv0 . xy = inputs . uv0 . xy * foregroundInverseSize ;
    outputs . uv1 . xy = inputs . uv1 . xy * videoInverseSize ;
    outputs . positiont = inputs . position ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    inputs . uv0 = uv0_ ;
    inputs . uv1 = uv1_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
    uv0 = outputs . uv0 ;
    uv1 = outputs . uv1 ;
}
[ShaderES] name=TestShaderPS version=200
#version 100
precision highp float;
#line 113
uniform vec2 foregroundInverseSize ;
uniform vec2 videoInverseSize ;
uniform sampler2D colorTexture ;
uniform sampler2D volumeTexture ;
varying vec2 uv0 ;
varying vec2 uv1 ;
struct Inputs
{
    vec4 positiont ;
    vec2 uv0 ;
    vec2 uv1 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
vec4 DoFunction1 ( in vec4 val )
{
    return val ;
}
void DoFunction2 ( in vec4 val , out vec4 newval )
{
    newval = val ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = DoFunction1 ( vec4 ( inputs . uv0 . xy , 0 , 1 ) ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . positiont = gl_FragCoord ;
    inputs . uv0 = uv0 ;
    inputs . uv1 = uv1 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=DrawQuadVS version=200
#version 100
precision highp float;
#line 157
uniform mat4 worldToClipTfm ;
attribute vec3 position_ ;
attribute vec2 uv0_ ;
attribute vec4 color_ ;
varying vec2 uv0 ;
varying vec4 color ;
struct Inputs
{
    vec3 position ;
    vec2 uv0 ;
    vec4 color ;
}
;
struct Outputs
{
    vec4 positiont ;
    vec2 uv0 ;
    vec4 color ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    outputs . uv0 = inputs . uv0 ;
    outputs . color = inputs . color ;
    outputs . positiont = vec4 ( inputs . position , 1.0 ) ;
    outputs . positiont = ( ( outputs . positiont ) * ( worldToClipTfm ) ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    inputs . uv0 = uv0_ ;
    inputs . color = color_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
    uv0 = outputs . uv0 ;
    color = outputs . color ;
}
[ShaderES] name=DrawQuadPS version=200
#version 100
precision highp float;
#line 200
varying vec2 uv0 ;
varying vec4 color ;
struct Inputs
{
    vec4 positiont ;
    vec2 uv0 ;
    vec4 color ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = inputs . color ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . positiont = gl_FragCoord ;
    inputs . uv0 = uv0 ;
    inputs . color = color ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=DrawTexQuadPS version=200
#version 100
precision highp float;
#line 232
uniform sampler2D colorTexture ;
varying vec2 uv0 ;
varying vec4 color ;
struct Inputs
{
    vec4 positiont ;
    vec2 uv0 ;
    vec4 color ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = inputs . color * texture2D ( colorTexture , inputs . uv0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . positiont = gl_FragCoord ;
    inputs . uv0 = uv0 ;
    inputs . color = color ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=DrawTextPS version=200
#version 100
precision highp float;
#line 265
uniform sampler2D colorTexture ;
varying vec2 uv0 ;
varying vec4 color ;
struct Inputs
{
    vec4 positiont ;
    vec2 uv0 ;
    vec4 color ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    vec4 c = texture2D ( colorTexture , inputs . uv0 . xy ) ;
    c = c . rrrr ;
    if ( ( c . a * inputs . color . a - 40.5 / 255.0 ) < 0.0 ) discard ;
    c *= inputs . color ;
    outputs . target0 = c ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . positiont = gl_FragCoord ;
    inputs . uv0 = uv0 ;
    inputs . color = color ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=FallbackWorldVS version=200
#version 100
precision highp float;
#line 302
uniform mat4 worldToClipTfm ;
uniform float debugCycles ;
attribute vec3 position_ ;
varying vec4 color ;
struct Inputs
{
    vec3 position ;
}
;
struct Outputs
{
    vec4 positiont ;
    vec4 color ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    outputs . positiont = vec4 ( inputs . position . xyz , 1.0 ) ;
    outputs . positiont = ( ( outputs . positiont ) * ( worldToClipTfm ) ) ;
    outputs . color = vec4 ( debugCycles + 0.2 , 0.0 , 0.0 , 1.0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
    color = outputs . color ;
}
[ShaderES] name=FallbackModelVS version=200
#version 100
precision highp float;
#line 336
uniform mat4 modelToClipTfm ;
uniform float debugCycles ;
attribute vec3 position_ ;
varying vec4 color ;
struct Inputs
{
    vec3 position ;
}
;
struct Outputs
{
    vec4 positiont ;
    vec4 color ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    outputs . positiont = vec4 ( inputs . position . xyz , 1.0 ) ;
    outputs . positiont = ( ( outputs . positiont ) * ( modelToClipTfm ) ) ;
    outputs . color = vec4 ( debugCycles + 0.2 , 0.0 , 0.0 , 1.0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
    color = outputs . color ;
}
[ShaderES] name=FallbackPS version=200
#version 100
precision highp float;
#line 370
varying vec4 color ;
struct Inputs
{
    vec4 positiont ;
    vec4 color ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = inputs . color ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . positiont = gl_FragCoord ;
    inputs . color = color ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=DynDrawVDVS version=200
#version 100
precision highp float;
#line 399
attribute vec3 position_ ;
attribute vec2 uv0_ ;
attribute vec4 color_ ;
struct Inputs
{
    vec3 position ;
    vec2 uv0 ;
    vec4 color ;
}
;
struct Outputs
{
    vec4 positiont ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    outputs . positiont = vec4 ( inputs . position . xyz , 1.0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    inputs . uv0 = uv0_ ;
    inputs . color = color_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
}
[ShaderES] name=AceVS version=200
#version 100
precision highp float;
#line 432
attribute vec4 position_ ;
attribute vec2 uv0_ ;
varying vec2 uv0 ;
struct Inputs
{
    vec4 position ;
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 positiont ;
    vec2 uv0 ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    outputs . positiont = inputs . position ;
    outputs . uv0 = inputs . uv0 ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    inputs . uv0 = uv0_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
    uv0 = outputs . uv0 ;
}
[ShaderES] name=ACENOPTransformPS version=200
#version 100
precision highp float;
#line 466
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedCMYKtoCMYKPS version=200
#version 100
precision highp float;
#line 494
uniform sampler2D ACEOptCMYKtoCMYK12Table ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptCMYKtoCMYK12 ( inout vec4 color )
{
    float val = color . a * 15.0 ;
    float idx = floor ( val ) ;
    float frc = val - idx ;
    vec2 rg = ( vec2 ( 0.5 , 0.5 ) + 15.0 * color . rg ) / 16.0 ;
    float b0 = ( 0.5 + 15.0 * color . b + 16.0 * idx ) / 256.0 ;
    float b1 = b0 + 16.0 / 256.0 ;
    vec4 k0 = vec4 ( rg , b0 , 0.0 ) ;
    vec4 k1 = vec4 ( rg , b1 , 0.0 ) ;
    k0 = texture2D ( ACEOptCMYKtoCMYK12Table , ( k0 . rgb ) . xy ) ;
    k1 = texture2D ( ACEOptCMYKtoCMYK12Table , ( k1 . rgb ) . xy ) ;
    color = mix ( k0 , k1 , frc ) ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptCMYKtoCMYK12 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedCMYKtoRGBPS version=200
#version 100
precision highp float;
#line 538
uniform sampler2D ACEOptCMYKtoRGB10Table ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptCMYKtoRGB10 ( inout vec4 color )
{
    float val = color . a * 8.0 ;
    float idx = floor ( val ) ;
    float frc = val - idx ;
    vec2 rg = ( vec2 ( 0.5 , 0.5 ) + 8.0 * color . rg ) / 16.0 ;
    float b0 = ( 0.5 + 8.0 * color . b + 9.0 * idx ) / 128.0 ;
    float b1 = b0 + 9.0 / 128.0 ;
    vec3 k0 = vec3 ( rg , b0 ) ;
    vec3 k1 = vec3 ( rg , b1 ) ;
    k0 = texture2D ( ACEOptCMYKtoRGB10Table , ( k0 ) . xy ) . rgb ;
    k1 = texture2D ( ACEOptCMYKtoRGB10Table , ( k1 ) . xy ) . rgb ;
    color . rgb = mix ( k0 , k1 , frc ) ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptCMYKtoRGB10 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedCMYKtoXYZPS version=200
#version 100
precision highp float;
#line 582
uniform sampler2D ACEOptCMYKtoXYZ8Curves ;
uniform sampler2D ACEOptCMYKtoXYZ8Table ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptCMYKtoXYZ8 ( inout vec4 color )
{
    color = ( vec4 ( 0.5 , 0.5 , 0.5 , 0.5 ) + 255.0 * color ) / 256.0 ;
    color . r = texture2D ( ACEOptCMYKtoXYZ8Curves , vec2 ( color . r , 0.0 ) ) . r ;
    color . g = texture2D ( ACEOptCMYKtoXYZ8Curves , vec2 ( color . g , 0.0 ) ) . g ;
    color . b = texture2D ( ACEOptCMYKtoXYZ8Curves , vec2 ( color . b , 0.0 ) ) . b ;
    color . a = texture2D ( ACEOptCMYKtoXYZ8Curves , vec2 ( color . a , 0.0 ) ) . a ;
    float val = color . a * 8.0 ;
    float idx = floor ( val ) ;
    float frc = val - idx ;
    vec2 rg = ( vec2 ( 0.5 , 0.5 ) + 8.0 * color . rg ) / 16.0 ;
    float b0 = ( 0.5 + 8.0 * color . b + 9.0 * idx ) / 128.0 ;
    float b1 = b0 + 9.0 / 128.0 ;
    vec3 k0 = vec3 ( rg , b0 ) ;
    vec3 k1 = vec3 ( rg , b1 ) ;
    k0 = texture2D ( ACEOptCMYKtoXYZ8Table , ( k0 . rgb ) . xy ) . rgb ;
    k1 = texture2D ( ACEOptCMYKtoXYZ8Table , ( k1 . rgb ) . xy ) . rgb ;
    color . rgb = mix ( k0 , k1 , frc ) ;
    color . r = ( color . r * 100.0 + 16.0 ) / 116.0 ;
    color . g = ( 255.0 * color . g - 128.0 ) / 500.0 ;
    color . b = ( 255.0 * color . b - 128.0 ) / 200.0 ;
    vec3 xyz ;
    xyz . r = color . r + color . g ;
    xyz . g = color . r ;
    xyz . b = color . r - color . b ;
    float brk = 6.0 / 29.0 ;
    float scale = 108.0 / 841.0 ;
    float offset = 4.0 / 29.0 ;
    if ( xyz . r >= brk ) color . r = pow ( xyz . r , 3.0 ) ;
    else color . r = scale * ( xyz . r - offset ) ;
    if ( xyz . g >= brk ) color . g = pow ( xyz . g , 3.0 ) ;
    else color . g = scale * ( xyz . g - offset ) ;
    if ( xyz . b >= brk ) color . b = pow ( xyz . b , 3.0 ) ;
    else color . b = scale * ( xyz . b - offset ) ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptCMYKtoXYZ8 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedGamutCMYKPS version=200
#version 100
precision highp float;
#line 648
uniform sampler2D ACEOptCMYKGamut22Table ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptCMYKGamut22 ( inout vec4 color )
{
    float val = color . a * 15.0 ;
    float idx = floor ( val ) ;
    float frc = val - idx ;
    vec2 rg = ( vec2 ( 0.5 , 0.5 ) + 15.0 * color . rg ) / 16.0 ;
    float b0 = ( 0.5 + 15.0 * color . b + 16.0 * idx ) / 256.0 ;
    float b1 = b0 + 16.0 / 256.0 ;
    vec4 k0 = vec4 ( rg , b0 , 0.0 ) ;
    vec4 k1 = vec4 ( rg , b1 , 0.0 ) ;
    k0 = texture2D ( ACEOptCMYKGamut22Table , ( k0 . rgb ) . xy ) ;
    k1 = texture2D ( ACEOptCMYKGamut22Table , ( k1 . rgb ) . xy ) ;
    color = mix ( k0 , k1 , frc ) ;
    color = ( color . r >= 128.0 / 255.0 ) ? vec4 ( 1 , 1 , 1 , 1 ) : vec4 ( 0 , 0 , 0 , 0 ) ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptCMYKGamut22 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedGamutRGBPS version=200
#version 100
precision highp float;
#line 693
uniform sampler2D ACEOptRGBGamut21Table ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptRGBGamut21 ( inout vec4 color )
{
    color . rgb = clamp ( ( color . rgb ) , 0.0 , 1.0 ) ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 31.0 * color . rgb ) / 32.0 ;
    color . rgb = texture2D ( ACEOptRGBGamut21Table , ( color . rgb ) . xy ) . rgb ;
    color . rgb = ( color . r >= 128.0 / 255.0 ) ? vec3 ( 1 , 1 , 1 ) : vec3 ( 0 , 0 , 0 ) ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptRGBGamut21 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedGrayTo32PS version=200
#version 100
precision highp float;
#line 730
uniform sampler2D ACEOptGrayToRGB19Curves ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptGrayToRGB19 ( inout vec4 color )
{
    color . rgb = clamp ( ( color . rgb ) , 0.0 , 1.0 ) ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 255.0 * color . rgb ) / 256.0 ;
    color . rgb = texture2D ( ACEOptGrayToRGB19Curves , vec2 ( color . r , 0.0 ) ) . rgb ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptGrayToRGB19 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedGrayToXYPS version=200
#version 100
precision highp float;
#line 766
uniform sampler2D ACEOptGrayToXYZ13Curves ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptGrayToXYZ13 ( inout vec4 color )
{
    color . rgb = clamp ( ( color . rgb ) , 0.0 , 1.0 ) ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 255.0 * color . rgb ) / 256.0 ;
    color . rgb = texture2D ( ACEOptGrayToXYZ13Curves , vec2 ( color . r , 0.0 ) ) . rgb ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptGrayToXYZ13 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedLabGamutPS version=200
#version 100
precision highp float;
#line 802
uniform sampler2D ACEOptLabGamut20Table ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptLabGamut20 ( inout vec4 color )
{
    color . rgb = clamp ( ( color . rgb ) , 0.0 , 1.0 ) ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 32.0 * color . rgb ) / 64.0 ;
    color . rgb = texture2D ( ACEOptLabGamut20Table , ( color . rgb ) . xy ) . rgb ;
    color . rgb = ( color . r >= 128.0 / 255.0 ) ? vec3 ( 1 , 1 , 1 ) : vec3 ( 0 , 0 , 0 ) ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptLabGamut20 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedLabToRGBPS version=200
#version 100
precision highp float;
#line 839
uniform sampler2D ACEOptLabToRGB2Table ;
uniform sampler2D ACEOptLabToRGB2Curves ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptLabToRGB2 ( inout vec4 color )
{
    color . rgb = clamp ( ( color . rgb ) , 0.0 , 1.0 ) ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 24.0 * color . rgb ) / 32.0 ;
    color . rgb = texture2D ( ACEOptLabToRGB2Table , ( color . rgb ) . xy ) . rgb ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 255.0 * color . rgb ) / 256.0 ;
    color . r = texture2D ( ACEOptLabToRGB2Curves , vec2 ( color . r , 0.0 ) ) . r ;
    color . g = texture2D ( ACEOptLabToRGB2Curves , vec2 ( color . g , 0.0 ) ) . g ;
    color . b = texture2D ( ACEOptLabToRGB2Curves , vec2 ( color . b , 0.0 ) ) . b ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptLabToRGB2 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedMatrixRGBToRGB_1DPS version=200
#version 100
precision highp float;
#line 880
uniform mat3 ACEOptMatrixRGBtoRGB17Matrix ;
uniform sampler2D ACEOptMatrixRGBtoRGB17InCurves ;
uniform sampler2D ACEOptMatrixRGBtoRGB17OutCurves ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptMatrixRGBtoRGB17 ( inout vec4 color )
{
    color . rgb = clamp ( ( color . rgb ) , 0.0 , 1.0 ) ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 255.0 * color . rgb ) / 256.0 ;
    color . r = texture2D ( ACEOptMatrixRGBtoRGB17InCurves , vec2 ( color . r , 0.0 ) ) . r ;
    color . g = texture2D ( ACEOptMatrixRGBtoRGB17InCurves , vec2 ( color . g , 0.0 ) ) . g ;
    color . b = texture2D ( ACEOptMatrixRGBtoRGB17InCurves , vec2 ( color . b , 0.0 ) ) . b ;
    color . rgb = ( ( ACEOptMatrixRGBtoRGB17Matrix ) * ( color . rgb ) ) ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 2047.0 * color . rgb ) / 2048.0 ;
    color . r = texture2D ( ACEOptMatrixRGBtoRGB17OutCurves , vec2 ( color . r , 0.0 ) ) . r ;
    color . g = texture2D ( ACEOptMatrixRGBtoRGB17OutCurves , vec2 ( color . g , 0.0 ) ) . g ;
    color . b = texture2D ( ACEOptMatrixRGBtoRGB17OutCurves , vec2 ( color . b , 0.0 ) ) . b ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptMatrixRGBtoRGB17 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedMatrixRGBToRGB_2DPS version=200
#version 100
precision highp float;
#line 925
uniform mat3 ACEOptMatrixRGBtoRGB17Matrix ;
uniform sampler2D ACEOptMatrixRGBtoRGB17InCurves ;
uniform sampler2D ACEOptMatrixRGBtoRGB17OutCurves ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptMatrixRGBtoRGB17 ( inout vec4 color )
{
    color . rgb = clamp ( ( color . rgb ) , 0.0 , 1.0 ) ;
    float texture_width = 16.0 , texture_height = 16.0 ;
    vec3 y1 = floor ( ( 255.0 * color . rgb ) / texture_width ) ;
    vec3 x1 = floor ( 255.0 * color . rgb ) - y1 * texture_width ;
    y1 = ( vec3 ( 0.5 , 0.5 , 0.5 ) + y1 ) / texture_height ;
    x1 = ( vec3 ( 0.5 , 0.5 , 0.5 ) + x1 ) / texture_width ;
    color . r = texture2D ( ACEOptMatrixRGBtoRGB17InCurves , vec2 ( x1 . r , y1 . r ) ) . r ;
    color . g = texture2D ( ACEOptMatrixRGBtoRGB17InCurves , vec2 ( x1 . g , y1 . g ) ) . g ;
    color . b = texture2D ( ACEOptMatrixRGBtoRGB17InCurves , vec2 ( x1 . b , y1 . b ) ) . b ;
    color . rgb = ( ( ACEOptMatrixRGBtoRGB17Matrix ) * ( color . rgb ) ) ;
    texture_width = 64.0 ;
    texture_height = 32.0 ;
    vec3 y2 = floor ( ( 2047.0 * color . rgb ) / texture_width ) ;
    vec3 x2 = floor ( 2047.0 * color . rgb ) - y2 * texture_width ;
    y2 = ( vec3 ( 0.5 , 0.5 , 0.5 ) + y2 ) / texture_height ;
    x2 = ( vec3 ( 0.5 , 0.5 , 0.5 ) + x2 ) / texture_width ;
    color . r = texture2D ( ACEOptMatrixRGBtoRGB17OutCurves , vec2 ( x2 . r , y2 . r ) ) . r ;
    color . g = texture2D ( ACEOptMatrixRGBtoRGB17OutCurves , vec2 ( x2 . g , y2 . g ) ) . g ;
    color . b = texture2D ( ACEOptMatrixRGBtoRGB17OutCurves , vec2 ( x2 . b , y2 . b ) ) . b ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptMatrixRGBtoRGB17 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedMatrixRGBToXYZ_1DPS version=200
#version 100
precision highp float;
#line 979
uniform mat3 ACEOptMatrixRGBtoXYZ16Matrix ;
uniform sampler2D ACEOptMatrixRGBtoXYZ16Curves ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptMatrixRGBtoXYZ16 ( inout vec4 color )
{
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 255.0 * color . rgb ) / 256.0 ;
    color . r = texture2D ( ACEOptMatrixRGBtoXYZ16Curves , vec2 ( color . r , 0.0 ) ) . r ;
    color . g = texture2D ( ACEOptMatrixRGBtoXYZ16Curves , vec2 ( color . g , 0.0 ) ) . g ;
    color . b = texture2D ( ACEOptMatrixRGBtoXYZ16Curves , vec2 ( color . b , 0.0 ) ) . b ;
    color . rgb = ( ( ACEOptMatrixRGBtoXYZ16Matrix ) * ( color . rgb ) ) ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptMatrixRGBtoXYZ16 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedMatrixRGBToXYZ_2DPS version=200
#version 100
precision highp float;
#line 1018
uniform mat3 ACEOptMatrixRGBtoXYZ16Matrix ;
uniform sampler2D ACEOptMatrixRGBtoXYZ16Curves ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptMatrixRGBtoXYZ16 ( inout vec4 color )
{
    float texture_width = 16.0 , texture_height = 16.0 ;
    vec3 y = floor ( ( 255.0 * color . rgb ) / texture_width ) ;
    vec3 x = floor ( 255.0 * color . rgb ) - y * texture_width ;
    y = ( vec3 ( 0.5 , 0.5 , 0.5 ) + y ) / texture_height ;
    x = ( vec3 ( 0.5 , 0.5 , 0.5 ) + x ) / texture_width ;
    color . r = texture2D ( ACEOptMatrixRGBtoXYZ16Curves , vec2 ( x . r , y . r ) ) . r ;
    color . g = texture2D ( ACEOptMatrixRGBtoXYZ16Curves , vec2 ( x . g , y . g ) ) . g ;
    color . b = texture2D ( ACEOptMatrixRGBtoXYZ16Curves , vec2 ( x . b , y . b ) ) . b ;
    color . rgb = ( ( ACEOptMatrixRGBtoXYZ16Matrix ) * ( color . rgb ) ) ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptMatrixRGBtoXYZ16 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedRGBToCMYKPS version=200
#version 100
precision highp float;
#line 1061
uniform sampler2D ACEOptRGBtoCMYK11Table ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptRGBtoCMYK11 ( inout vec4 color )
{
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 24.0 * color . rgb ) / 32.0 ;
    color = texture2D ( ACEOptRGBtoCMYK11Table , ( color . rgb ) . xy ) ;
    color = 1.0 - color ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptRGBtoCMYK11 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedRGBToGrayPS version=200
#version 100
precision highp float;
#line 1097
uniform sampler2D ACEOptRGBtoGray6Curves ;
uniform sampler2D ACEOptRGBtoGray6Table ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptRGBtoGray6 ( inout vec4 color )
{
    color . rgb = clamp ( ( color . rgb ) , 0.0 , 1.0 ) ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 255.0 * color . rgb ) / 256.0 ;
    color . r = texture2D ( ACEOptRGBtoGray6Curves , vec2 ( color . r , 0.0 ) ) . r ;
    color . g = texture2D ( ACEOptRGBtoGray6Curves , vec2 ( color . g , 0.0 ) ) . g ;
    color . b = texture2D ( ACEOptRGBtoGray6Curves , vec2 ( color . b , 0.0 ) ) . b ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 15.0 * color . rgb ) / 16.0 ;
    color . rgb = texture2D ( ACEOptRGBtoGray6Table , ( color . rgb ) . xy ) . rgb ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptRGBtoGray6 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedRGBToLabPS version=200
#version 100
precision highp float;
#line 1138
uniform sampler2D ACEOptRGBtoLab3Curves ;
uniform sampler2D ACEOptRGBtoLab3Table ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptRGBtoLab3 ( inout vec4 color )
{
    color . rgb = clamp ( ( color . rgb ) , 0.0 , 1.0 ) ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 255.0 * color . rgb ) / 256.0 ;
    color . r = texture2D ( ACEOptRGBtoLab3Curves , vec2 ( color . r , 0.0 ) ) . r ;
    color . g = texture2D ( ACEOptRGBtoLab3Curves , vec2 ( color . g , 0.0 ) ) . g ;
    color . b = texture2D ( ACEOptRGBtoLab3Curves , vec2 ( color . b , 0.0 ) ) . b ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 24.0 * color . rgb ) / 32.0 ;
    color . rgb = texture2D ( ACEOptRGBtoLab3Table , ( color . rgb ) . xy ) . rgb ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptRGBtoLab3 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedRGBToRGBPS version=200
#version 100
precision highp float;
#line 1179
uniform sampler2D ACEOptRGBtoRGB1Curves ;
uniform sampler2D ACEOptRGBtoRGB1Table ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptRGBtoRGB1 ( inout vec4 color )
{
    color . rgb = clamp ( ( color . rgb ) , 0.0 , 1.0 ) ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 255.0 * color . rgb ) / 256.0 ;
    color . r = texture2D ( ACEOptRGBtoRGB1Curves , vec2 ( color . r , 0.0 ) ) . r ;
    color . g = texture2D ( ACEOptRGBtoRGB1Curves , vec2 ( color . g , 0.0 ) ) . g ;
    color . b = texture2D ( ACEOptRGBtoRGB1Curves , vec2 ( color . b , 0.0 ) ) . b ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 15.0 * color . rgb ) / 16.0 ;
    color . rgb = texture2D ( ACEOptRGBtoRGB1Table , ( color . rgb ) . xy ) . rgb ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptRGBtoRGB1 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedRGBToRGBOverRangePS version=200
#version 100
precision highp float;
#line 1220
uniform sampler2D ACEOptMatrixRGBtoRGBOverRange14Curves ;
uniform sampler2D ACEOptMatrixRGBtoRGBOverRange14Table ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptMatrixRGBtoRGBOverRange14 ( inout vec4 color )
{
    color . rgb = clamp ( color . rgb , vec3 ( - 1.0 , - 1.0 , - 1.0 ) , vec3 ( 6.0 , 6.0 , 6.0 ) ) + 1.0 ;
    vec4 idx = floor ( color ) ;
    vec4 frc = color - idx ;
    vec4 color0 = ( idx + 0.5 ) / 8.0 ;
    vec4 color1 = ( idx + 1.5 ) / 8.0 ;
    color0 . r = texture2D ( ACEOptMatrixRGBtoRGBOverRange14Curves , vec2 ( color0 . r , 0.0 ) ) . r ;
    color0 . g = texture2D ( ACEOptMatrixRGBtoRGBOverRange14Curves , vec2 ( color0 . g , 0.0 ) ) . g ;
    color0 . b = texture2D ( ACEOptMatrixRGBtoRGBOverRange14Curves , vec2 ( color0 . b , 0.0 ) ) . b ;
    color1 . r = texture2D ( ACEOptMatrixRGBtoRGBOverRange14Curves , vec2 ( color1 . r , 0.0 ) ) . r ;
    color1 . g = texture2D ( ACEOptMatrixRGBtoRGBOverRange14Curves , vec2 ( color1 . g , 0.0 ) ) . g ;
    color1 . b = texture2D ( ACEOptMatrixRGBtoRGBOverRange14Curves , vec2 ( color1 . b , 0.0 ) ) . b ;
    color . rgb = mix ( color0 . rgb , color1 . rgb , frc . rgb ) ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 31.0 * color . rgb ) / 32.0 ;
    color . rgb = texture2D ( ACEOptMatrixRGBtoRGBOverRange14Table , ( color . rgb ) . xy ) . rgb ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptMatrixRGBtoRGBOverRange14 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedRGBToXYZPS version=200
#version 100
precision highp float;
#line 1268
uniform sampler2D ACEOptMatrixRGBtoXYZ5Curves ;
uniform sampler2D ACEOptMatrixRGBtoXYZ5Table ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptMatrixRGBtoXYZ5 ( inout vec4 color )
{
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 255.0 * color . rgb ) / 256.0 ;
    color . r = texture2D ( ACEOptMatrixRGBtoXYZ5Curves , vec2 ( color . r , 0.0 ) ) . r ;
    color . g = texture2D ( ACEOptMatrixRGBtoXYZ5Curves , vec2 ( color . g , 0.0 ) ) . g ;
    color . b = texture2D ( ACEOptMatrixRGBtoXYZ5Curves , vec2 ( color . b , 0.0 ) ) . b ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 24.0 * color . rgb ) / 32.0 ;
    color . rgb = texture2D ( ACEOptMatrixRGBtoXYZ5Table , ( color . rgb ) . xy ) . rgb ;
    color . r = ( color . r * 100.0 + 16.0 ) / 116.0 ;
    color . g = ( 255.0 * color . g - 128.0 ) / 500.0 ;
    color . b = ( 255.0 * color . b - 128.0 ) / 200.0 ;
    vec3 xyz ;
    xyz . r = color . r + color . g ;
    xyz . g = color . r ;
    xyz . b = color . r - color . b ;
    float brk = 6.0 / 29.0 ;
    float scale = 108.0 / 841.0 ;
    float offset = 4.0 / 29.0 ;
    if ( xyz . r >= brk ) color . r = pow ( xyz . r , 3.0 ) ;
    else color . r = scale * ( xyz . r - offset ) ;
    if ( xyz . g >= brk ) color . g = pow ( xyz . g , 3.0 ) ;
    else color . g = scale * ( xyz . g - offset ) ;
    if ( xyz . b >= brk ) color . b = pow ( xyz . b , 3.0 ) ;
    else color . b = scale * ( xyz . b - offset ) ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptMatrixRGBtoXYZ5 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedXYZToCMYKPS version=200
#version 100
precision highp float;
#line 1324
uniform sampler2D ACEOptXYZtoCMYK9Table ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptXYZtoCMYK9 ( inout vec4 color )
{
    float brk = 216.0 / 24389.0 ;
    float scale = 24389.0 / 27.0 ;
    if ( color . r >= brk ) color . r = 116.0 * pow ( color . r , 1.0 / 3.0 ) - 16.0 ;
    else color . r = color . r * scale ;
    if ( color . g >= brk ) color . g = 116.0 * pow ( color . g , 1.0 / 3.0 ) - 16.0 ;
    else color . g = color . g * scale ;
    if ( color . b >= brk ) color . b = 116.0 * pow ( color . b , 1.0 / 3.0 ) - 16.0 ;
    else color . b = color . b * scale ;
    vec3 xyz ;
    xyz . r = color . g / 100.0 ;
    xyz . g = ( ( 500.0 / 116.0 ) * ( color . r - color . g ) + 128.0 ) / 255.0 ;
    xyz . b = ( ( 200.0 / 116.0 ) * ( color . g - color . b ) + 128.0 ) / 255.0 ;
    color . rgb = clamp ( ( xyz . rgb ) , 0.0 , 1.0 ) ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 24.0 * color . rgb ) / 32.0 ;
    color = texture2D ( ACEOptXYZtoCMYK9Table , ( color . rgb ) . xy ) ;
    color = 1.0 - color ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptXYZtoCMYK9 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedXYZToMatrixRGB_1DPS version=200
#version 100
precision highp float;
#line 1373
uniform mat3 ACEOptXYZtoMatrixRGB15Matrix ;
uniform sampler2D ACEOptXYZtoMatrixRGB15Curves ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptXYZtoMatrixRGB15 ( inout vec4 color )
{
    color . rgb = ( ( ACEOptXYZtoMatrixRGB15Matrix ) * ( color . rgb ) ) ;
    color . rgb = clamp ( ( color . rgb ) , 0.0 , 1.0 ) ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 2047.0 * color . rgb ) / 2048.0 ;
    color . r = texture2D ( ACEOptXYZtoMatrixRGB15Curves , vec2 ( color . r , 0.0 ) ) . r ;
    color . g = texture2D ( ACEOptXYZtoMatrixRGB15Curves , vec2 ( color . g , 0.0 ) ) . g ;
    color . b = texture2D ( ACEOptXYZtoMatrixRGB15Curves , vec2 ( color . b , 0.0 ) ) . b ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptXYZtoMatrixRGB15 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedXYZToMatrixRGB_2DPS version=200
#version 100
precision highp float;
#line 1413
uniform mat3 ACEOptXYZtoMatrixRGB15Matrix ;
uniform sampler2D ACEOptXYZtoMatrixRGB15Curves ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptXYZtoMatrixRGB15 ( inout vec4 color )
{
    color . rgb = ( ( ACEOptXYZtoMatrixRGB15Matrix ) * ( color . rgb ) ) ;
    color . rgb = clamp ( ( color . rgb ) , 0.0 , 1.0 ) ;
    float texture_width = 64.0 , texture_height = 32.0 ;
    vec3 y = floor ( ( 2047.0 * color . rgb ) / texture_width ) ;
    vec3 x = floor ( 2047.0 * color . rgb ) - y * texture_width ;
    y = ( vec3 ( 0.5 , 0.5 , 0.5 ) + y ) / texture_height ;
    x = ( vec3 ( 0.5 , 0.5 , 0.5 ) + x ) / texture_width ;
    color . r = texture2D ( ACEOptXYZtoMatrixRGB15Curves , vec2 ( x . r , y . r ) ) . r ;
    color . g = texture2D ( ACEOptXYZtoMatrixRGB15Curves , vec2 ( x . g , y . g ) ) . g ;
    color . b = texture2D ( ACEOptXYZtoMatrixRGB15Curves , vec2 ( x . b , y . b ) ) . b ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptXYZtoMatrixRGB15 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEOptimizedXYZToRGBPS version=200
#version 100
precision highp float;
#line 1457
uniform sampler2D ACEOptXYZtoMatrixRGB4Table ;
uniform sampler2D ACEOptXYZtoMatrixRGB4Curves ;
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEOptXYZtoMatrixRGB4 ( inout vec4 color )
{
    float brk = 216.0 / 24389.0 ;
    float scale = 24389.0 / 27.0 ;
    if ( color . r >= brk ) color . r = 116.0 * pow ( color . r , 1.0 / 3.0 ) - 16.0 ;
    else color . r = color . r * scale ;
    if ( color . g >= brk ) color . g = 116.0 * pow ( color . g , 1.0 / 3.0 ) - 16.0 ;
    else color . g = color . g * scale ;
    if ( color . b >= brk ) color . b = 116.0 * pow ( color . b , 1.0 / 3.0 ) - 16.0 ;
    else color . b = color . b * scale ;
    vec3 xyz ;
    xyz . r = color . g / 100.0 ;
    xyz . g = ( ( 500.0 / 116.0 ) * ( color . r - color . g ) + 128.0 ) / 255.0 ;
    xyz . b = ( ( 200.0 / 116.0 ) * ( color . g - color . b ) + 128.0 ) / 255.0 ;
    color . rgb = clamp ( ( xyz . rgb ) , 0.0 , 1.0 ) ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 24.0 * color . rgb ) / 32.0 ;
    color . rgb = texture2D ( ACEOptXYZtoMatrixRGB4Table , ( color . rgb ) . xy ) . rgb ;
    color . rgb = ( vec3 ( 0.5 , 0.5 , 0.5 ) + 255.0 * color . rgb ) / 256.0 ;
    color . r = texture2D ( ACEOptXYZtoMatrixRGB4Curves , vec2 ( color . r , 0.0 ) ) . r ;
    color . g = texture2D ( ACEOptXYZtoMatrixRGB4Curves , vec2 ( color . g , 0.0 ) ) . g ;
    color . b = texture2D ( ACEOptXYZtoMatrixRGB4Curves , vec2 ( color . b , 0.0 ) ) . b ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEOptXYZtoMatrixRGB4 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=ACEStandardLabToXYZPS version=200
#version 100
precision highp float;
#line 1510
uniform sampler2D myTexture ;
varying vec2 uv0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void ACEStdLabToXYZ7 ( inout vec4 color )
{
    color . rgb = clamp ( ( color . rgb ) , 0.0 , 1.0 ) ;
    color . r = ( color . r * 100.0 + 16.0 ) / 116.0 ;
    color . g = ( 255.0 * color . g - 128.0 ) / 500.0 ;
    color . b = ( 255.0 * color . b - 128.0 ) / 200.0 ;
    vec3 xyz ;
    xyz . r = color . r + color . g ;
    xyz . g = color . r ;
    xyz . b = color . r - color . b ;
    float brk = 6.0 / 29.0 ;
    float scale = 108.0 / 841.0 ;
    float offset = 4.0 / 29.0 ;
    if ( xyz . r >= brk ) color . r = pow ( xyz . r , 3.0 ) ;
    else color . r = scale * ( xyz . r - offset ) ;
    if ( xyz . g >= brk ) color . g = pow ( xyz . g , 3.0 ) ;
    else color . g = scale * ( xyz . g - offset ) ;
    if ( xyz . b >= brk ) color . b = pow ( xyz . b , 3.0 ) ;
    else color . b = scale * ( xyz . b - offset ) ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = texture2D ( myTexture , inputs . uv0 ) ;
    ACEStdLabToXYZ7 ( outputs . target0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[Material]  name=Shared vs=SharedVS ps=SharedPS
[Material]  name=TestShader vs=TestShaderVS ps=TestShaderPS
[Material] name=DrawQuad vs=DrawQuadVS ps=DrawQuadPS
[Material] name=DrawTexQuad vs=DrawQuadVS ps=DrawTexQuadPS
[Material] name=DrawText vs=DrawQuadVS ps=DrawTextPS
[Material] name=FallbackWorld vs=FallbackWorldVS ps=FallbackPS
[Material] name=FallbackModel vs=FallbackModelVS ps=FallbackPS
[Material]  name=ACENOPTransform vs=AceVS ps=ACENOPTransformPS
[Material]  name=ACEOptimizedCMYKtoCMYK vs=AceVS ps=ACEOptimizedCMYKtoCMYKPS
[Material]  name=ACEOptimizedCMYKtoRGB vs=AceVS ps=ACEOptimizedCMYKtoRGBPS
[Material]  name=ACEOptimizedCMYKtoXYZ vs=AceVS ps=ACEOptimizedCMYKtoXYZPS
[Material]  name=ACEOptimizedGamutCMYK vs=AceVS ps=ACEOptimizedGamutCMYKPS
[Material]  name=ACEOptimizedGamutRGB vs=AceVS ps=ACEOptimizedGamutRGBPS
[Material]  name=ACEOptimizedGrayTo32 vs=AceVS ps=ACEOptimizedGrayTo32PS
[Material]  name=ACEOptimizedGrayToXY vs=AceVS ps=ACEOptimizedGrayToXYPS
[Material]  name=ACEOptimizedLabGamut vs=AceVS ps=ACEOptimizedLabGamutPS
[Material]  name=ACEOptimizedLabToRGB vs=AceVS ps=ACEOptimizedLabToRGBPS
[Material]  name=ACEOptimizedMatrixRGBToRGB_1D vs=AceVS ps=ACEOptimizedMatrixRGBToRGB_1DPS
[Material]  name=ACEOptimizedMatrixRGBToRGB_2D vs=AceVS ps=ACEOptimizedMatrixRGBToRGB_2DPS
[Material]  name=ACEOptimizedMatrixRGBToXYZ_1D vs=AceVS ps=ACEOptimizedMatrixRGBToXYZ_1DPS
[Material]  name=ACEOptimizedMatrixRGBToXYZ_2D vs=AceVS ps=ACEOptimizedMatrixRGBToXYZ_2DPS
[Material]  name=ACEOptimizedRGBToCMYK vs=AceVS ps=ACEOptimizedRGBToCMYKPS
[Material]  name=ACEOptimizedRGBToGray vs=AceVS ps=ACEOptimizedRGBToGrayPS
[Material]  name=ACEOptimizedRGBToLab vs=AceVS ps=ACEOptimizedRGBToLabPS
[Material]  name=ACEOptimizedRGBToRGB vs=AceVS ps=ACEOptimizedRGBToRGBPS
[Material]  name=ACEOptimizedRGBToRGBOverRange vs=AceVS ps=ACEOptimizedRGBToRGBOverRangePS
[Material]  name=ACEOptimizedRGBToXYZ vs=AceVS ps=ACEOptimizedRGBToXYZPS
[Material]  name=ACEOptimizedXYZToCMYK vs=AceVS ps=ACEOptimizedXYZToCMYKPS
[Material]  name=ACEOptimizedXYZToMatrixRGB_1D vs=AceVS ps=ACEOptimizedXYZToMatrixRGB_1DPS
[Material]  name=ACEOptimizedXYZToMatrixRGB_2D vs=AceVS ps=ACEOptimizedXYZToMatrixRGB_2DPS
[Material]  name=ACEOptimizedXYZToRGB vs=AceVS ps=ACEOptimizedXYZToRGBPS
[Material]  name=ACEStandardLabToXYZ vs=AceVS ps=ACEStandardLabToXYZPS
