[ShaderGL] name=SharedVS version=330
#version 330
#line 3
uniform mat4 modelToWorldTfm ;
uniform mat4 worldToViewTfm ;
uniform mat4 viewToClipTfm ;
uniform mat4 worldToClipTfm ;
uniform mat4 modelToClipTfm ;
uniform float debugCycles ;
layout ( location = 0 ) in vec4 position_ ;
struct Inputs
{
    vec4 position ;
}
;
struct Outputs
{
    vec4 positiont ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    vec4 pos = inputs . position ;
    pos = ( ( pos ) * ( modelToWorldTfm ) ) ;
    pos = ( ( pos ) * ( worldToViewTfm ) ) ;
    pos = ( ( pos ) * ( viewToClipTfm ) ) ;
    pos = ( ( pos ) * ( worldToClipTfm ) ) ;
    pos = ( ( pos ) * ( modelToClipTfm ) ) ;
    pos . x *= debugCycles ;
    outputs . positiont = pos ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
}
[ShaderGL] name=SharedPS version=330
#version 330
#line 42
layout ( location = 0 ) out vec4 target0 ;
struct Inputs
{
    vec4 positiont ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = vec4 ( 0 , 0 , 0 , 0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . positiont = gl_FragCoord ;
    MainPS ( inputs , outputs ) ;
    target0 = outputs . target0 ;
}
[ShaderGL] name=TestShaderVS version=330
#version 330
#line 68
uniform vec2 foregroundInverseSize ;
uniform vec2 videoInverseSize ;
layout ( location = 0 ) in vec4 position_ ;
layout ( location = 1 ) in vec2 uv0_ ;
layout ( location = 2 ) in vec2 uv1_ ;
out vec2 uv0 ;
out vec2 uv1 ;
struct Inputs
{
    vec4 position ;
    vec2 uv0 ;
    vec2 uv1 ;
}
;
struct Outputs
{
    vec4 positiont ;
    vec2 uv0 ;
    vec2 uv1 ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    outputs . uv0 . xy = inputs . uv0 . xy * foregroundInverseSize ;
    outputs . uv1 . xy = inputs . uv1 . xy * videoInverseSize ;
    outputs . positiont = inputs . position ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    inputs . uv0 = uv0_ ;
    inputs . uv1 = uv1_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
    uv0 = outputs . uv0 ;
    uv1 = outputs . uv1 ;
}
[ShaderGL] name=TestShaderPS version=330
#version 330
#line 110
uniform vec2 foregroundInverseSize ;
uniform vec2 videoInverseSize ;
uniform sampler2D colorTexture ;
uniform sampler3D volumeTexture ;
in vec2 uv0 ;
in vec2 uv1 ;
layout ( location = 0 ) out vec4 target0 ;
struct Inputs
{
    vec4 positiont ;
    vec2 uv0 ;
    vec2 uv1 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
vec4 DoFunction1 ( in vec4 val )
{
    return val ;
}
void DoFunction2 ( in vec4 val , out vec4 newval )
{
    newval = val ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = DoFunction1 ( vec4 ( inputs . uv0 . xy , 0 , 1 ) ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . positiont = gl_FragCoord ;
    inputs . uv0 = uv0 ;
    inputs . uv1 = uv1 ;
    MainPS ( inputs , outputs ) ;
    target0 = outputs . target0 ;
}
[ShaderGL] name=DrawQuadVS version=330
#version 330
#line 154
uniform mat4 worldToClipTfm ;
layout ( location = 0 ) in vec3 position_ ;
layout ( location = 1 ) in vec2 uv0_ ;
layout ( location = 7 ) in vec4 color_ ;
out vec2 uv0 ;
out vec4 color ;
struct Inputs
{
    vec3 position ;
    vec2 uv0 ;
    vec4 color ;
}
;
struct Outputs
{
    vec4 positiont ;
    vec2 uv0 ;
    vec4 color ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    outputs . uv0 = inputs . uv0 ;
    outputs . color = inputs . color ;
    outputs . positiont = vec4 ( inputs . position , 1.0 ) ;
    outputs . positiont = ( ( outputs . positiont ) * ( worldToClipTfm ) ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    inputs . uv0 = uv0_ ;
    inputs . color = color_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
    uv0 = outputs . uv0 ;
    color = outputs . color ;
}
[ShaderGL] name=DrawQuadPS version=330
#version 330
#line 196
in vec2 uv0 ;
in vec4 color ;
layout ( location = 0 ) out vec4 target0 ;
struct Inputs
{
    vec4 positiont ;
    vec2 uv0 ;
    vec4 color ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = inputs . color ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . positiont = gl_FragCoord ;
    inputs . uv0 = uv0 ;
    inputs . color = color ;
    MainPS ( inputs , outputs ) ;
    target0 = outputs . target0 ;
}
[ShaderGL] name=DrawTexQuadPS version=330
#version 330
#line 228
uniform sampler2D colorTexture ;
in vec2 uv0 ;
in vec4 color ;
layout ( location = 0 ) out vec4 target0 ;
struct Inputs
{
    vec4 positiont ;
    vec2 uv0 ;
    vec4 color ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = inputs . color * texture ( colorTexture , inputs . uv0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . positiont = gl_FragCoord ;
    inputs . uv0 = uv0 ;
    inputs . color = color ;
    MainPS ( inputs , outputs ) ;
    target0 = outputs . target0 ;
}
[ShaderGL] name=DrawTextPS version=330
#version 330
#line 261
uniform sampler2D colorTexture ;
in vec2 uv0 ;
in vec4 color ;
layout ( location = 0 ) out vec4 target0 ;
struct Inputs
{
    vec4 positiont ;
    vec2 uv0 ;
    vec4 color ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    vec4 c = texture ( colorTexture , inputs . uv0 . xy ) ;
    c = c . rrrr ;
    if ( ( c . a * inputs . color . a - 40.5 / 255.0 ) < 0.0 ) discard ;
    c *= inputs . color ;
    outputs . target0 = c ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . positiont = gl_FragCoord ;
    inputs . uv0 = uv0 ;
    inputs . color = color ;
    MainPS ( inputs , outputs ) ;
    target0 = outputs . target0 ;
}
[ShaderGL] name=FallbackWorldVS version=330
#version 330
#line 298
uniform mat4 worldToClipTfm ;
uniform float debugCycles ;
layout ( location = 0 ) in vec3 position_ ;
out vec4 color ;
struct Inputs
{
    vec3 position ;
}
;
struct Outputs
{
    vec4 positiont ;
    vec4 color ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    outputs . positiont = vec4 ( inputs . position . xyz , 1.0 ) ;
    outputs . positiont = ( ( outputs . positiont ) * ( worldToClipTfm ) ) ;
    outputs . color = vec4 ( debugCycles + 0.2 , 0.0 , 0.0 , 1.0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
    color = outputs . color ;
}
[ShaderGL] name=FallbackModelVS version=330
#version 330
#line 331
uniform mat4 modelToClipTfm ;
uniform float debugCycles ;
layout ( location = 0 ) in vec3 position_ ;
out vec4 color ;
struct Inputs
{
    vec3 position ;
}
;
struct Outputs
{
    vec4 positiont ;
    vec4 color ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    outputs . positiont = vec4 ( inputs . position . xyz , 1.0 ) ;
    outputs . positiont = ( ( outputs . positiont ) * ( modelToClipTfm ) ) ;
    outputs . color = vec4 ( debugCycles + 0.2 , 0.0 , 0.0 , 1.0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
    color = outputs . color ;
}
[ShaderGL] name=FallbackPS version=330
#version 330
#line 364
in vec4 color ;
layout ( location = 0 ) out vec4 target0 ;
struct Inputs
{
    vec4 positiont ;
    vec4 color ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = inputs . color ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . positiont = gl_FragCoord ;
    inputs . color = color ;
    MainPS ( inputs , outputs ) ;
    target0 = outputs . target0 ;
}
[ShaderGL] name=DynDrawVDVS version=330
#version 330
#line 393
layout ( location = 0 ) in vec3 position_ ;
layout ( location = 1 ) in vec2 uv0_ ;
layout ( location = 7 ) in vec4 color_ ;
struct Inputs
{
    vec3 position ;
    vec2 uv0 ;
    vec4 color ;
}
;
struct Outputs
{
    vec4 positiont ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    outputs . positiont = vec4 ( inputs . position . xyz , 1.0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    inputs . uv0 = uv0_ ;
    inputs . color = color_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
}
[ShaderGL] name=ACRPipeVS version=330
#version 330
#line 425
uniform mat4 modelToClipTfm ;
layout ( location = 0 ) in vec3 position_ ;
layout ( location = 7 ) in vec4 color_ ;
layout ( location = 1 ) in vec2 uv0_ ;
out vec4 color ;
out vec2 uv0 ;
struct Inputs
{
    vec3 position ;
    vec4 color ;
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 positiont ;
    vec4 color ;
    vec2 uv0 ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    outputs . positiont = ( ( vec4 ( inputs . position , 1.0 ) ) * ( modelToClipTfm ) ) ;
    outputs . uv0 = inputs . uv0 ;
    outputs . color = inputs . color ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    inputs . color = color_ ;
    inputs . uv0 = uv0_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
    color = outputs . color ;
    uv0 = outputs . uv0 ;
}
[ShaderGL] name=ACRPipePS version=330
#version 330
#line 466
const vec3 kWeights = vec3 ( 0.25 , 0.5 , 0.25 ) ;
const int kVisNormal = 0 ;
const int kVisClarity = 1 ;
const int kVisFillLight = 2 ;
const int kVisGrain = 3 ;
const float kBigTableRow_ToneCurve = 0.5 / 6.0 ;
const float kBigTableRow_FillLightCurve = 1.5 / 6.0 ;
const float kBigTableRow_ProfileWarp0 = 2.5 / 6.0 ;
const float kBigTableRow_ProfileWarp1 = 3.5 / 6.0 ;
const float kBigTableRow_ProfileWarp2 = 4.5 / 6.0 ;
const float kBigTableRow_ProfileVignette = 5.5 / 6.0 ;
const float kBigTableCol_First = 0.5 / 4096.0 ;
const float kBigTableCol_Last = 4095.5 / 4096.0 ;
const int kMaxGradients = 16 ;
const float kLocalExposureScale = 4.0 ;
uniform int uVisMode ;
uniform vec2 uDefaultCropSize ;
uniform vec2 uStage3Size ;
uniform vec2 uToDefaultCropScale ;
uniform vec2 uToDefaultCropOffset ;
uniform float uRenderScale ;
uniform vec3 uWhiteBalance ;
uniform mat3 uWBSelectorMatrix ;
uniform mat3 uABC2RGB ;
uniform float uWhiteBalanceRecover ;
uniform float uWhiteBalanceColorLimit ;
uniform vec3 uRampSlope ;
uniform vec3 uRampBlack ;
uniform vec3 uRampRadius ;
uniform vec3 uRampScale ;
uniform mat3 uSaturationMatrix ;
uniform float uVibrance ;
uniform bool uHasFillLight ;
uniform bool uHasLocalContrast ;
uniform float uClarityAmount ;
uniform bool uHasDenoise ;
uniform float uLumaDenoiseAmount ;
uniform mat3 uDenoiseRGBtoYCC ;
uniform mat3 uDenoiseYCCtoRGB ;
uniform float uDenoiseCurveIntegratedScale ;
uniform float uDenoiseCurveIntegratedOffset ;
uniform float uDenoiseCurveNoiseScale ;
uniform float uDenoiseCurveNoiseOffset ;
uniform bool uHasHSL ;
uniform bool uConvertToGray ;
uniform vec2 uHSLGrayCoords ;
uniform vec4 uHSLGrayRows ;
uniform float uToneContrastSplit ;
uniform bool uHasSplitTone ;
uniform float uSplitToneBalanceMapAlpha ;
uniform vec3 uSplitToneShadowFactor ;
uniform vec3 uSplitToneDeltaFactor ;
uniform bool uHasPostCropVignetteHighlightPriority ;
uniform bool uHasPostCropVignetteColorPriority ;
uniform bool uHasPostCropVignettePaintOverlay ;
uniform float uPostCropVignetteAmount ;
uniform float uPostCropVignetteMidpoint ;
uniform float uPostCropVignetteFeather ;
uniform float uPostCropVignetteRoundness ;
uniform float uPostCropVignetteHighlightContrast ;
uniform float uPostCropVignetteEllipseA ;
uniform float uPostCropVignetteEllipseB ;
uniform float uPostCropVignetteEllipseC ;
uniform float uPostCropVignetteEllipseD ;
uniform float uPostCropVignetteEllipseE ;
uniform mat3 uPostCropVignetteCropTransform ;
uniform float uPostCropVignetteCropAspectRatio ;
uniform bool uBlendStyleLensVignette ;
uniform bool uHasGrain ;
uniform float uGrainAmount ;
uniform bool uHasProfileWarp ;
uniform vec2 uProfileWarpCenter ;
uniform vec2 uProfileWarpToTable ;
uniform vec2 uProfileWarpFromTable ;
uniform bool uHasLensProfileVignette ;
uniform vec2 uVignetteProfileScale ;
uniform vec2 uVignetteProfileOffset ;
uniform float uLensVignetteAmount ;
uniform float uLensVignetteMidpoint ;
uniform vec3 uCAScale ;
uniform float uManualDistortB ;
uniform vec2 uNormalizeDistance ;
uniform mat3 uPerspectiveMatrix ;
uniform bool uShowShadowWarning ;
uniform bool uShowHighlightWarning ;
uniform bool uHasHueSatMap ;
uniform bool uHasLookTable ;
uniform vec3 uHueSatMapCoordsFirst ;
uniform vec3 uHueSatMapCoordsLast ;
uniform vec3 uLookTableCoordsFirst ;
uniform vec3 uLookTableCoordsLast ;
uniform bool uHasGradients ;
uniform int uNumGradients ;
uniform vec4 uGradients [ kMaxGradients ] ;
uniform vec4 uGradientsWeights [ kMaxGradients * 2 ] ;
uniform sampler2D uStage3Image ;
uniform sampler2D uBigTableTex ;
uniform sampler2D uFillLightMaskTex ;
uniform sampler2D uLocalContrastMask ;
uniform sampler2D uDenoiseMask ;
uniform sampler2D uHSLGrayTex ;
uniform sampler3D uHueSatMap ;
uniform sampler3D uLookTable ;
in vec2 uv0 ;
layout ( location = 0 ) out vec4 target0 ;
struct Inputs
{
    vec2 uv0 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
vec2 ToDefaultCrop ( vec2 pt )
{
    return ( pt * uToDefaultCropScale ) + uToDefaultCropOffset ;
}
float NormalizedSquaredDistanceFromCenter ( vec2 pt )
{
    vec2 diff = ( pt - vec2 ( 0.5 , 0.5 ) ) * uNormalizeDistance ;
    return dot ( diff , diff ) ;
}
float NormalizedSquaredPinnedDistanceFromCenter ( vec2 pt )
{
    return min ( NormalizedSquaredDistanceFromCenter ( pt ) , 1.0 ) ;
}
vec3 Clip01 ( vec3 rgb )
{
    return clamp ( rgb , vec3 ( 0.0 , 0.0 , 0.0 ) , vec3 ( 1.0 , 1.0 , 1.0 ) ) ;
}
float MapInfRangeToSignedNormRange ( float x )
{
    if ( x < 0.0 )
    {
        return pow ( 2.0 , x ) - 1.0 ;
    }
    else if ( x > 0.0 )
    {
        return 1.0 - pow ( 2.0 , - x ) ;
    }
    return 0.0 ;
}
vec4 BigTableLookup ( float index , float rowOffset )
{
    index = mix ( kBigTableCol_First , kBigTableCol_Last , index ) ;
    return texture ( uBigTableTex , vec2 ( index , rowOffset ) ) ;
}
float sRGB_Evaluate ( float x )
{
    if ( x <= 0.0031308 ) return x * 12.92 ;
    else return 1.055 * pow ( x , 1.0 / 2.4 ) - 0.055 ;
}
vec3 sRGB_Evaluate ( vec3 x )
{
    return vec3 ( sRGB_Evaluate ( x . r ) , sRGB_Evaluate ( x . g ) , sRGB_Evaluate ( x . b ) ) ;
}
float sRGB_EvaluateInverse ( float y )
{
    if ( y <= 0.0031308 * 12.92 ) return y * ( 1.0 / 12.92 ) ;
    else return pow ( ( y + 0.055 ) * ( 1.0 / 1.055 ) , 2.4 ) ;
}
vec3 sRGB_EvaluateInverse ( vec3 x )
{
    return vec3 ( sRGB_EvaluateInverse ( x . r ) , sRGB_EvaluateInverse ( x . g ) , sRGB_EvaluateInverse ( x . b ) ) ;
}
vec3 RGBtoHSV ( vec3 src )
{
    float h , s , v ;
    v = max ( src . r , max ( src . g , src . b ) ) ;
    float gap = v - min ( src . r , min ( src . g , src . b ) ) ;
    if ( gap > 0.0 )
    {
        if ( src . r == v )
        {
            h = ( src . g - src . b ) / gap ;
            if ( h < 0.0 )
            {
                h += 6.0 ;
            }
        }
        else if ( src . g == v )
        {
            h = 2.0 + ( src . b - src . r ) / gap ;
        }
        else
        {
            h = 4.0 + ( src . r - src . g ) / gap ;
        }
        s = gap / v ;
    }
    else
    {
        h = 0.0 ;
        s = 0.0 ;
    }
    return vec3 ( h , s , v ) ;
}
vec3 HSVtoRGB ( vec3 hsv )
{
    float r , g , b ;
    float h = hsv . x ;
    float s = hsv . y ;
    float v = hsv . z ;
    if ( s > 0.0 )
    {
        if ( h < 0.0 ) h += 6.0 ;
        if ( h >= 6.0 ) h -= 6.0 ;
        float i = floor ( h ) ;
        float f = h - i ;
        float p = v * ( 1.0 - s ) ;
        float q = v * ( 1.0 - s * f ) ;
        float t = ( v * ( 1.0 - s * ( 1.0 - f ) ) ) ;
        if ( i == 0.0 )
        {
            r = v ;
            g = t ;
            b = p ;
        }
        else if ( i == 1.0 )
        {
            r = q ;
            g = v ;
            b = p ;
        }
        else if ( i == 2.0 )
        {
            r = p ;
            g = v ;
            b = t ;
        }
        else if ( i == 3.0 )
        {
            r = p ;
            g = q ;
            b = v ;
        }
        else if ( i == 4.0 )
        {
            r = t ;
            g = p ;
            b = v ;
        }
        else
        {
            r = v ;
            g = p ;
            b = q ;
        }
    }
    else
    {
        r = v ;
        g = v ;
        b = v ;
    }
    return vec3 ( r , g , b ) ;
}
float DoProfileLensVignette ( vec2 pt )
{
    vec2 dxdy = pt * uVignetteProfileScale + uVignetteProfileOffset ;
    float rr = dot ( dxdy , dxdy ) ;
    return BigTableLookup ( rr , kBigTableRow_ProfileVignette ) . x ;
}
float DoManualLensVignette ( float rr , float amount , float midpoint , float amountScale )
{
    float power = 1.0 + 4.0 * midpoint ;
    float scale = pow ( 2.0 , abs ( amount ) * amountScale ) - 1.0 ;
    float y = 1.0 + scale * pow ( rr , power ) ;
    if ( amount < 0.0 )
    {
        y = 1.0 / y ;
    }
    return y ;
}
float DoManualLensVignette ( float rr )
{
    return DoManualLensVignette ( rr , uLensVignetteAmount , uLensVignetteMidpoint , 2.0 ) ;
}
vec3 DoLensVignette ( vec3 image , vec2 pt )
{
    float rr = NormalizedSquaredPinnedDistanceFromCenter ( pt ) ;
    float scale = DoManualLensVignette ( rr ) ;
    if ( uHasLensProfileVignette )
    {
        scale *= DoProfileLensVignette ( pt ) ;
    }
    scale = max ( scale , 0.0 ) ;
    return image * scale ;
}
vec2 DoPerspective ( vec2 pt )
{
    const float kPerspectiveMaxScale64 = 5.0 ;
    const float kPerspectiveMinScale64 = 1.0 / kPerspectiveMaxScale64 ;
    vec3 xyh = uPerspectiveMatrix * vec3 ( pt , 1.0 ) ;
    xyh . z = clamp ( xyh . z , kPerspectiveMinScale64 , kPerspectiveMaxScale64 ) ;
    float s = 1.0 / xyh . z ;
    xyh *= s ;
    pt = xyh . xy ;
    return pt ;
}
vec2 DoDistort ( vec2 pt , float radiusScale )
{
    const vec2 center = vec2 ( 0.5 , 0.5 ) ;
    return center + ( radiusScale * ( pt - center ) ) ;
}
vec2 DoManualDistort ( vec2 pt )
{
    vec2 ptDefaultCrop = ToDefaultCrop ( pt ) ;
    float rr = NormalizedSquaredPinnedDistanceFromCenter ( ptDefaultCrop ) ;
    float scale = ( 1.0 - uManualDistortB ) + uManualDistortB * rr ;
    pt = DoDistort ( pt , scale ) ;
    return pt ;
}
vec2 DoProfileDistort ( vec2 pt , float rowOffset )
{
    vec2 diff = ( pt - uProfileWarpCenter ) * uProfileWarpToTable ;
    float rr = dot ( diff , diff ) ;
    float r = sqrt ( rr ) ;
    vec2 ratio = BigTableLookup ( r , rowOffset ) . xx ;
    diff = diff * ratio ;
    return uProfileWarpCenter + ( diff * uProfileWarpFromTable ) ;
}
vec3 GetStage3 ( vec2 pt , out vec2 ptR , out vec2 ptG , out vec2 ptB )
{
    pt = DoPerspective ( pt ) ;
    pt = DoManualDistort ( pt ) ;
    ptR = pt ;
    ptG = pt ;
    ptB = pt ;
    if ( uHasProfileWarp )
    {
        ptR = DoProfileDistort ( pt , kBigTableRow_ProfileWarp0 ) ;
        ptG = DoProfileDistort ( pt , kBigTableRow_ProfileWarp1 ) ;
        ptB = DoProfileDistort ( pt , kBigTableRow_ProfileWarp2 ) ;
        ptR = mix ( ptR , ptG , vec2 ( 0.99999 ) ) ;
        ptB = mix ( ptB , ptG , vec2 ( 0.99999 ) ) ;
    }
    ptR += 0.0000001 * DoDistort ( ptR , uCAScale . r ) ;
    ptG += 0.0000001 * DoDistort ( ptG , uCAScale . g ) ;
    ptB += 0.0000001 * DoDistort ( ptB , uCAScale . b ) ;
    vec3 stage3 = vec3 ( texture ( uStage3Image , ptR ) . r , texture ( uStage3Image , ptG ) . g , texture ( uStage3Image , ptB ) . b ) ;
    return stage3 ;
}
vec3 DoRamp ( vec3 x )
{
    vec3 y = x - ( uRampBlack - uRampRadius ) ;
    vec3 result = uRampScale * y * y ;
    vec3 result2 = min ( ( x - uRampBlack ) * uRampSlope , vec3 ( 1.0 ) ) ;
    vec3 result1 = vec3 ( 0.0 ) ;
    result = mix ( result , result2 , vec3 ( greaterThanEqual ( x , uRampBlack + uRampRadius ) ) ) ;
    result = mix ( result , result1 , vec3 ( lessThanEqual ( x , uRampBlack - uRampRadius ) ) ) ;
    return result ;
}
vec3 DoSaturation ( vec3 rgb )
{
    vec3 temp = ( ( uSaturationMatrix ) * ( rgb ) ) ;
    temp = Clip01 ( temp ) ;
    return temp ;
}
vec3 DoRGBtoMMH ( vec3 rgb )
{
    float r = rgb . r ;
    float g = rgb . g ;
    float b = rgb . b ;
    bool mirror0 = ( b > g ) ;
    if ( mirror0 )
    {
        float temp = g ;
        g = b ;
        b = temp ;
    }
    bool mirror1 = ( b > r ) ;
    if ( mirror1 )
    {
        float temp = r ;
        r = b ;
        b = temp ;
    }
    bool mirror2 = ( g > r ) ;
    if ( mirror2 )
    {
        float temp = g ;
        g = r ;
        r = temp ;
    }
    float hue ;
    if ( r == b )
    {
        hue = 0.0 ;
    }
    else
    {
        hue = ( g - b ) / ( r - b ) ;
    }
    if ( mirror2 )
    {
        hue = 2.0 - hue ;
    }
    if ( mirror1 )
    {
        hue = 4.0 - hue ;
    }
    if ( mirror0 )
    {
        hue = 6.0 - hue ;
    }
    return vec3 ( b , r , hue ) ;
}
vec3 DoMMHtoRGB ( vec3 mmh )
{
    float hue = mmh . z ;
    float r = mmh . y ;
    float b = mmh . x ;
    if ( hue > 6.0 )
    {
        hue -= 6.0 ;
    }
    if ( hue > 6.0 )
    {
        hue -= 6.0 ;
    }
    bool mirror0 = ( hue > 3.0 ) ;
    if ( mirror0 )
    {
        hue = 6.0 - hue ;
    }
    bool mirror1 = ( hue > 2.0 ) ;
    if ( mirror1 )
    {
        hue = 4.0 - hue ;
    }
    bool mirror2 = ( hue > 1.0 ) ;
    if ( mirror2 )
    {
        hue = 2.0 - hue ;
    }
    float g = b + ( r - b ) * hue ;
    if ( mirror2 )
    {
        float temp = g ;
        g = r ;
        r = temp ;
    }
    if ( mirror1 )
    {
        float temp = r ;
        r = b ;
        b = temp ;
    }
    if ( mirror0 )
    {
        float temp = g ;
        g = b ;
        b = temp ;
    }
    return vec3 ( r , g , b ) ;
}
vec3 DoColorConvert ( vec3 image )
{
    return image ;
}
const float kMinSkinHue = - 60.0 ;
const float kMinCentralSkinHue = 0.0 ;
const float kMaxCentralSkinHue = 30.0 ;
const float kMaxSkinHue = 45.0 ;
const float kMinScaledSkinHue = ( kMinSkinHue + 60.0 ) / 60.0 ;
const float kMinScaledCentralSkinHue = ( kMinCentralSkinHue + 60.0 ) / 60.0 ;
const float kMaxScaledCentralSkinHue = ( kMaxCentralSkinHue + 60.0 ) / 60.0 ;
const float kMaxScaledSkinHue = ( kMaxSkinHue + 60.0 ) / 60.0 ;
const float kMinSideFalloff = 1.0 / ( kMinScaledCentralSkinHue - kMinScaledSkinHue ) ;
const float kMaxSideFalloff = 1.0 / ( kMaxScaledSkinHue - kMaxScaledCentralSkinHue ) ;
vec3 DoIncreaseVibrance ( vec3 minMaxHue , float vibranceShift )
{
    const float kMaxSaturationGain = 6.0 ;
    const float kMaxSkinSaturationGain = 1.75 ;
    const float kStandardFactor = 1.0 - ( 1.0 / kMaxSaturationGain ) ;
    const float kSkinFactor = 1.0 - ( 1.0 / kMaxSkinSaturationGain ) ;
    const float kSkinProtectionSlope = kSkinFactor - kStandardFactor ;
    float minValue = minMaxHue . x ;
    float maxValue = minMaxHue . y ;
    float gap = maxValue - minValue ;
    if ( gap == 0.0 )
    {
        return minMaxHue ;
    }
    float saturation = gap / maxValue ;
    float shiftFactor = vibranceShift ;
    float hue = minMaxHue . z ;
    float shiftedHue = hue + 1.0 ;
    if ( 6.0 <= shiftedHue ) shiftedHue -= 6.0 ;
    float minSide = clamp ( 1.0 - ( kMinScaledCentralSkinHue - shiftedHue ) * kMinSideFalloff , 0.0 , 1.0 ) ;
    float maxSide = clamp ( 1.0 - ( shiftedHue - kMaxScaledCentralSkinHue ) * kMaxSideFalloff , 0.0 , 1.0 ) ;
    float protection = min ( minSide , maxSide ) ;
    protection *= ( 1.0 - saturation * saturation ) ;
    shiftFactor = shiftFactor * ( shiftFactor * protection + 1.0 - protection ) ;
    float saturationFactor = kStandardFactor + kSkinProtectionSlope * protection ;
    saturationFactor *= shiftFactor ;
    saturationFactor *= 1.0 - minValue ;
    float shadowRolloff = min ( 1.0 , 16.0 * maxValue ) ;
    shadowRolloff *= 2.0 - shadowRolloff ;
    saturationFactor *= shadowRolloff ;
    float saturationMask = saturation * ( 1.0 - saturation ) ;
    saturationMask *= 2.0 - saturationMask ;
    float brightnessFactor = shiftFactor * shadowRolloff * saturationMask ;
    saturation = saturation / ( 1.0 - saturationFactor * ( 1.0 - saturation ) ) ;
    maxValue *= 1.0 + 0.25 * brightnessFactor * ( 1.0 - maxValue ) ;
    minValue = maxValue - saturation * maxValue ;
    return vec3 ( minValue , maxValue , hue ) ;
}
vec3 DoDecreaseVibrance ( vec3 minMaxHue , float vibranceShift )
{
    float minValue = minMaxHue . x ;
    float maxValue = minMaxHue . y ;
    float gap = maxValue - minValue ;
    if ( gap == 0.0 )
    {
        return minMaxHue ;
    }
    float saturation = gap / maxValue ;
    float saturationFactor = - vibranceShift ;
    float shadowRolloff = min ( 1.0 , 16.0 * maxValue ) ;
    shadowRolloff *= 2.0 - shadowRolloff ;
    float saturationMask = saturation * ( 1.0 - saturation ) ;
    saturationMask *= 2.0 - saturationMask ;
    float brightnessFactor = - vibranceShift * shadowRolloff * saturationMask ;
    saturation *= 1.0 - saturationFactor + saturationFactor * saturation * ( 0.5 + 0.5 * saturation ) * shadowRolloff ;
    saturation *= 1.0 - 0.25 * saturationFactor ;
    maxValue *= 1.0 - brightnessFactor * ( 1.0 - maxValue ) ;
    minValue = maxValue - saturation * maxValue ;
    return vec3 ( minValue , maxValue , minMaxHue . z ) ;
}
float ContrastBump ( float lum )
{
    float contrastBump ;
    if ( lum <= 0.5 )
    {
        float f = ( lum - 0.25 ) * 4.0 ;
        contrastBump = f * f - 1.0 ;
    }
    else
    {
        float f = ( lum - 0.75 ) * 4.0 ;
        contrastBump = 1.0 - f * f ;
    }
    contrastBump *= 0.125 ;
    return contrastBump ;
}
float ShiftBrightnessAndContrast ( float lum , float brightnessShift , float contrastShift , float contrastSplitSlope , float invContrastSplitSlope )
{
    float dbSlope = pow ( 2.0 , brightnessShift * 4.0 ) ;
    if ( contrastShift == 0.0 )
    {
        float lum_db = dbSlope * lum ;
        lum = lum_db / ( 1.0 + lum_db - lum ) ;
    }
    else
    {
        float slope1 = dbSlope * contrastSplitSlope ;
        float slope2 = invContrastSplitSlope ;
        float lum_scaled_1 = slope1 * lum ;
        lum = lum_scaled_1 / ( 1.0 + lum_scaled_1 - lum ) ;
        float contrastSlope = pow ( 2.0 , 0.75 * contrastShift ) ;
        float contrastBump = ContrastBump ( lum ) ;
        if ( 1.0 <= contrastSlope )
        {
            lum += contrastBump * min ( 0.5 , contrastSlope - 1.0 ) ;
            contrastSlope = max ( 1.0 , contrastSlope * 0.6666666667 ) ;
        }
        else
        {
            lum += contrastBump * max ( - 0.5 , contrastSlope - 1.0 ) ;
            contrastSlope = min ( 1.0 , contrastSlope * 2.0 ) ;
        }
        if ( contrastSlope != 1.0 )
        {
            float lum_expanded = 2.0 * lum - 1.0 ;
            float lum_expanded_scaled = lum_expanded * contrastSlope ;
            float lum_expanded_scaled_b = lum_expanded_scaled / ( 1.0 + ( contrastSlope - 1.0 ) * abs ( lum_expanded ) ) ;
            lum = 0.5 + 0.5 * lum_expanded_scaled_b ;
        }
        float lum_scaled_2 = slope2 * lum ;
        lum = lum_scaled_2 / ( 1.0 + lum_scaled_2 - lum ) ;
    }
    return lum ;
}
vec3 DoTuneHSLMasked32 ( vec3 minMaxHue , float lMask , float cMask , float sMask )
{
    float contrastSplit = uToneContrastSplit ;
    const float kMaxSaturationGain = 6.0 ;
    const float kBaseSaturationFactor = 1.0 - ( 1.0 / kMaxSaturationGain ) ;
    const float tableScale = ( 1.0 / 6.0 ) ;
    float contrastSplitSlope = ( 1.0 - contrastSplit ) / contrastSplit ;
    float invContrastSplitSlope = contrastSplit / ( 1.0 - contrastSplit ) ;
    const float kExponentialSaturationFactor = 2.5 ;
    float minValue = minMaxHue . x ;
    float maxValue = minMaxHue . y ;
    float hue = minMaxHue . z ;
    float newHue = hue ;
    float initialGap = maxValue - minValue ;
    float maskBrightnessShift = lMask ;
    float maskContrastShift = cMask ;
    float maskSaturationShift = sMask ;
    bool doMaskBrightnessShift = maskBrightnessShift != 0.0 ;
    bool doMaskContrastShift = maskContrastShift != 0.0 ;
    bool doMaskBrightnessContrastShift = doMaskBrightnessShift || doMaskContrastShift ;
    float hslSaturationShift = 0.0 ;
    if ( initialGap != 0.0 )
    {
        float index = hue * tableScale ;
        index = mix ( uHSLGrayCoords . x , uHSLGrayCoords . y , index ) ;
        newHue = texture ( uHSLGrayTex , vec2 ( index , uHSLGrayRows . x ) ) . r ;
        hslSaturationShift = texture ( uHSLGrayTex , vec2 ( index , uHSLGrayRows . y ) ) . r ;
        float hslLuminanceShift = texture ( uHSLGrayTex , vec2 ( index , uHSLGrayRows . z ) ) . r ;
        if ( hslLuminanceShift != 0.0 )
        {
            float gap2 = initialGap * ( 2.0 - initialGap ) ;
            float gap4 = gap2 * ( 2.0 - gap2 ) ;
            float gap8 = gap4 * ( 2.0 - gap4 ) ;
            hslLuminanceShift *= gap8 ;
            minValue = minValue * ( 1.0 + hslLuminanceShift * ( 1.0 - minValue ) ) ;
            maxValue = maxValue * ( 1.0 + hslLuminanceShift * ( 1.0 - maxValue ) ) ;
            minValue = minValue * ( 1.0 + hslLuminanceShift * ( 1.0 - minValue ) ) ;
            maxValue = maxValue * ( 1.0 + hslLuminanceShift * ( 1.0 - maxValue ) ) ;
        }
    }
    if ( doMaskBrightnessContrastShift )
    {
        minValue = ShiftBrightnessAndContrast ( minValue , maskBrightnessShift , maskContrastShift , contrastSplitSlope , invContrastSplitSlope ) ;
        maxValue = ShiftBrightnessAndContrast ( maxValue , maskBrightnessShift , maskContrastShift , contrastSplitSlope , invContrastSplitSlope ) ;
    }
    if ( minValue < maxValue )
    {
        float saturationShift = hslSaturationShift + maskSaturationShift ;
        if ( saturationShift < 0.0 )
        {
            saturationShift = max ( - 1.0 , saturationShift ) ;
            float L = 0.5 * ( maxValue + minValue ) ;
            minValue += saturationShift * ( minValue - L ) ;
            maxValue += saturationShift * ( maxValue - L ) ;
        }
        else if ( 0.0 < saturationShift )
        {
            float gap = maxValue - minValue ;
            float saturation = gap / maxValue ;
            float shiftedHue = hue + 1.0 ;
            if ( 6.0 <= shiftedHue ) shiftedHue -= 6.0 ;
            float minSide = clamp ( 1.0 - ( kMinScaledCentralSkinHue - shiftedHue ) * kMinSideFalloff , 0.0 , 1.0 ) ;
            float maxSide = clamp ( 1.0 - ( shiftedHue - kMaxScaledCentralSkinHue ) * kMaxSideFalloff , 0.0 , 1.0 ) ;
            float protection = min ( minSide , maxSide ) ;
            protection *= ( 1.0 - saturation * saturation ) ;
            float availableForProtection = clamp ( maskSaturationShift , 0.0 , saturationShift ) ;
            saturationShift -= 0.5 * availableForProtection * protection ;
            saturationShift *= 1.0 - minValue ;
            float shadowRolloff = min ( 1.0 , 16.0 * maxValue ) ;
            shadowRolloff *= 2.0 - shadowRolloff ;
            saturationShift *= shadowRolloff ;
            if ( saturationShift <= 1.0 )
            {
                float saturationFactor = kBaseSaturationFactor * saturationShift ;
                saturation = saturation / ( 1.0 - saturationFactor * ( 1.0 - saturation ) ) ;
            }
            else
            {
                float saturationFactor = 6.0 * pow ( 2.0 , kExponentialSaturationFactor * ( saturationShift - 1.0 ) ) ;
                float scaledSaturation = saturationFactor * saturation ;
                saturation = scaledSaturation / ( 1.0 + scaledSaturation - saturation ) ;
            }
            minValue = maxValue - saturation * maxValue ;
        }
    }
    minMaxHue . x = minValue ;
    minMaxHue . y = maxValue ;
    minMaxHue . z = newHue ;
    return minMaxHue ;
}
vec3 DoTuneLuminanceMasked32 ( vec3 rgb , float localLuminanceMask , float localContrastMask )
{
    float contrastSplit = uToneContrastSplit ;
    float contrastSplitSlope = ( 1.0 - contrastSplit ) / contrastSplit ;
    float invContrastSplitSlope = contrastSplit / ( 1.0 - contrastSplit ) ;
    float brightnessShift = localLuminanceMask ;
    float contrastShift = localContrastMask ;
    float lum = rgb . x ;
    lum = ShiftBrightnessAndContrast ( lum , brightnessShift , contrastShift , contrastSplitSlope , invContrastSplitSlope ) ;
    return vec3 ( lum ) ;
}
vec3 evalSlopeCurve32 ( vec3 y , vec3 shadowSlope , vec3 highlightSlope )
{
    vec3 deltaSlope = vec3 ( 3.0 ) - highlightSlope - shadowSlope ;
    return y * ( ( vec3 ( 1.0 ) - y ) * ( shadowSlope + deltaSlope * y ) + y * y ) ;
}
const float kColorToningLimit = 1.9375 ;
const float kYellowAngleFract = 0.8125 ;
vec3 DoLocalColorToning ( vec3 rgb , float byMask , float gmMask )
{
    const float s_min_slope = 0.5 ;
    const float h_min_slope = 0.5 ;
    const float w_r = 0.25 ;
    const float w_g = 0.50 ;
    const float w_b = 1.0 - w_r - w_g ;
    const float U = w_r + kYellowAngleFract * w_g ;
    const float sY_delta = ( 1.0 - s_min_slope ) / U ;
    const float sB_delta = ( 1.0 - s_min_slope ) / ( 1.0 - U ) ;
    const float sBY_delta = sY_delta < sB_delta ? sY_delta : sB_delta ;
    const float mfract = 1.5 - kYellowAngleFract ;
    const float V = w_r + mfract * w_b ;
    const float sM_delta = ( 1.0 - s_min_slope ) / V ;
    const float sG_delta = ( 1.0 - s_min_slope ) / ( 1.0 - V ) ;
    const float sMG_delta = sM_delta < sG_delta ? sM_delta : sG_delta ;
    const float sBYMG_delta = sBY_delta < sMG_delta ? sBY_delta : sMG_delta ;
    const float sY_final_delta = sBYMG_delta ;
    const float sB_final_delta = sBYMG_delta ;
    const float sM_final_delta = sBYMG_delta ;
    const float sG_final_delta = sBYMG_delta ;
    const float hY_delta = ( 1.0 - h_min_slope ) / ( 1.0 - U ) ;
    const float hB_delta = ( 1.0 - h_min_slope ) / U ;
    const float hBY_delta = hY_delta < hB_delta ? hY_delta : hB_delta ;
    const float hM_delta = ( 1.0 - h_min_slope ) / ( 1.0 - V ) ;
    const float hG_delta = ( 1.0 - h_min_slope ) / V ;
    const float hMG_delta = hM_delta < hG_delta ? hM_delta : hG_delta ;
    const float hBYMG_delta = hBY_delta < hMG_delta ? hBY_delta : hMG_delta ;
    const float hY_final_delta = hBYMG_delta ;
    const float hB_final_delta = hBYMG_delta ;
    const float hM_final_delta = hBYMG_delta ;
    const float hG_final_delta = hBYMG_delta ;
    const float k_sY_b = 1.0 - sY_final_delta * U ;
    const float k_sY_r = k_sY_b + sY_final_delta ;
    const float k_sY_g = k_sY_b + kYellowAngleFract * sY_final_delta ;
    const float k_sB_r = 1.0 - sB_final_delta * ( 1.0 - U ) ;
    const float k_sB_b = k_sB_r + sB_final_delta ;
    const float k_sB_g = k_sB_r + ( 1.0 - kYellowAngleFract ) * sB_final_delta ;
    const float k_hY_b = 1.0 + hY_final_delta * U ;
    const float k_hY_r = k_hY_b - hY_final_delta ;
    const float k_hY_g = k_hY_b - kYellowAngleFract * hY_final_delta ;
    const float k_hB_r = 1.0 + hB_final_delta * ( 1.0 - U ) ;
    const float k_hB_b = k_hB_r - hB_final_delta ;
    const float k_hB_g = k_hB_r - ( 1.0 - kYellowAngleFract ) * hB_final_delta ;
    const float k_sY_r_1 = k_sY_r - 1.0 ;
    const float k_sY_g_1 = k_sY_g - 1.0 ;
    const float k_sY_b_1 = k_sY_b - 1.0 ;
    const float k_hY_r_1 = k_hY_r - 1.0 ;
    const float k_hY_g_1 = k_hY_g - 1.0 ;
    const float k_hY_b_1 = k_hY_b - 1.0 ;
    const float k_sB_r_1 = k_sB_r - 1.0 ;
    const float k_sB_g_1 = k_sB_g - 1.0 ;
    const float k_sB_b_1 = k_sB_b - 1.0 ;
    const float k_hB_r_1 = k_hB_r - 1.0 ;
    const float k_hB_g_1 = k_hB_g - 1.0 ;
    const float k_hB_b_1 = k_hB_b - 1.0 ;
    const float k_sM_g = 1.0 - sM_final_delta * V ;
    const float k_sM_r = k_sM_g + sM_final_delta ;
    const float k_sM_b = k_sM_g + mfract * sM_final_delta ;
    const float k_sG_r = 1.0 - sG_final_delta * ( 1.0 - V ) ;
    const float k_sG_g = k_sG_r + sG_final_delta ;
    const float k_sG_b = k_sG_r + ( 1.0 - mfract ) * sG_final_delta ;
    const float k_hM_g = 1.0 + hM_final_delta * V ;
    const float k_hM_r = k_hM_g - hM_final_delta ;
    const float k_hM_b = k_hM_g - mfract * hM_final_delta ;
    const float k_hG_r = 1.0 + hG_final_delta * ( 1.0 - V ) ;
    const float k_hG_g = k_hG_r - hG_final_delta ;
    const float k_hG_b = k_hG_r - ( 1.0 - mfract ) * hG_final_delta ;
    const float k_sM_r_1 = k_sM_r - 1.0 ;
    const float k_sM_b_1 = k_sM_b - 1.0 ;
    const float k_sM_g_1 = k_sM_g - 1.0 ;
    const float k_hM_r_1 = k_hM_r - 1.0 ;
    const float k_hM_b_1 = k_hM_b - 1.0 ;
    const float k_hM_g_1 = k_hM_g - 1.0 ;
    const float k_sG_r_1 = k_sG_r - 1.0 ;
    const float k_sG_b_1 = k_sG_b - 1.0 ;
    const float k_sG_g_1 = k_sG_g - 1.0 ;
    const float k_hG_r_1 = k_hG_r - 1.0 ;
    const float k_hG_b_1 = k_hG_b - 1.0 ;
    const float k_hG_g_1 = k_hG_g - 1.0 ;
    const float kColorToningLimit2 = kColorToningLimit * kColorToningLimit ;
    float sBY_r_1 , sBY_g_1 , sBY_b_1 , hBY_r_1 , hBY_g_1 , hBY_b_1 , fract_BY ;
    float by = byMask ;
    float mg = gmMask ;
    float scale = kColorToningLimit / sqrt ( kColorToningLimit2 + by * by + mg * mg ) ;
    by *= scale ;
    mg *= scale ;
    if ( by < 0.0 )
    {
        sBY_r_1 = k_sB_r_1 ;
        sBY_g_1 = k_sB_g_1 ;
        sBY_b_1 = k_sB_b_1 ;
        hBY_r_1 = k_hB_r_1 ;
        hBY_g_1 = k_hB_g_1 ;
        hBY_b_1 = k_hB_b_1 ;
        fract_BY = - by ;
    }
    else
    {
        sBY_r_1 = k_sY_r_1 ;
        sBY_g_1 = k_sY_g_1 ;
        sBY_b_1 = k_sY_b_1 ;
        hBY_r_1 = k_hY_r_1 ;
        hBY_g_1 = k_hY_g_1 ;
        hBY_b_1 = k_hY_b_1 ;
        fract_BY = by ;
    }
    float sMG_r_1 , sMG_g_1 , sMG_b_1 , hMG_r_1 , hMG_g_1 , hMG_b_1 , fract_MG ;
    if ( mg < 0.0 )
    {
        sMG_r_1 = k_sM_r_1 ;
        sMG_g_1 = k_sM_g_1 ;
        sMG_b_1 = k_sM_b_1 ;
        hMG_r_1 = k_hM_r_1 ;
        hMG_g_1 = k_hM_g_1 ;
        hMG_b_1 = k_hM_b_1 ;
        fract_MG = - mg ;
    }
    else
    {
        sMG_r_1 = k_sG_r_1 ;
        sMG_g_1 = k_sG_g_1 ;
        sMG_b_1 = k_sG_b_1 ;
        hMG_r_1 = k_hG_r_1 ;
        hMG_g_1 = k_hG_g_1 ;
        hMG_b_1 = k_hG_b_1 ;
        fract_MG = mg ;
    }
    float s_r = 1.0 + fract_BY * sBY_r_1 + fract_MG * sMG_r_1 ;
    float s_g = 1.0 + fract_BY * sBY_g_1 + fract_MG * sMG_g_1 ;
    float s_b = 1.0 + fract_BY * sBY_b_1 + fract_MG * sMG_b_1 ;
    float h_r = 1.0 + fract_BY * hBY_r_1 + fract_MG * hMG_r_1 ;
    float h_g = 1.0 + fract_BY * hBY_g_1 + fract_MG * hMG_g_1 ;
    float h_b = 1.0 + fract_BY * hBY_b_1 + fract_MG * hMG_b_1 ;
    rgb = evalSlopeCurve32 ( rgb , vec3 ( s_r , s_g , s_b ) , vec3 ( h_r , h_g , h_b ) ) ;
    return rgb ;
}
vec3 RGBTone ( vec3 rgb , float rowOffset )
{
    float rr = BigTableLookup ( rgb . r , rowOffset ) . r ;
    float bb = BigTableLookup ( rgb . b , rowOffset ) . r ;
    float gg = bb + ( ( rr - bb ) * ( rgb . g - rgb . b ) / ( rgb . r - rgb . b ) ) ;
    return vec3 ( rr , gg , bb ) ;
}
vec3 DoToneCurve ( vec3 rgb , float rowOffset )
{
    float r = rgb . r ;
    float g = rgb . g ;
    float b = rgb . b ;
    vec3 result ;
    if ( r >= g )
    {
        if ( g > b )
        {
            result = RGBTone ( rgb , rowOffset ) . rgb ;
        }
        else if ( b > r )
        {
            result = RGBTone ( vec3 ( b , r , g ) , rowOffset ) . gbr ;
        }
        else if ( b > g )
        {
            result = RGBTone ( vec3 ( r , b , g ) , rowOffset ) . rbg ;
        }
        else
        {
            float gg = BigTableLookup ( g , rowOffset ) . r ;
            result = vec3 ( BigTableLookup ( r , rowOffset ) . r , gg , gg ) ;
        }
    }
    else
    {
        if ( r >= b )
        {
            result = RGBTone ( vec3 ( g , r , b ) , rowOffset ) . grb ;
        }
        else if ( b > g )
        {
            result = RGBTone ( vec3 ( b , g , r ) , rowOffset ) . bgr ;
        }
        else
        {
            result = RGBTone ( vec3 ( g , b , r ) , rowOffset ) . brg ;
        }
    }
    return result ;
}
vec3 DoWarpMask ( vec3 image , vec2 pt )
{
    const vec3 kMaskValue = vec3 ( 0.125 ) ;
    const vec2 kPixelOffset = vec2 ( 0.5 , 0.5 ) ;
    vec2 size = uDefaultCropSize * uRenderScale ;
    vec2 ptPixels = ToDefaultCrop ( pt ) * size ;
    vec2 clipTL = kPixelOffset ;
    vec2 clipBR = size - kPixelOffset ;
    float alpha = ( clamp ( 1.0 - max ( clipTL . x - ptPixels . x , ptPixels . x - clipBR . x ) , 0.0 , 1.0 ) * clamp ( 1.0 - max ( clipTL . y - ptPixels . y , ptPixels . y - clipBR . y ) , 0.0 , 1.0 ) ) ;
    image = mix ( kMaskValue , image , vec3 ( alpha ) ) ;
    return image ;
}
vec3 DoTuneHSL ( vec3 minMaxHue )
{
    const float kMaxSaturationGain = 6.0 ;
    const float kBaseSaturationFactor = 1.0 - ( 1.0 / kMaxSaturationGain ) ;
    float tableScale = ( 1.0 / 6.0 ) ;
    float initialGap = minMaxHue . y - minMaxHue . x ;
    if ( initialGap == 0.0 )
    {
        return minMaxHue ;
    }
    float minValue = minMaxHue . x ;
    float maxValue = minMaxHue . y ;
    float hue = minMaxHue . z ;
    float index = hue * tableScale ;
    index = mix ( uHSLGrayCoords . x , uHSLGrayCoords . y , index ) ;
    hue = texture ( uHSLGrayTex , vec2 ( index , uHSLGrayRows . x ) ) . r ;
    float saturationShift = texture ( uHSLGrayTex , vec2 ( index , uHSLGrayRows . y ) ) . r ;
    float luminanceShift = texture ( uHSLGrayTex , vec2 ( index , uHSLGrayRows . z ) ) . r ;
    if ( luminanceShift != 0.0 )
    {
        float gap2 = initialGap * ( 2.0 - initialGap ) ;
        float gap4 = gap2 * ( 2.0 - gap2 ) ;
        float gap8 = gap4 * ( 2.0 - gap4 ) ;
        luminanceShift *= gap8 ;
        minValue = minValue * ( 1.0 + luminanceShift * ( 1.0 - minValue ) ) ;
        maxValue = maxValue * ( 1.0 + luminanceShift * ( 1.0 - maxValue ) ) ;
        minValue = minValue * ( 1.0 + luminanceShift * ( 1.0 - minValue ) ) ;
        maxValue = maxValue * ( 1.0 + luminanceShift * ( 1.0 - maxValue ) ) ;
    }
    if ( saturationShift < 0.0 )
    {
        float L = 0.5 * ( maxValue + minValue ) ;
        minValue += saturationShift * ( minValue - L ) ;
        maxValue += saturationShift * ( maxValue - L ) ;
    }
    else if ( 0.0 < saturationShift )
    {
        float gap = maxValue - minValue ;
        float saturation = gap / maxValue ;
        float saturationFactor = kBaseSaturationFactor ;
        saturationFactor *= saturationShift ;
        saturationFactor *= 1.0 - minValue ;
        float shadowRolloff = min ( 1.0 , 16.0 * maxValue ) ;
        shadowRolloff *= 2.0 - shadowRolloff ;
        saturationFactor *= shadowRolloff ;
        saturation = saturation / ( 1.0 - saturationFactor * ( 1.0 - saturation ) ) ;
        minValue = maxValue - saturation * maxValue ;
    }
    return vec3 ( minValue , maxValue , hue ) ;
}
vec3 DoGrayMixer ( vec3 rgb )
{
    float tableScale = ( 1.0 / 6.0 ) ;
    float r = rgb . r ;
    float g = rgb . g ;
    float b = rgb . b ;
    float minValue , maxValue , hue ;
    bool mirror0 = ( b > g ) ;
    if ( mirror0 )
    {
        float temp = g ;
        g = b ;
        b = temp ;
    }
    bool mirror1 = ( b > r ) ;
    if ( mirror1 )
    {
        float temp = r ;
        r = b ;
        b = temp ;
    }
    bool mirror2 = ( g > r ) ;
    if ( mirror2 )
    {
        float temp = g ;
        g = r ;
        r = temp ;
    }
    if ( r == b )
    {
        return vec3 ( b ) ;
    }
    else
    {
        hue = ( g - b ) / ( r - b ) ;
    }
    if ( mirror2 )
    {
        hue = 2.0 - hue ;
    }
    if ( mirror1 )
    {
        hue = 4.0 - hue ;
    }
    if ( mirror0 )
    {
        hue = 6.0 - hue ;
    }
    minValue = b ;
    maxValue = r ;
    hue = hue ;
    float gap = maxValue - minValue ;
    float tableIndex = hue * tableScale ;
    tableIndex = mix ( uHSLGrayCoords . x , uHSLGrayCoords . y , tableIndex ) ;
    float gray = texture ( uHSLGrayTex , vec2 ( tableIndex , uHSLGrayRows . w ) ) . r ;
    float result ;
    if ( gray < 0.0 )
    {
        float minT ;
        if ( 9.0 * minValue < 1.0 ) minT = ( 3.0 * minValue ) / ( 0.25 + 6.75 * minValue ) ;
        else minT = 0.25 + 0.75 * minValue ;
        float maxT ;
        if ( 9.0 * maxValue < 1.0 ) maxT = ( 3.0 * maxValue ) / ( 0.25 + 6.75 * maxValue ) ;
        else maxT = 0.25 + 0.75 * maxValue ;
        float resultT = clamp ( minT + gray * ( maxT - minT ) , 0.0 , 1.0 ) ;
        if ( 3.0 * resultT < 1.0 ) result = resultT / ( 12.0 - 27.0 * resultT ) ;
        else result = ( resultT - 0.25 ) / 0.75 ;
    }
    else
    {
        result = minValue + gray * gap ;
    }
    result = clamp ( result , 0.0 , 1.0 ) ;
    return vec3 ( result ) ;
}
float ScaleDelta ( float delta , float scale )
{
    float sd = scale * delta ;
    if ( scale > 1.0 )
    {
        sd = sd / ( 1.0 + ( scale - 1.0 ) * abs ( delta ) ) ;
    }
    return sd ;
}
const float kNonLinearMapping_sqrt_a = 1.0 / 16.0 ;
const float kNonLinearMapping_a = kNonLinearMapping_sqrt_a * kNonLinearMapping_sqrt_a ;
const float kNonLinearMapping_scale1 = 1.0644512214 ;
const float kNonLinearMapping_scale2 = 0.93945122137 ;
float LinearToNonLinear ( float x )
{
    return ( sqrt ( x + kNonLinearMapping_a ) - kNonLinearMapping_sqrt_a ) * kNonLinearMapping_scale1 ;
}
float NonLinearToLinear ( float y )
{
    y = y * kNonLinearMapping_scale2 + kNonLinearMapping_sqrt_a ;
    return ( y * y ) - kNonLinearMapping_a ;
}
vec3 DoLocalContrast ( vec3 rgb , vec2 pt , float localClarityMask )
{
    const float kFudgeLimit = 0.5 ;
    float amount = uClarityAmount * kFudgeLimit ;
    const float kExponentialClarityFactor = 0.5859375 ;
    float c = localClarityMask ;
    float cc = pow ( 2.0 , c * kExponentialClarityFactor ) ;
    float d = dot ( kWeights , Clip01 ( rgb ) ) ;
    float cb_linear = texture ( uLocalContrastMask , pt ) . r ;
    float dd = LinearToNonLinear ( d ) ;
    float cb = LinearToNonLinear ( cb_linear ) ;
    cc *= ( 1.0 + amount ) ;
    float combinedDelta = 0.0 ;
    if ( cc < 1.0 )
    {
        float cc_factor = 0.5 + 0.5 * cc ;
        combinedDelta = ( dd - cb ) * ( cc * cc_factor * cc_factor - 1.0 ) ;
    }
    else if ( cc > 1.0 )
    {
        combinedDelta = 0.5 * ScaleDelta ( dd - cb , 2.0 * ( cc - 1.0 ) ) ;
    }
    float x = dd * 2.0 - 1.0 ;
    x = x * x ;
    x = x * x ;
    x = 1.0 - x ;
    x = x * x ;
    x = x * x ;
    dd = clamp ( dd + x * combinedDelta , 0.0 , 1.0 ) ;
    dd = NonLinearToLinear ( dd ) ;
    float scale = dd / max ( d , 1.0 / 65535.0 ) ;
    return Clip01 ( rgb * scale ) ;
}
float Scale ( float x , float s )
{
    float sx = s * x ;
    return sx / ( 1.0 + sx - x ) ;
}
float PowerScreen ( float x , float s )
{
    if ( x <= 0.0 )
    {
        return pow ( 1.0 + x , s ) - 1.0 ;
    }
    else
    {
        return 1.0 - pow ( 1.0 - x , s ) ;
    }
}
float DoPostCropVignette ( float x , float amount )
{
    float fMidpoint = uPostCropVignetteMidpoint ;
    float fFeather = uPostCropVignetteFeather ;
    float resultLensVignette = 0.0 ;
    if ( uBlendStyleLensVignette && ( amount < 0.0 ) )
    {
        resultLensVignette = DoManualLensVignette ( x , amount , fMidpoint , 5.0 ) ;
    }
    float feather = uPostCropVignetteFeather ;
    feather = 1.5 * feather / ( 1.0 + 0.5 * feather ) ;
    const float kMaxSlope = 8.0 ;
    float fs = 1.0 / ( feather + ( 1.0 - feather ) / kMaxSlope ) ;
    fs = fs * fs ;
    float target = sqrt ( 0.5 ) + ( 2.0 * fMidpoint - 1.0 ) * ( sqrt ( 0.5 ) - sqrt ( 0.20 ) ) * ( 0.75 + 0.25 * fMidpoint ) ;
    target = target * target ;
    float ts = ( 1.0 - target ) / target ;
    x = ts * x / ( 1.0 + ( ts - 1.0 ) * x ) ;
    x = 2.0 * x - 1.0 ;
    x = PowerScreen ( x , fs ) ;
    x = 0.5 * ( x + 1.0 ) ;
    float finalResult ;
    if ( amount < 0.0 )
    {
        float blended_sRGB = 1.0 - x ;
        float blended_linear = sRGB_EvaluateInverse ( blended_sRGB ) ;
        float scaled_sRGB = 1.0 + amount ;
        float scaled_linear = sRGB_EvaluateInverse ( scaled_sRGB ) ;
        float result = 1.0 - ( 1.0 - scaled_linear ) * ( 1.0 - blended_linear ) ;
        if ( ! uBlendStyleLensVignette )
        {
            return result ;
        }
        float lerpFactor = sRGB_EvaluateInverse ( fFeather ) ;
        finalResult = mix ( result , resultLensVignette , lerpFactor ) ;
    }
    else
    {
        float blended_sRGB = x ;
        float blended_linear = sRGB_EvaluateInverse ( blended_sRGB ) ;
        float scaled_sRGB = amount ;
        float scaled_linear = sRGB_EvaluateInverse ( scaled_sRGB ) ;
        finalResult = 1.0 - scaled_linear * blended_linear ;
    }
    return finalResult ;
}
float RefEllipseMask16 ( vec2 pt )
{
    float x = ( pt . y * uDefaultCropSize . y ) + uPostCropVignetteEllipseD ;
    float Axx = uPostCropVignetteEllipseA * x * x ;
    float Bx = uPostCropVignetteEllipseB * x ;
    float y = pt . x * uDefaultCropSize . x + uPostCropVignetteEllipseE ;
    float r2 = Axx + ( Bx + uPostCropVignetteEllipseC * y ) * y ;
    r2 = min ( r2 , 1.0 ) ;
    float z = DoPostCropVignette ( r2 , uPostCropVignetteAmount ) ;
    return z ;
}
float RefRoundedRectMask16 ( vec2 pt )
{
    float flatX = 0.0 ;
    float flatY = 0.0 ;
    float croppedAspectRatio = uPostCropVignetteCropAspectRatio ;
    float roundness = uPostCropVignetteRoundness ;
    if ( croppedAspectRatio >= 1.0 )
    {
        flatX = 0.45 * ( - roundness ) ;
        flatY = max ( 0.0 , 0.5 - ( ( 0.5 - flatX ) * croppedAspectRatio ) ) ;
    }
    else
    {
        flatY = 0.45 * ( - roundness ) ;
        flatX = max ( 0.0 , 0.5 - ( ( 0.5 - flatY ) / croppedAspectRatio ) ) ;
    }
    float scaleX = 0.5 / ( 0.5 - flatX ) ;
    float scaleY = 0.5 / ( 0.5 - flatY ) ;
    pt . x *= uDefaultCropSize . x ;
    pt . y *= uDefaultCropSize . y ;
    pt = ( ( ( uPostCropVignetteCropTransform ) * ( vec3 ( pt . yx , 1.0 ) ) ) ) . yx ;
    float x = abs ( pt . x - 0.5 ) ;
    float y = abs ( pt . y - 0.5 ) ;
    x = max ( x - flatX , 0.0 ) * scaleX ;
    y = max ( y - flatY , 0.0 ) * scaleY ;
    float r2 = ( x * x + y * y ) * 2.0 ;
    r2 = min ( r2 , 1.0 ) ;
    float z = DoPostCropVignette ( r2 , uPostCropVignetteAmount ) ;
    return z ;
}
float DoPostCropVignette ( vec2 pt )
{
    if ( uPostCropVignetteRoundness >= 0.0 )
    {
        return RefEllipseMask16 ( pt ) ;
    }
    else
    {
        return RefRoundedRectMask16 ( pt ) ;
    }
}
const float kGrainShadowMin = 0.00 ;
const float kGrainShadowMax = 0.05 ;
const float kGrainHighlightMin = 0.95 ;
const float kGrainHighlightMax = 1.00 ;
const float kGrainShadowScale = 1.0 / ( kGrainShadowMax - kGrainShadowMin ) ;
const float kGrainShadowOffset = - kGrainShadowMin * kGrainShadowScale ;
const float kGrainHighlightScale = 1.0 / ( kGrainHighlightMin - kGrainHighlightMax ) ;
const float kGrainHighlightOffset = - kGrainHighlightMax * kGrainHighlightScale ;
const vec3 kvGrainShadowScale = vec3 ( kGrainShadowScale ) ;
const vec3 kvGrainShadowOffset = vec3 ( kGrainShadowOffset ) ;
const vec3 kvGrainHighlightScale = vec3 ( kGrainHighlightScale ) ;
const vec3 kvGrainHighlightOffset = vec3 ( kGrainHighlightOffset ) ;
const vec3 kZero3 = vec3 ( 0.0 ) ;
const vec3 kOne3 = vec3 ( 1.0 ) ;
vec3 DoGrain ( vec3 image , vec2 pt )
{
    return image ;
}
vec3 DoFillLight ( vec3 rgb , vec2 pt )
{
    float mask = texture ( uFillLightMaskTex , pt ) . x ;
    mask = BigTableLookup ( mask , kBigTableRow_FillLightCurve ) . x ;
    return Clip01 ( rgb * mask ) ;
}
vec3 DoDarkPostCropVignette ( vec3 image , vec2 pt )
{
    float m = DoPostCropVignette ( pt ) ;
    float scale = m ;
    if ( uPostCropVignetteHighlightContrast > 0.0 && ! uHasPostCropVignettePaintOverlay )
    {
        float maxScale = mix ( m , 1.0 , uPostCropVignetteHighlightContrast ) ;
        const float kHLThresh = 0.18 ;
        const float kHLScale = 1.0 / ( 1.0 - kHLThresh ) ;
        const float kHLOffset = - kHLThresh * kHLScale ;
        vec3 hsv = RGBtoHSV ( image ) ;
        float v = hsv . z ;
        float t = clamp ( ( v * kHLScale ) + kHLOffset , 0.0 , 1.0 ) ;
        scale = mix ( m , maxScale , t ) ;
        hsv . z = v * scale ;
        image = HSVtoRGB ( hsv ) ;
        return image ;
    }
    return image * scale ;
}
vec3 DoWhitePostCropVignette ( vec3 image , vec2 pt )
{
    float m = DoPostCropVignette ( pt ) ;
    return vec3 ( 1.0 ) - Clip01 ( ( vec3 ( 1.0 ) - image ) ) * m ;
}
vec3 DoPostCropVignette ( vec3 image , vec2 pt )
{
    pt = ToDefaultCrop ( pt ) ;
    if ( uPostCropVignetteAmount < 0.0 )
    {
        image = DoDarkPostCropVignette ( image , pt ) ;
    }
    else
    {
        image = DoWhitePostCropVignette ( image , pt ) ;
    }
    return image ;
}
vec3 DoColorTable2D ( vec3 rgb , sampler2D table , vec3 firstCoords , vec3 lastCoords )
{
    vec3 hsv = RGBtoHSV ( rgb ) ;
    vec3 hsvIndex = hsv ;
    hsvIndex . x *= ( 1.0 / 6.0 ) ;
    hsvIndex = mix ( firstCoords , lastCoords , hsvIndex ) ;
    vec3 hsvDelta = texture ( table , hsvIndex . yx ) . xyz ;
    hsv . x += ( hsvDelta . x / 60.0 ) ;
    hsv . yz *= hsvDelta . yz ;
    hsv . yz = min ( hsv . yz , vec2 ( 1.0 ) ) ;
    rgb = HSVtoRGB ( hsv ) ;
    return rgb ;
}
vec3 DoColorTable3D ( vec3 rgb , sampler3D table , vec3 firstCoords , vec3 lastCoords )
{
    vec3 hsv = RGBtoHSV ( rgb ) ;
    vec3 hsvIndex = hsv ;
    hsvIndex . x *= ( 1.0 / 6.0 ) ;
    hsvIndex = mix ( firstCoords , lastCoords , hsvIndex ) ;
    vec3 hsvDelta = texture ( table , hsvIndex . yxz ) . xyz ;
    hsv . x += ( hsvDelta . x / 60.0 ) ;
    hsv . yz *= hsvDelta . yz ;
    hsv . yz = min ( hsv . yz , vec2 ( 1.0 ) ) ;
    rgb = HSVtoRGB ( hsv ) ;
    return rgb ;
}
vec3 DivMapEvaluate ( vec3 x , float alpha )
{
    vec3 scaled = vec3 ( alpha ) * x ;
    return scaled / ( vec3 ( 1.0 ) + scaled - x ) ;
}
vec3 DivMapEvaluateInverse ( vec3 y , float alpha )
{
    vec3 scaled = y / vec3 ( alpha ) ;
    return scaled / ( vec3 ( 1.0 ) + scaled - y ) ;
}
vec3 DoSplitTone ( vec3 rgb )
{
    vec3 y = rgb ;
    y = DivMapEvaluate ( y , uSplitToneBalanceMapAlpha ) ;
    y = y * ( ( vec3 ( 1.0 ) - y ) * ( uSplitToneShadowFactor + uSplitToneDeltaFactor * y ) + y * y ) ;
    return DivMapEvaluateInverse ( y , uSplitToneBalanceMapAlpha ) ;
}
vec3 DoColorMatrix ( vec3 abc )
{
    vec3 result ;
    abc = ( ( abc ) * ( uWBSelectorMatrix ) ) ;
    if ( ( uWhiteBalanceRecover == 1.0 ) && ( uWhiteBalanceColorLimit == 1.0 ) )
    {
        vec3 wbABC = min ( uWhiteBalance * abc , vec3 ( 1.0 ) ) ;
        result = Clip01 ( ( ( uABC2RGB ) * ( wbABC ) ) ) ;
    }
    else
    {
        const float kMinValue = 0.0 ;
        const float kMaxValue = 1.0 ;
        const float kExtra2 = 1.0 / 2.0 ;
        const float kExtra3 = 1.0 / 3.0 ;
        float scale0 = uWhiteBalance . r ;
        float scale1 = uWhiteBalance . g ;
        float recover = uWhiteBalanceRecover ;
        float colorLimit = uWhiteBalanceColorLimit ;
        float rLimit = 1.0 / recover ;
        float base2 = ( kMaxValue - colorLimit ) * kExtra3 ;
        float base1 = ( scale1 - kMaxValue ) * kExtra2 + base2 ;
        float eScale = recover / colorLimit ;
        float c0 = abc . r ;
        float c1 = abc . g ;
        float c2 = abc . b ;
        c0 = c0 * scale0 ;
        c1 = c1 * scale1 ;
        float uc0 = c0 ;
        float uc1 = c1 ;
        float uc2 = c2 ;
        float e = 0.0 ;
        bool didClip = false ;
        if ( c0 > colorLimit )
        {
            didClip = true ;
            c0 = min ( c0 , rLimit ) ;
            if ( c0 > scale1 ) e = ( c0 - scale1 ) + base1 ;
            else if ( c0 > kMaxValue ) e = ( c0 - kMaxValue ) * kExtra2 + base2 ;
            else e = ( c0 - colorLimit ) * kExtra3 ;
            c0 = colorLimit ;
        }
        if ( c1 > colorLimit )
        {
            didClip = true ;
            c1 = min ( c1 , rLimit ) ;
            if ( c1 > kMaxValue ) e += ( c1 - kMaxValue ) * kExtra2 + base2 ;
            else e += ( c1 - colorLimit ) * kExtra3 ;
            c1 = colorLimit ;
        }
        if ( c2 > colorLimit )
        {
            didClip = true ;
            e += ( c2 - colorLimit ) * kExtra3 ;
            c2 = colorLimit ;
        }
        vec3 rgb = ( ( uABC2RGB ) * ( vec3 ( c0 , c1 , c2 ) ) ) ;
        if ( rgb . r > colorLimit )
        {
            didClip = true ;
            rgb . r = colorLimit ;
        }
        if ( rgb . g > colorLimit )
        {
            didClip = true ;
            rgb . g = colorLimit ;
        }
        if ( rgb . b > colorLimit )
        {
            didClip = true ;
            rgb . b = colorLimit ;
        }
        rgb = max ( rgb , vec3 ( kMinValue ) ) ;
        float scale = recover + e * eScale ;
        rgb *= scale ;
        rgb = min ( rgb , vec3 ( kMaxValue ) ) ;
        if ( didClip )
        {
            uc0 = min ( uc0 , 2.0 ) ;
            uc1 = min ( uc1 , 2.0 ) ;
            uc2 = min ( uc2 , 2.0 ) ;
            vec3 rrggbb = ( ( uABC2RGB ) * ( vec3 ( uc0 , uc1 , uc2 ) ) ) ;
            rrggbb *= recover ;
            float oldGap = max ( max ( abs ( rgb . r - rgb . g ) , abs ( rgb . r - rgb . b ) ) , abs ( rgb . g - rgb . b ) ) ;
            if ( rrggbb . r > rgb . r ) rgb . r = min ( rrggbb . r , min ( rgb . r + oldGap , kMaxValue ) ) ;
            if ( rrggbb . g > rgb . g ) rgb . g = min ( rrggbb . g , min ( rgb . g + oldGap , kMaxValue ) ) ;
            if ( rrggbb . b > rgb . b ) rgb . b = min ( rrggbb . b , min ( rgb . b + oldGap , kMaxValue ) ) ;
        }
        result = rgb ;
    }
    return result ;
}
float RenderGradient ( vec4 grad , vec2 pt )
{
    float m = clamp ( dot ( pt - grad . xy , grad . zw ) , 0.0 , 1.0 ) ;
    m = 1.0 - m * m ;
    m = 1.0 - m * m ;
    return m ;
}
vec3 FlatNoiseEncode ( vec3 rgb )
{
    vec3 eval = sqrt ( uDenoiseCurveNoiseScale * rgb + vec3 ( uDenoiseCurveNoiseOffset ) ) ;
    vec3 integ = ( 2.0 / uDenoiseCurveNoiseScale ) * eval ;
    return ( integ - vec3 ( uDenoiseCurveIntegratedOffset ) ) * vec3 ( uDenoiseCurveIntegratedScale ) ;
}
vec3 FlatNoiseDecode ( vec3 rgb )
{
    vec3 z = vec3 ( uDenoiseCurveIntegratedOffset ) + ( rgb / uDenoiseCurveIntegratedScale ) ;
    z *= ( uDenoiseCurveNoiseScale * 0.5 ) ;
    return ( ( z * z ) - vec3 ( uDenoiseCurveNoiseOffset ) ) / uDenoiseCurveNoiseScale ;
}
vec3 DoDenoise ( vec3 rgb , vec2 pt , float localNoiseMask )
{
    pt = ToDefaultCrop ( pt ) ;
    rgb = FlatNoiseEncode ( rgb ) ;
    vec3 ycc = uDenoiseRGBtoYCC * rgb ;
    vec3 delta = texture ( uDenoiseMask , pt ) . rgb ;
    delta -= vec3 ( 0.5 ) ;
    float amount = uLumaDenoiseAmount ;
    if ( localNoiseMask != 0.0 )
    {
        localNoiseMask = MapInfRangeToSignedNormRange ( localNoiseMask ) ;
        localNoiseMask = clamp ( localNoiseMask , - 0.5 , + 0.5 ) ;
        if ( localNoiseMask < 0.0 )
        {
            float t = ( localNoiseMask + 0.5 ) * 2.0 ;
            amount = mix ( 0.0 , uLumaDenoiseAmount , t ) ;
        }
        else
        {
            float t = localNoiseMask * 2.0 ;
            amount = mix ( uLumaDenoiseAmount , 1.0 , t ) ;
        }
    }
    delta . x *= amount ;
    ycc += delta ;
    rgb = uDenoiseYCCtoRGB * ycc ;
    rgb = Clip01 ( rgb ) ;
    rgb = FlatNoiseDecode ( rgb ) ;
    return rgb ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    vec2 dstPt = inputs . uv0 ;
    vec2 srcPtR = dstPt ;
    vec2 srcPt = dstPt ;
    vec2 srcPtB = dstPt ;
    vec3 image = GetStage3 ( dstPt , srcPtR , srcPt , srcPtB ) ;
    float localExposureMask = 0.0 ;
    float localClarityMask = 0.0 ;
    float localSatMask = 0.0 ;
    float localLuminanceMask = 0.0 ;
    float localContrastMask = 0.0 ;
    float localBlueYellowMask = 0.0 ;
    float localGreenMagentaMask = 0.0 ;
    float localNoiseMask = 0.0 ;
    if ( uHasGradients )
    {
        vec2 ptThis = dstPt * uStage3Size ;
        for ( int k = 0 ;
        k < uNumGradients ;
        k ++ )
        {
            float g = RenderGradient ( uGradients [ k ] , ptThis ) ;
            localExposureMask += g * uGradientsWeights [ 2 * k + 0 ] . x ;
            localClarityMask += g * uGradientsWeights [ 2 * k + 0 ] . y ;
            localSatMask += g * uGradientsWeights [ 2 * k + 0 ] . z ;
            localLuminanceMask += g * uGradientsWeights [ 2 * k + 0 ] . w ;
            localContrastMask += g * uGradientsWeights [ 2 * k + 1 ] . x ;
            localBlueYellowMask += g * uGradientsWeights [ 2 * k + 1 ] . y ;
            localGreenMagentaMask += g * uGradientsWeights [ 2 * k + 1 ] . z ;
            localNoiseMask += g * uGradientsWeights [ 2 * k + 1 ] . w ;
        }
    }
    if ( uVisMode == kVisClarity )
    {
        outputs . target0 = vec4 ( texture ( uLocalContrastMask , srcPt ) . rrr , 1.0 ) ;
        return ;
    }
    else if ( uVisMode == kVisFillLight )
    {
        outputs . target0 = vec4 ( texture ( uFillLightMaskTex , srcPt ) . rrr , 1.0 ) ;
        return ;
    }
    else if ( uVisMode == kVisGrain )
    {
        outputs . target0 = vec4 ( 0.0 , 0.0 , 0.0 , 1.0 ) ;
        return ;
    }
    image = DoColorMatrix ( image ) ;
    if ( uHasDenoise )
    {
        image = DoDenoise ( image , srcPt , localNoiseMask ) ;
    }
    if ( uHasHueSatMap )
    {
        image = DoColorTable3D ( image , uHueSatMap , uHueSatMapCoordsFirst , uHueSatMapCoordsLast ) ;
    }
    image = DoLensVignette ( image , srcPt ) ;
    if ( uHasPostCropVignetteHighlightPriority )
    {
        image = DoPostCropVignette ( image , dstPt ) ;
    }
    if ( uHasFillLight )
    {
        image = DoFillLight ( image , srcPt ) ;
    }
    if ( uHasGradients )
    {
        localExposureMask = pow ( 2.0 , localExposureMask * kLocalExposureScale ) ;
        image *= localExposureMask ;
    }
    image = DoRamp ( image ) ;
    if ( uConvertToGray )
    {
        if ( uHasLookTable )
        {
            image = DoColorTable3D ( image , uLookTable , uLookTableCoordsFirst , uLookTableCoordsLast ) ;
        }
        image = DoGrayMixer ( image ) ;
        if ( uHasLocalContrast )
        {
            image = DoLocalContrast ( image , dstPt , localClarityMask ) ;
        }
        if ( localLuminanceMask != 0.0 || localContrastMask != 0.0 )
        {
            image = DoTuneLuminanceMasked32 ( image , localLuminanceMask , localContrastMask ) ;
        }
    }
    else
    {
        image = DoSaturation ( image ) ;
        if ( uHasLocalContrast )
        {
            image = DoLocalContrast ( image , dstPt , localClarityMask ) ;
        }
        if ( uHasLookTable )
        {
            image = DoColorTable3D ( image , uLookTable , uLookTableCoordsFirst , uLookTableCoordsLast ) ;
        }
        image = DoRGBtoMMH ( image ) ;
        if ( uVibrance > 0.0 )
        {
            image = DoIncreaseVibrance ( image , uVibrance ) ;
        }
        else if ( uVibrance < 0.0 )
        {
            image = DoDecreaseVibrance ( image , uVibrance ) ;
        }
        if ( uHasHSL )
        {
            image = DoTuneHSLMasked32 ( image , localLuminanceMask , localContrastMask , localSatMask ) ;
        }
        image = DoMMHtoRGB ( image ) ;
    }
    if ( localBlueYellowMask != 0.0 || localGreenMagentaMask != 0.0 )
    {
        image = DoLocalColorToning ( image , localBlueYellowMask , localGreenMagentaMask ) ;
    }
    if ( uHasPostCropVignetteColorPriority )
    {
        image = DoPostCropVignette ( image , dstPt ) ;
    }
    image = DoToneCurve ( image , kBigTableRow_ToneCurve ) ;
    if ( uHasSplitTone )
    {
        image = DoSplitTone ( image ) ;
    }
    if ( uHasGrain )
    {
        image = DoGrain ( image , dstPt ) ;
    }
    if ( uHasPostCropVignettePaintOverlay )
    {
        image = DoPostCropVignette ( image , dstPt ) ;
    }
    if ( uShowShadowWarning && ( image . r < 0.001 || image . g < 0.001 || image . b < 0.001 ) )
    {
        image = vec3 ( 0.0 , 0.0 , 1.0 ) ;
    }
    else if ( uShowHighlightWarning && ( image . r > 0.999 || image . g > 0.999 || image . b > 0.999 ) )
    {
        image = vec3 ( 1.0 , 0.0 , 0.0 ) ;
    }
    image = DoWarpMask ( image , srcPt ) ;
    image = DoColorConvert ( image ) ;
    outputs . target0 = vec4 ( image , 1.0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . uv0 = uv0 ;
    MainPS ( inputs , outputs ) ;
    target0 = outputs . target0 ;
}
[Material]  name=Shared vs=SharedVS ps=SharedPS
[Material]  name=TestShader vs=TestShaderVS ps=TestShaderPS
[Material] name=DrawQuad vs=DrawQuadVS ps=DrawQuadPS
[Material] name=DrawTexQuad vs=DrawQuadVS ps=DrawTexQuadPS
[Material] name=DrawText vs=DrawQuadVS ps=DrawTextPS
[Material] name=FallbackWorld vs=FallbackWorldVS ps=FallbackPS
[Material] name=FallbackModel vs=FallbackModelVS ps=FallbackPS
[Material] sname=ACRPipe vs=ACRPipeVS ps=ACRPipePS
