/*****************************************************************************/

// Shared vertex shader.

[Source] name=SharedVS

[Param]
    in vec4 position;
    out vec4 positiont;

    uniform mat4  modelToWorldTfm;
    uniform mat4  worldToViewTfm;
    uniform mat4  viewToClipTfm;
    uniform mat4  worldToClipTfm;
    uniform mat4  modelToClipTfm;
    uniform float debugCycles;

    //uniform bool  testB;
    //uniform float testF;
    //uniform int   testI;
    //uniform vec2  packTestV2;
    //uniform float packTestF;
    //uniform mat2  packTestM22;
	//uniform vec2  packTestM22V2;
	//uniform mat3  packTestM33;
	//uniform float packTestM33F;
[Code]
    vec4 pos = inputs.position;

    // keep the vars from being stripped
    pos = mul(pos, modelToWorldTfm);
    pos = mul(pos, worldToViewTfm);
    pos = mul(pos, viewToClipTfm);
    pos = mul(pos, worldToClipTfm);
    pos = mul(pos, modelToClipTfm);

    pos.x *= debugCycles;
    
    /*
    // test code ----------
    // gl and es just don't appear to like casts
    //pos.x *= (float)testB;
    //pos.x *= (float)testI;

    if (testB)
        pos.x *= 2.0;
    pos.x *= testF;

    if (testI > 0)
        pos.x *= 2.0;

    pos.xy *= packTestV2;
    pos.x *= packTestF;
	
    pos.xy = mul(pos.xy, packTestM22);
	pos.xy *= packTestM22V2;
	pos.xyz = mul(pos.xyz, packTestM33);
	pos.x *= packTestM33F;
	*/
    
    // does this need to use vars, so they're not stripped
    outputs.positiont = pos;

/*****************************************************************************/

// Shared pixel shader.

[Source] name=SharedPS

[Param]

    in vec4 positiont; // not used, but needed to prevent empty inputs struct

    out vec4 target0;

[Code]

    outputs.target0 = vec4(0,0,0,0);

/*****************************************************************************/

[Material] name=Shared vs=SharedVS ps=SharedPS

/*****************************************************************************/
