[ShaderDX] name=SharedVS version=1000
#line 2
    #pragma pack_matrix ( row_major )
cbuffer params
{
    float4x4 modelToWorldTfm ;
    float4x4 worldToViewTfm ;
    float4x4 viewToClipTfm ;
    float4x4 worldToClipTfm ;
    float4x4 modelToClipTfm ;
    bool testB ;
    float testF ;
    int testI ;
    float2 packTestV2 ;
    float packTestF ;
    float2x2 packTestM22 ;
    float2 packTestM22V2 ;
    float3x3 packTestM33 ;
    float packTestM33F ;
}
struct Inputs
{
    float4 position : POSITION ;
}
;
struct Outputs
{
    float4 positiont : SV_Position ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    float4 pos = inputs . position ;
    pos = mul ( pos , modelToWorldTfm ) ;
    pos = mul ( pos , worldToViewTfm ) ;
    pos = mul ( pos , viewToClipTfm ) ;
    pos = mul ( pos , worldToClipTfm ) ;
    pos = mul ( pos , modelToClipTfm ) ;
    if ( testB ) pos . x *= 2.0 ;
    pos . x *= testF ;
    if ( testI > 0 ) pos . x *= 2.0 ;
    pos . xy *= packTestV2 ;
    pos . x *= packTestF ;
    pos . xy = mul ( pos . xy , packTestM22 ) ;
    pos . xy *= packTestM22V2 ;
    pos . xyz = mul ( pos . xyz , packTestM33 ) ;
    pos . x *= packTestM33F ;
    outputs . positiont = pos ;
}
[ShaderDX] name=SharedPS version=1000
#line 51
    #pragma pack_matrix ( row_major )
struct Inputs
{
    float4 positiont : SV_Position ;
}
;
struct Outputs
{
    float4 target0 : SV_Target0 ;
}
;
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = float4 ( 0 , 0 , 0 , 0 ) ;
}
[ShaderDX] name=TestShaderVS version=1000
#line 68
    #pragma pack_matrix ( row_major )
cbuffer params
{
    float2 foregroundInverseSize ;
    float2 videoInverseSize ;
}
struct Inputs
{
    float4 position : POSITION ;
    float2 uv0 : TEXCOORD0 ;
    float2 uv1 : TEXCOORD1 ;
}
;
struct Outputs
{
    float4 positiont : SV_Position ;
    float2 uv0 : TEXCOORD0 ;
    float2 uv1 : TEXCOORD1 ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    outputs . uv0 . xy = inputs . uv0 . xy * foregroundInverseSize ;
    outputs . uv1 . xy = inputs . uv1 . xy * videoInverseSize ;
    outputs . positiont = inputs . position ;
}
[ShaderDX] name=TestShaderPS version=1000
#line 96
    #pragma pack_matrix ( row_major )
cbuffer params
{
    float2 foregroundInverseSize ;
    float2 videoInverseSize ;
}
uniform SamplerState colorTextureSampler ;
uniform Texture2D colorTexture ;
uniform SamplerState volumeTextureSampler ;
uniform Texture3D volumeTexture ;
struct Inputs
{
    float4 positiont : SV_Position ;
    float2 uv0 : TEXCOORD0 ;
    float2 uv1 : TEXCOORD1 ;
}
;
struct Outputs
{
    float4 target0 : SV_Target0 ;
}
;
float4 DoFunction1 ( in float4 val )
{
    return val ;
}
void DoFunction2 ( in float4 val , out float4 newval )
{
    newval = val ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = DoFunction1 ( float4 ( inputs . uv0 . xy , 0 , 1 ) ) ;
}
[ShaderDX] name=DrawQuadVS version=1000
#line 132
    #pragma pack_matrix ( row_major )
cbuffer params
{
    float4x4 worldToClipTfm ;
}
struct Inputs
{
    float3 position : POSITION ;
    float2 uv0 : TEXCOORD0 ;
    float4 color : COLOR ;
}
;
struct Outputs
{
    float4 positiont : SV_Position ;
    float2 uv0 : TEXCOORD0 ;
    float4 color : COLOR ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    outputs . uv0 = inputs . uv0 ;
    outputs . color = inputs . color ;
    outputs . positiont = mul ( float4 ( inputs . position , 1.0 ) , worldToClipTfm ) ;
}
[ShaderDX] name=DrawQuadPS version=1000
#line 159
    #pragma pack_matrix ( row_major )
struct Inputs
{
    float4 positiont : SV_Position ;
    float2 uv0 : TEXCOORD0 ;
    float4 color : COLOR ;
}
;
struct Outputs
{
    float4 target0 : SV_Target0 ;
}
;
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = inputs . color ;
}
[ShaderDX] name=DynDrawVDVS version=1000
#line 178
    #pragma pack_matrix ( row_major )
struct Inputs
{
    float3 position : POSITION ;
    float2 uv0 : TEXCOORD0 ;
    float4 color : COLOR ;
}
;
struct Outputs
{
    float4 positiont : SV_Position ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    outputs . positiont = float4 ( inputs . position . xyz , 1.0 ) ;
}
[Material]  name=Shared vs=SharedVS ps=SharedPS
[Material]  name=TestShader vs=TestShaderVS ps=TestShaderPS
[Material]  name=DrawQuad vs=DrawQuadVS ps=DrawQuadPS
