[ShaderES] name=SharedVS version=200
#version 100
precision highp float;
#line 4
uniform mat4 modelToWorldTfm ;
uniform mat4 worldToViewTfm ;
uniform mat4 viewToClipTfm ;
uniform mat4 worldToClipTfm ;
uniform mat4 modelToClipTfm ;
uniform bool testB ;
uniform float testF ;
uniform int testI ;
uniform vec2 packTestV2 ;
uniform float packTestF ;
uniform mat2 packTestM22 ;
uniform vec2 packTestM22V2 ;
uniform mat3 packTestM33 ;
uniform float packTestM33F ;
attribute vec4 position_ ;
struct Inputs
{
    vec4 position ;
}
;
struct Outputs
{
    vec4 positiont ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    vec4 pos = inputs . position ;
    pos = ( ( pos ) * ( modelToWorldTfm ) ) ;
    pos = ( ( pos ) * ( worldToViewTfm ) ) ;
    pos = ( ( pos ) * ( viewToClipTfm ) ) ;
    pos = ( ( pos ) * ( worldToClipTfm ) ) ;
    pos = ( ( pos ) * ( modelToClipTfm ) ) ;
    if ( testB ) pos . x *= 2.0 ;
    pos . x *= testF ;
    if ( testI > 0 ) pos . x *= 2.0 ;
    pos . xy *= packTestV2 ;
    pos . x *= packTestF ;
    pos . xy = ( ( pos . xy ) * ( packTestM22 ) ) ;
    pos . xy *= packTestM22V2 ;
    pos . xyz = ( ( pos . xyz ) * ( packTestM33 ) ) ;
    pos . x *= packTestM33F ;
    outputs . positiont = pos ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
}
[ShaderES] name=SharedPS version=200
#version 100
precision highp float;
#line 60
struct Inputs
{
    vec4 positiont ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = vec4 ( 0 , 0 , 0 , 0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . positiont = gl_FragCoord ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=TestShaderVS version=200
#version 100
precision highp float;
#line 86
uniform vec2 foregroundInverseSize ;
uniform vec2 videoInverseSize ;
attribute vec4 position_ ;
attribute vec2 uv0_ ;
attribute vec2 uv1_ ;
varying vec2 uv0 ;
varying vec2 uv1 ;
struct Inputs
{
    vec4 position ;
    vec2 uv0 ;
    vec2 uv1 ;
}
;
struct Outputs
{
    vec4 positiont ;
    vec2 uv0 ;
    vec2 uv1 ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    outputs . uv0 . xy = inputs . uv0 . xy * foregroundInverseSize ;
    outputs . uv1 . xy = inputs . uv1 . xy * videoInverseSize ;
    outputs . positiont = inputs . position ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    inputs . uv0 = uv0_ ;
    inputs . uv1 = uv1_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
    uv0 = outputs . uv0 ;
    uv1 = outputs . uv1 ;
}
[ShaderES] name=TestShaderPS version=200
#version 100
precision highp float;
#line 129
uniform vec2 foregroundInverseSize ;
uniform vec2 videoInverseSize ;
uniform sampler2D colorTexture ;
uniform sampler2D volumeTexture ;
varying vec2 uv0 ;
varying vec2 uv1 ;
struct Inputs
{
    vec4 positiont ;
    vec2 uv0 ;
    vec2 uv1 ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
vec4 DoFunction1 ( in vec4 val )
{
    return val ;
}
void DoFunction2 ( in vec4 val , out vec4 newval )
{
    newval = val ;
}
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = DoFunction1 ( vec4 ( inputs . uv0 . xy , 0 , 1 ) ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . positiont = gl_FragCoord ;
    inputs . uv0 = uv0 ;
    inputs . uv1 = uv1 ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=DrawQuadVS version=200
#version 100
precision highp float;
#line 173
uniform mat4 worldToClipTfm ;
attribute vec3 position_ ;
attribute vec2 uv0_ ;
attribute vec4 color_ ;
varying vec2 uv0 ;
varying vec4 color ;
struct Inputs
{
    vec3 position ;
    vec2 uv0 ;
    vec4 color ;
}
;
struct Outputs
{
    vec4 positiont ;
    vec2 uv0 ;
    vec4 color ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    outputs . uv0 = inputs . uv0 ;
    outputs . color = inputs . color ;
    outputs . positiont = ( ( vec4 ( inputs . position , 1.0 ) ) * ( worldToClipTfm ) ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    inputs . uv0 = uv0_ ;
    inputs . color = color_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
    uv0 = outputs . uv0 ;
    color = outputs . color ;
}
[ShaderES] name=DrawQuadPS version=200
#version 100
precision highp float;
#line 215
varying vec2 uv0 ;
varying vec4 color ;
struct Inputs
{
    vec4 positiont ;
    vec2 uv0 ;
    vec4 color ;
}
;
struct Outputs
{
    vec4 target0 ;
}
;
void MainPS ( in Inputs inputs , out Outputs outputs )
{
    outputs . target0 = inputs . color ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . positiont = gl_FragCoord ;
    inputs . uv0 = uv0 ;
    inputs . color = color ;
    MainPS ( inputs , outputs ) ;
    gl_FragData [ 0 ] = outputs . target0 ;
}
[ShaderES] name=DynDrawVDVS version=200
#version 100
precision highp float;
#line 247
attribute vec3 position_ ;
attribute vec2 uv0_ ;
attribute vec4 color_ ;
struct Inputs
{
    vec3 position ;
    vec2 uv0 ;
    vec4 color ;
}
;
struct Outputs
{
    vec4 positiont ;
}
;
void MainVS ( in Inputs inputs , out Outputs outputs )
{
    outputs . positiont = vec4 ( inputs . position . xyz , 1.0 ) ;
}
void main ( )
{
    Inputs inputs ;
    Outputs outputs ;
    inputs . position = position_ ;
    inputs . uv0 = uv0_ ;
    inputs . color = color_ ;
    MainVS ( inputs , outputs ) ;
    gl_Position = outputs . positiont ;
}
[Material]  name=Shared vs=SharedVS ps=SharedPS
[Material]  name=TestShader vs=TestShaderVS ps=TestShaderPS
[Material]  name=DrawQuad vs=DrawQuadVS ps=DrawQuadPS
